var Database = flight.component(function () {

  'use strict';

  /**
   * Const
   */

  var dbSchemaName = 'PflegetagebuchDebug';
  var dbSchemaVersion = 1;
  
  /**
   * Module exports
   */

  return database;

  /**
   * Module function
   */

  function database() {

    this.defaultAttrs({

    });
    
    this.handleGetDataFromDate = function(evt, data){
    	
    	if (!data) {
    		var todayHelper = new Date();
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
    			key: 'today'
    		});
    		
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()-1),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
    			key: 'yesterday'
    		});
    		
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()-2),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
    			key: 'yesterday-1'
    		});    		
    	} else {
    		this.handleGetData(evt, data);
    	}
    }
    
    this.handleGetData = function(evt, data){
    	    	
    	var thisComponent = this;
    	
    	var type = (data.type ? data.type : undefined);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
    	
		request.onupgradeneeded = function(evt){
    		var db = this.result;
  	  		if(!db.objectStoreNames.contains('accomplishments')){
  	  			var store = db.createObjectStore('accomplishments', {
  	  				keyPath: 'key',
  	  				autoIncrement: true
  	  			});
  	  		} else {
  	  			var store = evt.currentTarget.transaction.objectStore('accomplishments');
  	  		}
  	  		
  			store.createIndex('id', 'Accomplishment.id', { unique: false });
  			store.createIndex('mmRequestId', 'mmRequestId', { unique: false });
  			store.createIndex('start_time', 'start_time', { unique: false });
    	}
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var items = new Array();
      	  		console.log(data);
      	  		var range = IDBKeyRange.bound(0, new Date().getTime());
      	  		console.log(range);
      	  		var index = store.index('mmRequestId');
      	  		console.log(index);
      	  		var indexRequest = index.openCursor(range);
      	  		console.log(indexRequest);
    			indexRequest.onsuccess = function(event){
    				console.log(event);
    				
    				var cursor = event.target.result;
    				if (cursor) {
    					console.log(cursor);
    					items.push(cursor.value);
    					cursor["continue"]();
    				} else {
    					console.log(items);
    					$('#edit').trigger('dataAccomplishmentsFromDateRetrieved', {items:items, key: data.key, type: type});
    				}
    			}
    			indexRequest.onerror = function(event){
    				console.log(event);
    				/*
    				var cursor = event.target.result;
    				if (cursor) {
    					items.push(cursor.value);
    					cursor.continue();
    				} else {
    					$('#edit').trigger('dataAccomplishmentsFromDateRetrieved', {items:items, key: data.key, type: type});
    				}*/
    			}
  	  		}
  		}
    	request.onerror = function(evt){
    		console.log('error');
    		console.log(evt);
    	}
    	
    }
    
    this.handleGetWeekDataFromDate = function(evt, data){
    	
    }
    
    this.handleGetWeekData = function(evt, data){
    		
    }
    
    this.handleDataAddRecord = function(evt, data){
    	var thisComponent = this;
    	data.data.Accomplishment.id = '';
    	data.data.mmRequestId = data.mmRequestId;
    	data.data.start_time = new Date(data.data.Accomplishment.start_time);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
  	  	
    	request.onupgradeneeded = function(){
    		
    		var db = this.result;
  	  		if(!db.objectStoreNames.contains('accomplishments')){
  	  			var store = db.createObjectStore('accomplishments', {
  	  				keyPath: 'key',
  	  				autoIncrement: true
  	  			});
  	  		} else {
  	  			var store = event.currentTarget.transaction.objectStore('accomplishments');
  	  		}
  	  		
  			store.createIndex('id', 'Accomplishment.id', { unique: false });
  			store.createIndex('mmRequestId', 'mmRequestId', { unique: false });
  			store.createIndex('start_time', 'start_time', { unique: false });
    	}
    	
    	request.onsuccess = function(){
  	  		var db = this.result;
  	  		var trans = db.transaction(['accomplishments'], 'readwrite');
  	  		var store = trans.objectStore('accomplishments');

  	  		var request = store.put(data.data); 
  	  		request.onsuccess = function(evt){
  	  			localStorage.setItem('localData', true);
  	  		}
  		}
    };

    this.handleGetSingleRecord = function(evt, data){

    };
    
    this.handleDataEditRecord = function(evt, data){

    }
    
    this.after('initialize', function () {

  	  	this.on('dataSaveRecord', this.handleDataAddRecord);
  	  	this.on('dataGetDataFromDate', this.handleGetDataFromDate);
  	  	this.on('dataGetSingleRecord', this.handleGetSingleRecord);
  	  	this.on('dataGetWeekDataFromDate', this.handleGetWeekDataFromDate);
  	  	this.on('dataEditRecord', this.handleDataEditRecord);
  	  	
    });
    
  }

}());