var Database = flight.component(function () {

  'use strict';

  /**
   * Const
   */

  var dbSchemaName = 'pflegeBeta';
  var dbSchemaVersion = 1;
  
  /**
   * Module exports
   */

  function upgradeNeededHandler(evt){
	console.log('upgradenneeded');
  	var db = evt.target.result;
	if(!db.objectStoreNames.contains('accomplishments')){
		var store = db.createObjectStore('accomplishments', {
			keyPath: 'mmRequestId'
		});
	} else {
		var store = event.currentTarget.transaction.objectStore('accomplishments');
	}
	
	store.createIndex('id', 'Accomplishment.id', { unique: false });
	store.createIndex('mmRequestId', 'mmRequestId', { unique: false });
	store.createIndex('start_time', 'start_time', { unique: false });
	
	$(document).trigger('dataDoGetRequest', {
		url: 'accomplishments/index.json',
		headers: 'true',
		mmRequestId: 'dataGetAllRecords', 
		selector: document,
	    success: 'dataGetAllRecordsSuccess',
	    error: 'dataGetAllRecordsFailed'
	});
  }
  
  return database;


  function database() {

    this.defaultAttrs({

    });
    
    this.handleGetDataFromDate = function(evt, data){
    	if (!data) {
    		var todayHelper = new Date();
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
    			key: 'today'
    		});
    		
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
    			key: 'yesterday'
    		});
    		
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 2),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
    			key: 'yesterday-1'
    		});
    		this.handleGetData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
    			key: 'today-1'
    		});
    	} else {
    		this.handleGetData(evt, data);
    	}
    };
    
    this.handleGetDataWithoutID = function(evt, data){
    	var thisComponent = this;
    	
    	//var type = (data.type ? data.type : undefined);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

		request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
    		
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var items = [];
      	  		var range = IDBKeyRange.bound('', '');
      	  		var index = store.index('id');
    			var indexRequest = index.openCursor(range);
    			indexRequest.onsuccess = function(evt){
    				var cursor = evt.target.result;
    				if (cursor) {
    					items.push(cursor.value);
    					cursor["continue"]();
    				} else {
    					thisComponent.trigger('dataAccomplishmentsWithoutIDRetrieved', {items:items});
    				}
    			};
  	  		}
  		};
    	request.onerror = function(evt){
    		console.log('error');
    		console.log(evt);
    	};
    };
    
    this.handleGetData = function(evt, data){
    	
    	var thisComponent = this;
    	
    	var type = (data.type ? data.type : undefined);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

		request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
    		
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var items = [];
      	  		var range = IDBKeyRange.bound(data.start, data.end);
      	  		var index = store.index('start_time');
    			var indexRequest = index.openCursor(range);
    			indexRequest.onsuccess = function(evt){
    				var cursor = evt.target.result;
    				if (cursor) {
    					items.push(cursor.value);
    					cursor["continue"]();
    				} else {
    					$('#edit').trigger('dataAccomplishmentsFromDateRetrieved', {items:items, key: data.key, type: type, dateHelper: data.start});
    				}
    			};
  	  		}
  		};
    	request.onerror = function(evt){
    		console.log('error');
    		console.log(evt);
    	};
    	
    };
    
    this.handleGetWeekDataFromDate = function(evt, data){
    	console.log(data);
    	if (!data) {
    		var todayHelper = new Date();
    		this.handleGetWeekData(evt, {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - todayHelper.getDay() + 1),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - todayHelper.getDay() + 8),
    			key: 'week'
    		});
    		    		
    	} else {
    		this.handleGetWeekData(evt, data);
    	}
    };
    
    this.handleGetWeekData = function(evt, data){
    	var thisComponent = this;
    	console.log(data);
    	var type = (data.type ? data.type : undefined);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
    
		request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var items = [];
      	  		var range = IDBKeyRange.bound(data.start, data.end);
      	  		
      	  		var index = store.index('start_time');
    			var indexRequest = index.openCursor(range);
    			indexRequest.onsuccess = function(evt){
    				
    				var cursor = evt.target.result;
    				if (cursor) {
    					items.push(cursor.value);
    					cursor["continue"]();
    				} else {
    					if (data.key === 'week' || data.fromDatePicker === true){
    						$('#export').trigger('dataAccomplishmentsFromWeekRetrieved', {items:items, key: data.key, type: type, week_start_date : data.start});
    					} else {
    						$('#pflegestufe').trigger('dataAccomplishmentsFromWeekForAssessmentRetrieved', {items:items, key: data.key, type: type});
    					}
    				}
    			};
  	  		}
  		};
    	request.onerror = function(evt){
    		console.log('error');
    		console.log(evt);
    	};
    	
    	return request;
    	
    };
    
    this.handleDataAddRecord = function(evt, data){
    	var thisComponent = this;
    	
    	if (!data.data.Accomplishment.id){
    		data.data.Accomplishment.id = '';
    	}
    	
    	data.data.mmRequestId = parseInt(data.mmRequestId);
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
  	  	
    	request.onupgradeneeded = function(event){
    		upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		var trans = db.transaction(['accomplishments'], 'readwrite');
  	  		var store = trans.objectStore('accomplishments');
  	  		var request = store.put(data.data); 
  	  		request.onsuccess = function(evt){
  	  			localStorage.setItem('localData', true);
  	  			$('#edit').trigger('dataAccomplishmentCreated', {items: data.data, type: 'new'});
  	  		};
  		};
    };

    this.handleGetSingleRecord = function(evt, data){
    	var thisComponent = this;
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

    	request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var indexRequest = store.get(parseInt(data.key));
      	  		
      	  		indexRequest.onsuccess = function(evt) {
	      	  		
					if (evt.target.result) {
						$('#editing').trigger('dataGetSingleRecordCompleted', evt.target.result);
					}
      	  			
      	  		};
  	  		}
  	  	};
    	
    };
    
    this.handleGetSingleRecordForEdit = function(evt, data){
    	var thisComponent = this;
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

    	request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var indexRequest = store.get(data.key);
      	  		
      	  		indexRequest.onsuccess = function(evt) {
	      	  		
					if (evt.target.result) {
						$(document).trigger('dataGetSingleRecordForEditCompleted', evt.target.result);
					}
      	  			
      	  		};
  	  		}
  	  };
    	
    };
    
    this.handleDataEditRecord = function(evt, data){
    	
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

    	request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  	
      	  		var putRequest = store.put(data.data); 
      	  			
      	  		putRequest.onsuccess = function(evt) {
      	  			$('#edit').trigger('dataAccomplishmentUpdated', {items: data.data, type: 'update'});
      	  		};
  	  		}
  	  	};	
    };
    
    this.handleSyncRecord = function(evt, data){
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
  	  	
    	request.onupgradeneeded = function(event){
    		upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		var trans = db.transaction(['accomplishments'], 'readwrite');
  	  		var store = trans.objectStore('accomplishments');
  	  		var request = store.put(data); 
  	  		request.onsuccess = function(evt){
  	  			$(document).trigger('dataSyncRecordSucces');
  	  			// trigger update and #export
  	  		};
  		};
    };
    
    this.handleDeleteRange = function(evt, data){
    	console.log(data);
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion),
    		thisComponent = this;

		request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
    		
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  		
      	  		var items = [];
      	  		var range = IDBKeyRange.bound(new Date(data.start), new Date(data.end));
      	  		var index = store.index('start_time');
    			var indexRequest = index.openCursor(range);
    			indexRequest.onsuccess = function(evt){
    				var cursor = evt.target.result;
    				if (cursor) {
    					thisComponent.handleDataDeleteForSync('default', {key:cursor.value.mmRequestId});
    					cursor["continue"]();
    				}
    			};
  	  		};
  		};
    	request.onerror = function(evt){
    		console.log('error');
    		console.log(evt);
    	};
    };
    
    this.handleDataDeleteForSync = function(evt, data){

    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

    	request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  	
      	  		var deleteRequest = store["delete"](data.key); 
      	  			
      	  		deleteRequest.onsuccess = function(evt) {
      	  		};
  	  		}
  	  };
    };
    
    
    this.handleDataDeleteRecord = function(evt, data){
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);

    	request.onupgradeneeded = function(event){
			upgradeNeededHandler(event);
    	};
    	
    	request.onsuccess = function(evt){
  	  		var db = evt.target.result;
  	  		if(db.objectStoreNames.contains('accomplishments')){
      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
      	  		var store = trans.objectStore('accomplishments');
      	  	
      	  		var deleteRequest = store["delete"](data.key); 
      	  			
      	  		deleteRequest.onsuccess = function(evt) {
      	  			$('#edit').trigger('dataAccomplishmentDeleted', {key: data.key});
      	  		};
  	  		}
  	  };
    };
    
    this.handleGetAllRecordsSuccess = function(evt, data){
    	$('#edit .spinner-overlay').show();
    	var thisComponent = this;
    	thisComponent.dataHelper = 0;
    	for (var i = 0; i<data.accomplishments.length; i++){
        	
    		(function(){
	    		var mmRequestIdHelper = new Date();
	    		
	        	data.accomplishments[i].mmRequestId = parseInt(mmRequestIdHelper.getTime())-data.accomplishments.length + i;
	        	data.accomplishments[i].id = data.accomplishments[i].Accomplishment.id;
	        	data.accomplishments[i].created = data.accomplishments[i].Accomplishment.created;
	        	data.accomplishments[i].modified = data.accomplishments[i].Accomplishment.modified;
	        	data.accomplishments[i].start_time = new Date(data.accomplishments[i].Accomplishment.start_time);
	        	
	        	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
	      	  	
	        	request.onupgradeneeded = function(event){
	        		upgradeNeededHandler(event);
	        	};
	        	
	        	var newRecord = data.accomplishments[i];
	        	
	        	request.onsuccess = function(evt){
	        		var db = evt.target.result;
	      	  		var trans = db.transaction(['accomplishments'], 'readwrite');
	      	  		var store = trans.objectStore('accomplishments');
	      	  		var request = store.put(newRecord); 
	      	  		request.onsuccess = function(evt){
	      	  			
	      	  			thisComponent.dataHelper++;
	      	  			
	      	  			if (i === thisComponent.dataHelper){
	      	  				$('#edit').trigger('afterAfterInitialize');
	      	  			}
	      	  			//$('#edit').trigger('dataAccomplishmentCreated', {items: data.data, type: 'new'});
	      	  		};
	      		};
	    		localStorage.setItem('localData', true);
    		}());
    	}
    	
    	if (data.accomplishments.length === 0 ){
    		$('#edit .spinner-overlay').hide();
    	}
    	
    };
    
    this.handleClearAccomplishments = function(){
    	var request = indexedDB.open(dbSchemaName, dbSchemaVersion);
  	  	
    	request.onupgradeneeded = function(evt){
    		upgradeNeededHandler(evt);
    	};
    	
    	request.onsuccess = function(evt){
    		var db = evt.target.result;
  	  		var trans = db.transaction(['accomplishments'], 'readwrite');
  	  		var store = trans.objectStore('accomplishments');
  	  		var request = store.clear(); 
  	  		request.onsuccess = function(evt){
  	  		 console.log(store);
          };
          request.onerror = function(evt){
            console.log('error');
            console.log(evt);
          };
  		};
    };
    
    this.after('initialize', function () {
    	this.on('dataAddRecord', this.handleDataAddRecord);
  	  	this.on('dataEditRecord', this.handleDataEditRecord);
  	  	this.on('dataGetDataFromDate', this.handleGetDataFromDate);
  	  	this.on('dataGetDataWithoutID', this.handleGetDataWithoutID);
  	  	this.on('dataGetSingleRecord', this.handleGetSingleRecord);
  	  	this.on('dataGetSingleRecordForEdit', this.handleGetSingleRecordForEdit);
  	  	this.on('dataGetWeekDataFromDate', this.handleGetWeekDataFromDate);
  	  	this.on('dataDeleteRecord', this.handleDataDeleteRecord);
  	  	this.on('dataGetAllRecordsSuccess', this.handleGetAllRecordsSuccess);
  	  	this.on('dataClearAccomplishments', this.handleClearAccomplishments);
  	  	this.on('dataAddRecordFromServer', this.handleSyncRecord);
  	  	this.on('dataDeleteRangeForSync', this.handleDeleteRange);
    });
    
  }

}());