var HandleData = flight.component(function () {

  'use strict';

  var syncCounter = 0;


  /**
   * Module exports
   */

  return handleData;

  /**
   * Module function
   */

  function handleData() {
    this.defaultAttrs({

    });

    this.handleUiPostData = function(evt, data){

    	var timeHelper = new Date();

    	data.postData.id = '';
    	data.postData.modified = utils.getServerDateObject(timeHelper);
    	data.postData.created = utils.getServerDateObject(timeHelper);
    	data.postData.start_time = new Date(data.postData.Accomplishment.start_time);

    	$(document).trigger('dataAddRecord', {
    		mmRequestId : timeHelper.getTime(),
    		data: data.postData
    	});
    	//if (navigator.network.connection.type === 'none' || navigator.network.connection.type === 'unknown'){
    		$(document).trigger('dataDoPostRequest', {
    			url: data.url,
    			headers: true,
    			mmRequestId: timeHelper.getTime(),
    			selector: document,
    		    success: 'dataPostSuccess',
    		    error: 'dataPostFailed',
    		    data: JSON.stringify(data.postData)
    		});
		//}
    }

    this.handleUiPutData = function(evt, data){
    	var timeHelper = new Date();
    	data.putData.modified = utils.getServerDateObject(timeHelper);
    	$(document).trigger('dataEditRecord', {
    		key : data.mmRequestId,
    		data: data.putData
    	});

    	$(document).trigger('dataDoPutRequest', {
			url: data.url,
			headers: true,
			mmRequestId: timeHelper.getTime(),
			selector: document,
		    success: 'dataPutSuccess',
		    error: 'dataPutFailed',
		    data: JSON.stringify(data.putData)
		});
    }

    this.handleDataPostSuccess = function(evt, data){

		this['a' + data._metadata.request_id] = data;
    	$(document).trigger('dataGetSingleRecordForEdit', {
    		key: parseInt(data._metadata.request_id)
    	});
    	$('#a' + data._metadata.request_id).attr('data-server-id', data['Accomplishment']['id']);

    	this.showSuccessFeedback('Verrichtung wurde gespeichert.');
      // $('#edit').trigger('dataSetChangeUpdateSwiper')
    }

    this.handleDataPutSuccess = function(evt, data){
    	if (data.Accomplishment){
    		this['a' + data._metadata.request_id] = data;
        	$(document).trigger('dataGetSingleRecordForEdit', {
        		key: parseInt(data._metadata.request_id)
        	});
        	$('#a' + data._metadata.request_id).attr('data-server-id', data['Accomplishment']['id']);
    	}
    	this.showSuccessFeedback('Änderung wurde gespeichert.')
    	$(document).trigger('dataGetDataWithoutID');
      // $('#edit').trigger('dataSetChangeUpdateSwiper')
    }

    this.handleDataPutFailed = function(evt, data){
    	if (data.status === 400){
    		if (data._metadata['error-code'] === 3101){

    			$('#special-controls .popup-update-data-version-needed').show();
    	        $('#special-controls .overlay').show();
    	        // data version check
    	        return;
    		}
    	}

    	$('#special-controls .popup-no-internet').show();
        $('#special-controls .overlay').show();

    }

    this.handleSingleRecordForEdit = function(evt, data){
    	data.Accomplishment.id=this['a' + data.mmRequestId]['Accomplishment']['id'];
    	data.id=this['a' + data.mmRequestId]['Accomplishment']['id'];
    	$(document).trigger('dataEditRecord', {data:data});
    }

    this.handleAccomplishmentsWithoutID = function(evt, data){
    	for (var i = 0; i<data.items.length; i++){
    		$(document).trigger('dataDoPostRequest', {
    			url: 'accomplishments/add.json',
    			headers: true,
    			mmRequestId: data.items[i].mmRequestId,
    			selector: document,
    		    success: 'dataPostSuccess',
    		    error: 'dataPostFailed',
    		    data: JSON.stringify({Accomplishment:data.items[i].Accomplishment})
    		});
    	}
    }

    this.showSuccessFeedback = function(message){
    	$('#data-saved-helper').html(message).css('bottom', '0px');
    	setTimeout(function(){
    		$('#data-saved-helper').css('bottom', '-50px');
    	},1000);
    }

    this.handleDataDeleteAccomplishmentSuccess = function(evt, data){
    	this.showSuccessFeedback('Verrichtung wurde gelöscht.');
    	$(document).trigger('dataDeleteRecord', {
			key: parseInt(data._metadata.request_id.split('-')[1])
		});
    }

    this.handleDataDeleteAccomplishmentFailed = function(evt, data){

    }

    this.handleSyncSuccess = function(evt, data){
    	syncCounter = data.accomplishments.length;
    	for (var i = 0; i < data.accomplishments.length; i++){
    		$(document).trigger('dataAddRecordFromServer',{
    			Accomplishment:data.accomplishments[i].Accomplishment,
    			created: data.accomplishments[i].Accomplishment.created,
    		    id: data.accomplishments[i].Accomplishment.id,
    		    mmRequestId: Math.round(new Date().getTime() * Math.random()),
    		    modified: data.accomplishments[i].Accomplishment.modified,
    		    start_time: new Date (data.accomplishments[i].Accomplishment.start_time)
    		});
    	}
    }

    this.handleSyncCompleted = function(evt, data){
    	syncCounter--;
    	if (syncCounter === 0){
    		$('#edit').trigger('uiInitDataAfterSync');
    		$('#export').trigger('uiChangeModuleTo');
    	}
    }

    this.after('initialize', function () {
    	this.on(document, 'dataHandlePostData', this.handleUiPostData);
    	this.on(document, 'dataHandlePutData', this.handleUiPutData);
    	this.on('dataGetSingleRecordForEditCompleted', this.handleSingleRecordForEdit);
    	this.on('dataPostSuccess', this.handleDataPostSuccess);
    	this.on('dataPutSuccess', this.handleDataPutSuccess)
    	this.on('dataPutFailed', this.handleDataPutFailed)
    	this.on('dataAccomplishmentsWithoutIDRetrieved', this.handleAccomplishmentsWithoutID);
    	this.on('dataDeleteAccomplishmentSuccess', this.handleDataDeleteAccomplishmentSuccess);
    	this.on('dataSyncSuccess', this.handleSyncSuccess);
    	this.on('dataSyncRecordSucces', this.handleSyncCompleted)

    });
  }

}());
