var Settings = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return settings;

  /**
   * Module function
   */

  function settings() {
    this.defaultAttrs({

    });

    this.hasRequestErrored = function(response){
      if(!response){
        return true;
      }
      var metadata = response._metadata;
      if(!metadata){
        return true;
      }
      return (metadata.status !== "OK");
    }

    this.getErrorCode = function(response){
      if(response){
        if(response._metadata){
          return response._metadata['error-code'];
        }else{
          return response.status;
        }
      }
    }

    this.handleDataCheckDataVersion = function(){
    	$(document).trigger('dataDoGetRequest', {
			url: 'status/data_version.json',
			headers: 'true',
			mmRequestId: 'dataVersion',
			selector: document,
		    success: 'dataHandleCheckDataVersionResponse',
		    error: 'dataHandleCheckDataVersionResponse'
		});
    }

    this.dataHandleCheckDataVersionResponse = function(evt, data){
      var hasErrored = this.hasRequestErrored(data);
      if(hasErrored){
        var errorCode = this.getErrorCode(data)
        if(errorCode){
          switch(errorCode){
            case 403:
            $('#account').trigger('handleLogout', true);
            return;
            //handle Error;
            default:
          }
        }
      }


    	if (!hasErrored && (!localStorage.getItem('dataVersion') || parseInt(localStorage.getItem('dataVersion')) !== data.Status.data_version)){

    		localStorage.setItem('dataVersion', data.Status.data_version);

    		this.dataResponses = 0;
    		$(document).trigger('dataDoGetRequest', {
    			url: 'accomplishment_categories/index.json',
    			headers: 'true',
    			mmRequestId: 'dataGetAccomplishments',
    			selector: document,
    		    success: 'dataHandleGetAccomplishmentsResponse',
    		    error: 'dataHandleGetAccomplishmentsResponse'
    		});
    		$(document).trigger('dataDoGetRequest', {
    			url: 'accomplishment_types/index_list.json',
    			headers: 'true',
    			mmRequestId: 'dataGetTypesIndex',
    			selector: document,
    		    success: 'dataHandleGetTypesIndexResponse',
    		    error: 'dataHandleGetTypesIndexResponse'
    		});
    		$(document).trigger('dataDoGetRequest', {
    			url: 'accomplishment_subcategories/index_list.json',
    			headers: 'true',
    			mmRequestId: 'dataGetSubcategoriesIndex',
    			selector: document,
    		    success: 'dataHandleGetSubcategoriesIndexResponse',
    		    error: 'dataHandleGetSubcategoriesIndexResponse'
    		});
    		$(document).trigger('dataDoGetRequest', {
    			url: 'help_chapters/index.json',
    			headers: 'true',
    			mmRequestId: 'dataGetHelpFull',
    			selector: '#help',
    		    success: 'dataHandleGetHelpFullSuccess',
    		    error: 'dataHandleGetHelpFullFailed'
    		});
        	$(document).trigger('dataDoGetRequest', {
    			url: 'help_articles/index_list.json',
    			headers: 'true',
    			mmRequestId: 'dataGetHelpFull',
    			selector: '#help',
    		    success: 'dataHandleGetArticlesListSuccess',
    		    error: 'dataHandleGetArticlesListFailed'
    		});

        	localStorage.setItem('newDataVersion', true);

    	} else {
    		localStorage.removeItem('newDataVersion');
    		$('#help').trigger('dataHandleGetHelpFullFailed');
    	}
    }

    this.handleGetAccomplishmentsResponse = function(evt, data){
    	localStorage.setItem('accTypes', JSON.stringify(data));
    	accTypes = data;
    	if (this.dataResponses === 3){
    	} else {
    		this.dataResponses++;
    	}

    };
	this.handleGetTypesIndexResponse = function(evt, data){
		localStorage.setItem('typesIndex', JSON.stringify(data));
		typesIndex = data;
		if (this.dataResponses === 3){
    	} else {
    		this.dataResponses++;
    	}
	};
	this.handleGetSubcategoriesIndexResponse = function(evt, data){
		localStorage.setItem('subcategoriesIndex', JSON.stringify(data));
		subcategoriesIndex = data;
		if (this.dataResponses === 3){
    	} else {
    		this.dataResponses++;
    	}
	};

	this.handleDataRestartApp = function(){
		navigator.splashscreen.show();
		localStorage.removeItem('newDataVersion');
		location.reload();
	}

    this.after('initialize', function () {
    	var thisComponent = this;

    	this.on('dataCheckDataVersion', this.handleDataCheckDataVersion);
    	this.on('dataRestartApp', this.handleDataRestartApp);
    	this.on('dataHandleCheckDataVersionResponse', this.dataHandleCheckDataVersionResponse);

    	this.on('dataHandleGetAccomplishmentsResponse', this.handleGetAccomplishmentsResponse);
    	this.on('dataHandleGetTypesIndexResponse', this.handleGetTypesIndexResponse);
    	this.on('dataHandleGetSubcategoriesIndexResponse', this.handleGetSubcategoriesIndexResponse);

    	$(document).unbind('resume').bind('resume', function(){
    		$(document).trigger('dataCheckDataVersion');
    	});

    	$('#special-controls .popup-update-data-version-needed footer .btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.unbind('touchend');
    			$this.removeClass('active');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			if ($this.attr('data-option') === 'yes'){
    				thisComponent.handleDataRestartApp();
    			} else {
    				localStorage.removeItem('newDataVersion');
    				setTimeout(function(){
    					localStorage.setItem('newDataVersion', true);
    				}, 300000);
    			}

    			$this.parent().parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});

    	$('#special-controls .popup-update-data-version footer .btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.unbind('touchend');
    			$this.removeClass('active');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			if ($this.attr('data-option') === 'yes'){
    				thisComponent.handleDataRestartApp();
    			} else {
    				localStorage.removeItem('newDataVersion');
    				setTimeout(function(){
    					localStorage.setItem('newDataVersion', true);
    				}, 300000);
    				if ($this.parent().parent().parent().hide().hasClass('help')){
    					$('#extra-flyout .help').trigger('touchstart').trigger('touchend');
    				}
    			}

    			$this.parent().parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});
    });
  }

}());
