var Account = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return account;

  /**
   * Module function
   */

  function account() {
    this.defaultAttrs({

    });

    this.logout = function(evt, data){
      $(document).trigger('dataGetDataWithoutID');

      $(document).trigger('dataDoGetRequest', {
        url: 'users/logout.json',
        headers: 'true',
        mmRequestId: 'dataUserLogout',
        selector: '#account',
          success: 'dataUserLogoutSuccess',
          error: 'dataUserLogoutFailed'
      });

      localStorage.removeItem('privateToken');
      $('#settings').hide();
      $('#login').show();
      if(data){
        $('#login .notice').show();
      }      

      $(document).trigger('dataClearAccomplishments');
      $('#signUp input').val('');
      localStorage.removeItem('exportBody');
      this.initProfileData();
      $('#edit').trigger('uiLogout');
            $('#profile').trigger('uiLogout');
      $(document).trigger('uiResetHistory');
    }

    this.initProfileData = function(evt, data){
    	if (!localStorage.getItem('exportBody')){
  		  localStorage.setItem('exportBody', JSON.stringify({
			 "CaredPerson": {
		        "name":"",
		        "firstname":"",
		        "birthdate":"",
		        "street":"",
		        "city":""
		    },
		    "CaringPerson": {
		        "name":"",
		        "firstname":""
		    },
			"LifeConstraint": {
		        "answer_q01": -1,
		        "answer_q02": -1,
		        "answer_q03": -1,
		        "answer_q04": -1,
		        "answer_q05": -1,
		        "answer_q06": -1,
		        "answer_q07": -1,
		        "answer_q08": -1,
		        "answer_q09": -1,
		        "answer_q10": -1,
		        "answer_q11": -1,
		        "answer_q12": -1,
		        "answer_q13": -1,
		        "constraint_level":-1
		    }
   		}));
  	  }
    }

    this.doChangeModule = function(evt, data){
    	$('.module.container-fluid').hide();
    	$('#settings').show().find('.main').hide();
    	var userDataHelper = JSON.parse(localStorage.getItem('userData'));
    	this.$node.find('h2').text(userDataHelper.user.User.email);
    	this.$node.show();
    	$('.subcategories-wrapper').hide();
		$('#capturing').attr('class', '').hide();
		$('#capture .category-overview').show();
		$('#capturing .capture-property').trigger('uiReset', {key: 'capture'}).removeClass('active activated');
    	$('.subcategory .type-wrapper').height(0);

		$('#editing').attr('class', '').hide();
		$('#diary').show();
		$('#editing .capture-property').trigger('uiReset', {key: 'edit'}).removeClass('active activated');
    }

    this.showSecurityPopup = function(){
    	var userDataHelper = JSON.parse(localStorage.getItem('userData'));

    	$('#special-controls .overlay').show();

    	$('#special-controls .popup-delete-account').show()
    		.find('.btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$('#special-controls .overlay').hide();
		    	$('#special-controls .popup-delete-account').hide();
    			if ($this.attr('data-option') === 'yes'){

        			$('#settings').hide();
        			$('#login').show();
        			$(document).trigger('dataClearAccomplishments');
        			$('#edit').trigger('uiLogout');
        			$(document).trigger('uiResetHistory');
        			$(document).trigger('dataDoDeleteRequest', {
        				url: 'users/delete/' + userDataHelper.user.User.id + '.json',
        				headers: 'true',
        				mmRequestId: 'dataDeleteAccount',
        				selector: '#account',
        			    success: 'dataHandleDeleteAccount',
        			    error: 'dataHandleDeleteAccount',
        			    data: JSON.stringify('')
        			});
        			localStorage.removeItem('privateToken');
        			localStorage.removeItem('userData');

        			$(document).trigger('dataClearAccomplishments');
        			$('#login input').val('');
        			$('#signUp input').val('');
        			localStorage.removeItem('lastLoginEmail');
        			localStorage.removeItem('exportBody');
        			thisComponent.initProfileData();
    			}
    		});
    	});
    }

    this.showChangePassword = function(){

    	var thisComponent = this;

    	this.$node.parent().find('#change-password').show().find('header .ui-icon.back-btn').show().parent().bind('touchend', function(){
    		thisComponent.$node.show();
    		$(this).parent().hide();
    	});
    	this.$node.hide();
    	this.$node.parent().find('#change-password .btn.save').unbind('touchstart').bind('touchstart', function(){

    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			var passwort1 = thisComponent.$node.parent().find('input[name="newpassword"]').val();
    			var passwort2 = thisComponent.$node.parent().find('input[name="newpasswordrepeat"]').val();

    			var credentialsFlag = false;

    			if (passwort1 !== passwort2 || passwort1 === ''){
    				thisComponent.$node.parent().find('.error-not-same').show();

    				credentialsFlag = true;
    	    		$('#change-password input[name="newpassword"]').val('');
    	    		$('#change-password input[name="newpasswordrepeat"]').val('');

    			}
    			/*
    			if (navigator.network.connection.type === 'none' || navigator.network.connection.type === 'unknown'){
    				thisComponent.$node.find('.error-connection').show();
    				credentialsFlag = true;
    			}
    			*/
    			if (!credentialsFlag){
	    	    	$(document).trigger('dataDoPutRequest', {
	    				url: 'users/change_password.json',
	    				headers: true,
	    				mmRequestId: 'changepasswort',
	    				selector: '#account',
	    			    success: 'changePasswordSuccess',
	    			    error: 'changePasswordFailed',
	    			    data: JSON.stringify({
	    			    	User: {
	    			    		password: thisComponent.$node.parent().find('input[name="oldpassword"]').val(),
	    			    		'new_password': thisComponent.$node.parent().find('input[name="newpassword"]').val()
	    	    		}})
	    			});
    			}
    		});
    	});
    	setTimeout(function(){
    		$('#change-password').find('input').first().focus();
    	}, 500);
    }

    this.handleChangePasswordSuccess = function(evt, data){
    	$('#change-password input').val('');

    	$('#data-saved-helper').html('Passwortänderung erfolgreich.').css('bottom', '0px');
    	setTimeout(function(){
    		$('#data-saved-helper').css('bottom', '-50px');
    	},1000);

    }

    this.handleChangePasswordFailed = function(evt, data){
    	if (data.status === 0){
    		this.$node.find('.error').hide();
    	} else {
    		if (data._metadata['error-code'] === 2201){
    			$('#change-password .error-not-same').hide();
	    		if (data._metadata['error-message'] !== ''){
	    			$('#change-password .error-not-good').text('Passwort ungültig (' + data._metadata['error-message'] + ')');
	    		}
	    		$('#change-password .error-not-good').show();
	    		$('#change-password input[name="newpassword"]').val('');
	    		$('#change-password input[name="newpasswordrepeat"]').val('');
	    	}
    		if (data._metadata['error-code'] == 1002){
    			$('#change-password input[name="oldpassword"]').val('');
    			$('#change-password .error-not-same').hide();
    			$('#change-password .error-not-good').text('Altes Passwort ungültig.').show();
	    	}
    	}
    }

    this.after('initialize', function () {

    	this.on('uiDoChangeModule', this.doChangeModule);
    	this.on('changePasswordSuccess', this.handleChangePasswordSuccess);
    	this.on('changePasswordFailed', this.handleChangePasswordFailed);
    	this.on('needProfileDataInit', this.initProfileData);
      this.on('handleLogout', this.logout);
    	this.initProfileData();

    	var thisComponent = this;

    	this.$node.find('.btn.logout').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

          thisComponent.logout();
    			// $(document).trigger('dataGetDataWithoutID');
    			//
    		  //   $(document).trigger('dataDoGetRequest', {
    			// 	url: 'users/logout.json',
    			// 	headers: 'true',
    			// 	mmRequestId: 'dataUserLogout',
    			// 	selector: '#account',
    			//     success: 'dataUserLogoutSuccess',
    			//     error: 'dataUserLogoutFailed'
    			// });
    			//
    			// localStorage.removeItem('privateToken');
    			// $('#settings').hide();
    			// $('#login').show();
    			//
    			// $(document).trigger('dataClearAccomplishments');
    			// $('#signUp input').val('');
    			// localStorage.removeItem('exportBody');
    			// thisComponent.initProfileData();
    			// $('#edit').trigger('uiLogout');
          //       $('#profile').trigger('uiLogout');
    			// $(document).trigger('uiResetHistory');
    		});
		});

    	this.$node.find('.btn.change-password').bind('untouchstart').bind('touchstart', function(evt){
    		evt.stopPropagation();
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.showChangePassword();
    		});
		});

    	this.$node.find('.btn.delete-account').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.showSecurityPopup();
    		});
		});

    	$('#extra-flyout .account').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.bind('touchend', function(){
    			thisComponent.doChangeModule();
    			$('#extra-flyout').css('right', '-80%');
    			$('#special-controls .overlay-light').hide();
    			$this.removeClass('active');
    		});
    	});

    });

  }

}());
