var AssistanceType = flight.component(function () {

  'use strict';

  /**
   * Const
   */

  var assistanceTypes = {ASSISTANCE_TYPE_PARTIAL_ADOPTION:'Teilweise Übernahme', ASSISTANCE_TYPE_COMPLETE_ADOPTION:'Vollständige Übernahme', ASSISTANCE_TYPE_GUIDANCE:'Anleitung', ASSISTANCE_TYPE_ATTENDANCE:'Beaufsichtigung', ASSISTANCE_TYPE_SUPPORT:'Unterstützung'};

  /**
   * Module exports
   */

  return assistanceType;

  /**
   * Module function
   */

  function assistanceType() {
    this.defaultAttrs({

    });

    this.handleInitAssistanceType = function(evt, data){
    	if (!document.getElementById('sw-wrapper')){

    		var parentHelper = this.$node.parent().attr('id');

    		if (this.$node.find('header .value').text() !== '00:00'){
    			var durationHelper = this.$node.find('header .value').text().split(':');

    			var startMinute = parseInt(durationHelper[0]);
    			var startSeconds = parseInt(durationHelper[1]);
    			//var startDate = new Date(this.$node.find('header .value .col-xs-8').text()).getTime();
    		} else {
    			var startMinute = 0;
    			var startSeconds = 0;
    		}
    		SpinningWheel.addSlot(assistanceTypes, 'center', 'ASSISTANCE_TYPE_GUIDANCE');
    		SpinningWheel.open('#' + parentHelper + ' .assistance_type .editor.multipleselect .col-xs-9');
        this.$node.find('#sw-slots-wrapper').css({height: this.$node.find('#sw-frame').height()})
    		this.trigger('uiUpdateHeader');
    	}
    }

    this.deprecatedHandleInitAssistanceType = function(evt, data){

    	var thisComponent = this;

    	var initialSlide = 2;
		var saveName = 'capture';

    	if (data){
    		var saveName = 'edit';

    		if (data.Accomplishment.assistance_type){
    			var choices = document.querySelectorAll('#editing .assistance_type .swiper-slide');

        		for(var i=0; i < choices.length; i++){
        			if (choices[i].getAttribute('data-type') === data.Accomplishment.assistance_type){
        				initialSlide = i-1;
        				break;
        			}
        		}
    		}
    	}

    	var selector = this.$node.parent().attr('id');

    	if (!this[saveName + '-swiper']){
    		this[saveName + '-swiper'] = new Swiper('#' + selector + ' .assistance_type .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		initialSlide:initialSlide,
        		loop:true,
        		loopedSlides: 3,
        		onSlideChangeEnd : function(){
        			thisComponent.trigger('uiUpdateHeader');
        		}
        	});
    	}

    	if (data){
    		thisComponent.trigger('uiUpdateHeader');
    	}
    };

    this.handleUiUpdateHeader = function(evt, data){

    	if (typeof data === 'string'){
    		var selectionHelper = {
    				keys: [data],
    				values: [assistanceTypes[data]]
    		};
    	} else {
    		var selectionHelper = SpinningWheel.getSelectedValues();
    	}
    	this.$node.find('header > .value').html(selectionHelper.values[0]).attr('data-type', selectionHelper.keys[0]);
    }

    this.handleUiReset = function(evt, data){
    	this.$node.find('header .value').text('').attr('data-type', '');
    }

    this.after('initialize', function () {
    	//this.on('uiInitCapturing', this.handleInitAssistanceType);
    	//this.on('uiInitEditing', this.handleInitAssistanceType);
    	this.on('uiEditProperty', this.handleInitAssistanceType);
    	this.on('uiUpdateHeader', this.handleUiUpdateHeader);
    	this.on('uiReset', this.handleUiReset);
    });
  }

}());
