var DatePickerPopup = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return datePickerPopup;

  /**
   * Module function
   */

  function datePickerPopup() {
    this.defaultAttrs({

    });
    
    this.handleGetDatePickerPopup = function(evt, data){
    	console.log(data);
    	this.$node.attr('data-selector', '');
    	this.$node.parent().find('.overlay').show();
    	var todayHelper = new Date();
    	this.setDatePickerView(todayHelper, 'today');
    	this.$node.show().attr('data-selector', data.selector);
    };
    
    this.setDatePickerView = function(orientationData, mode){
    	var monthHelper = orientationData.getMonth(),
    		yearHelper = orientationData.getFullYear(),
    		firstHelper = new Date(yearHelper, monthHelper, 1),
    		daysContainer = document.querySelectorAll('#dp-days .dp-day'),
    		firstDayHelper = firstHelper.getDay(),
    		monthLength = [31,28,31,30,31,30,31,31,30,31,30,31],
    		todayHelper = orientationData.getDate();
  
    	$(daysContainer).html('').removeClass('selected').removeClass('today');
    	
    	if (firstDayHelper !== 0){
    		firstDayHelper--;
    	} else {
    		firstDayHelper = 6;
    	}
    		
		if ( (!(yearHelper % 4) && yearHelper % 100) || !(yearHelper % 400)) {
			monthLength[1] = 29;
		}
		
		if ((firstDayHelper < 5 && monthLength[monthHelper] === 31) || 
				(firstDayHelper < 6 && monthLength[monthHelper] === 30) ||
				(firstDayHelper === 5 && monthLength[monthHelper] === 31) || 
				(monthLength[monthHelper] < 30)){
			this.$node.find('#dp-days .row').last().hide();
			
			if (monthLength[monthHelper] === 28 && firstDayHelper === 0){
				this.$node.find('#dp-days .row').last().prev().hide();
			} else {
				this.$node.find('#dp-days .row').last().prev().show();
			}
		} else {
			this.$node.find('#dp-days .row').last().show().prev().show();
		}
		var todayTodayHelper = new Date();
    	for (var i = 0; i < monthLength[monthHelper]; i++){
    		daysContainer[firstDayHelper].innerHTML = (i+1);
    		if ((mode === 'today' && todayHelper === i+1) || (monthHelper === todayTodayHelper.getMonth() && todayTodayHelper.getDate() === i+1)){
    			daysContainer[firstDayHelper].className += ' selected today';
    			if (this.$node.attr('data-selector') === '#export'){
    				$(daysContainer[firstDayHelper]).next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected');
    			}
    		}
    		firstDayHelper++;
    	}
    	this.$node.find('header .dp-month').html(utils.getMonthLongnameString(monthHelper));
    	this.$node.find('header .dp-year').html(yearHelper);
    	this.currentViewFirstDate = firstHelper;
   };
    
    this.handleBackward = function(evt, data){
    	var prevMonthHelper = new Date(this.currentViewFirstDate - 1000*60*60*24);
    	this.$node.find('header .dp-month').html(utils.getMonthNameString(prevMonthHelper.getMonth()));
    	this.$node.find('header .dp-year').html(prevMonthHelper.getFullYear());
    	this.setDatePickerView(new Date(prevMonthHelper.getFullYear(), prevMonthHelper.getMonth(), 1));
    };
    
    this.handleForward = function(evt, data){
    	var nextMonthHelper = new Date(this.currentViewFirstDate.getTime() + 1000*60*60*24*40);
    	this.$node.find('header .dp-month').html(utils.getMonthNameString(nextMonthHelper.getMonth()));
    	this.$node.find('header .dp-year').html(nextMonthHelper.getFullYear());
    	this.setDatePickerView(new Date(nextMonthHelper.getFullYear(), nextMonthHelper.getMonth(), 1));
    };
    
    this.handleGetSelectedDate = function(evt, data){
    	var day = this.$node.find('#dp-days .selected').first().text();
    	
    	if (day){
    		var month = this.$node.find('header .dp-month').text();
        	var year = this.$node.find('header .dp-year').text();
        	
        	$(this.$node.attr('data-selector')).trigger('uiReturnDateFromDatePicker', {day:day, month: month, year: year});
    	}
    	this.$node.hide().parent().find('.overlay').hide();    	
    };
    
    this.after('initialize', function () {
    	this.on('uiGetDatePickerPopup', this.handleGetDatePickerPopup);
    	
    	var thisComponent = this;
    	
    	this.$node.find('header .backward').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			thisComponent.handleBackward('default', {width: 1});
    		});
    		
    	});
    	
    	this.$node.find('header .forward').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			
    			thisComponent.handleForward('default', {width: 1});
    		});
    		
    	});
    	
    	this.$node.find('#dp-days .dp-day').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			if ($this.text() !== ''){
    				$('#dp-days .dp-day.selected').removeClass('selected');
        			$this.addClass('selected');
        			
        			if (thisComponent.$node.attr('data-selector') === '#export'){
        				$this.next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected').next().addClass('selected');
        				if (thisComponent.$node.find('.dp-day.selected').length < 7){
      
        					var selectedCount = thisComponent.$node.find('.dp-day.selected').length;
        					
        					thisComponent.$node.find('.dp-day.selected').last().parent().next().find('.dp-day').first().addClass('selected');
        					for (var i = selectedCount; i < 6; i++){
        						thisComponent.$node.find('.dp-day.selected').last().next().addClass('selected');
        					}
        				}
        			}
    			}
    		});
    	});
    	
    	this.$node.find('footer .btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			thisComponent.handleGetSelectedDate('default', {mode:'day'});
    		});
    	});
    	
    });
    
  }

}());
