var InitCategory = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return initCategory;

  /**
   * Module function
   */

  function initCategory() {
    this.defaultAttrs({
    	subcategoryWrapperTemplateSelector : '.subcategories.template',
    	subcategoryTemplateSelector: '.subcategory.template'
    });

    this.handleGoToCategory = function(event, data){
    	$('#capturing').hide();
    	$('#capture .category-overview').hide();
    	this.$node.show();
    	
    	var initialSlideHelper = this.$node.find('.subcategories');
    	
    	for (var i = 0; i < initialSlideHelper.length; i++){
    		
    		if (initialSlideHelper[i].id === data.target + '-subcategories'){
    			initialSlideHelper = i;
    			break;
    		}
    	}
    	
    	var thisComponent = this;

		this.swiper = new Swiper('.subcategories-wrapper.swiper-container',{
    	    //Your options here:
    	    mode:'horizontal',
            height: window.innerHeight - utils.getMainNavigationHeight(),
    	    loop: true,
    	    initialSlide: initialSlideHelper,//data.target.split('-')[1]-1,
    	    onTouchMove: function(){
    	    	thisComponent.swiperMoved = true;
    	    }
    	  });
    	
    	var thisComponent = this;
    	this.$node.find('.subnavi-title').parent().bind('touchend', function(){
            $(document).trigger('setCurrentScreen', constants.moduleCapture());
			thisComponent.trigger('uiGoToBackToMain', {
				target: '.category-overview'
			});
		});
    	this.$node.find('.subcategory header').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			if ($this.parent().hasClass('single-type')){   
                    $(document).trigger('setCurrentScreen', constants.moduleCapturing()); 				
    				$('#capturing').trigger('uiStartCapturing', {
						typeId: $this.parent().attr('data-type-id'),
						category: $this.attr('data-category'),
	    				title: $this.find('.title').text()
					});
				} else {
					thisComponent.expandTypes(evt, {
						subcategoryId : $this.parent().attr('id')
					});
				}
    		});
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			setTimeout(function(){
    				$this.unbind('touchend');
    			}, 1);
    		});	
		});
    	
    	this.$node.find('.type').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
                $(document).trigger('setCurrentScreen', constants.moduleCapturing());
    			$('#capturing').trigger('uiStartCapturing', {
    				typeId: this.getAttribute('id').split('-')[1],
    				category: this.getAttribute('data-category'),
    				title: $(this).find('.title').text()
    			});
    		});
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    	});
        $(document).trigger('setCurrentScreen', {module:'#capture', view:'.subcategories-wrapper'});
    };
    
    this.expandTypes = function(evt, data){
    	if ($('#' + data.subcategoryId + ' .type-wrapper').height() > 0){
    		$('#' + data.subcategoryId + ' .type-wrapper').height(0);
    	} else {
    		var activeSlider = document.querySelector('.swiper-slide-active #' + data.subcategoryId);
    		if(activeSlider){
    			var typesCountHelper = activeSlider.querySelectorAll('.type').length;
        		$('#' + data.subcategoryId + ' .type-wrapper').height(typesCountHelper * ($('#capture .type-wrapper .title').first().height() + 2));
    		}else{
    			activeSlider = document.querySelector('#' + data.subcategoryId); // fix where activeSlider is null sometimes caus swiper-slide-active class is not set 
    			var typesCountHelper = activeSlider.querySelectorAll('.type').length;
    			// var typesCountHelper = document.querySelector('.swiper-slide-active #' + data.subcategoryId).querySelectorAll('.type').length;
        		$('#' + data.subcategoryId + ' .type-wrapper').height(typesCountHelper * ($('#capture .type-wrapper .title').first().height() + 2));
    		}
    	}
    };
    
    this.uiBackToMain = function(){
    	this.destroy();
    	this.backToMain();
    };
    
    this.destroy = function(){
    	this.$node.find('.subcategory .type-wrapper').height(0);
    	if (this.swiper && this.swiper.destroy){
			this.swiper.destroy();
			$('#capture .swiper-slide-duplicate').remove();
			$('#capture .swiper-wrapper').attr('style', '');
			$('#capture .subcategories').attr('style', '');
		}
    };
    
    this.backToMain = function(){
    	$('.subcategories-wrapper').hide();
		$('#capturing').hide();
		$('#capture .category-overview').show();
    };
    
    this.after('initialize', function () {
    	
    	this.on('uiGoToCategory', this.handleGoToCategory);
    	
    	this.on('uiGoToBackToMain', this.uiBackToMain);
    	
    	this.on('uiDestroy', this.destroy);

    	this.on('uiExpandTypes', this.expandTypes);
    	
/* ----------------------------------------------------------------------------------------------------------------------------------------------------------------------- */    	
    	
		this.$subcategoryWrapperTemplate = this.select('subcategoryWrapperTemplateSelector').clone();
		var thisComponent = this;
		
    	for (var i = 0; i < accTypes.accomplishmentCategories.length; i++){
    		var $subcategoryWrapper = this.$subcategoryWrapperTemplate.clone();
    		$subcategoryWrapper.attr('id', 'category-' + accTypes.accomplishmentCategories[i].AccomplishmentCategory.id + '-subcategories');
    		$subcategoryWrapper.removeClass('template');
    		
    		$subcategoryWrapper.find('header .title').text(accTypes.accomplishmentCategories[i].AccomplishmentCategory.name);		
    		this.$node.find('.swiper-wrapper').append($subcategoryWrapper);
    	}
    	this.select('subcategoryWrapperTemplateSelector').remove();

/* ----------------------------------------------------------------------------------------------------------------------------------------------------------------------- */
    	
    	this.$subcategoryTemplate = this.select('subcategoryTemplateSelector').first().clone();
		var thisComponent = this;
		
    	for (var i = 0; i < accTypes.accomplishmentCategories.length; i++){
    		for (var j = 0; j < accTypes.accomplishmentCategories[i].AccomplishmentSubcategory.length; j++){
    			var $subcategory = this.$subcategoryTemplate.clone();
    			$subcategory.attr('id', 'subcategory-' + accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].id);
    			$subcategory.removeClass('template');
    			$subcategory.find('header').attr('data-category', accTypes.accomplishmentCategories[i].AccomplishmentCategory.id);
    			$subcategory.find('header .title').text(accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].short_name ? accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].short_name : accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].name);
    			$subcategory.find('header .icon').html('&#' + accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].icon_char + ';');
    
    			if (accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType.length > 1){
    				$subcategory.find('.type .title').text(accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[0].short_name ? accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[0].short_name : accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[0].name);
    				$subcategory.find('.type').attr('id', 'type-' + accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[0].id).attr('data-category', accTypes.accomplishmentCategories[i].AccomplishmentCategory.id);
	    			for (var k = 1; k < accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType.length; k ++){
	    				var typeHelper = $subcategory.find('.type').first().clone();
	    				typeHelper.attr('id', 'type-' + accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[k].id);
	    				typeHelper.attr('data-category', accTypes.accomplishmentCategories[i].AccomplishmentCategory.id);
	    				typeHelper.find('.title').text(accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[k].short_name ? accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[k].short_name : accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[k].name);
	    				$subcategory.find('.type-wrapper').append(typeHelper);
	    			}
    			} else {
    				$subcategory.find('.type').remove();
    				$subcategory.addClass('single-type');
    				$subcategory.attr('data-type-id', accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].AccomplishmentType[0].id);
    			}
    			
    			this.$node.find('#category-' + (accTypes.accomplishmentCategories[i].AccomplishmentCategory.id) + '-subcategories').append($subcategory);
    			
    		}
    	}
    	this.select('subcategoryTemplateSelector').remove();
    	
    });
  }

}());
