var InitEdit = flight.component(function () {

  'use strict';
  
  /**
   * Module exports
   */

  var activeIndex = 2;
  var sliderTemplate = '<div class="no-data">Für diesen Tag wurden noch keine Verrichtungen erfasst.</div><div class="data-wrapper" style="display:none;"><div class="time-wrapper morning row"><header>Morgens<br>6 - 12 Uhr</header></div><div class="time-wrapper noon row"><header>Mittags<br>12 - 14 Uhr</header></div><div class="time-wrapper afternoon row"><header>Nachmittags<br>14 - 18 Uhr</header></div><div class="time-wrapper evening row"><header>Abends<br>18 - 22 Uhr</header></div><div class="time-wrapper night row"><header>Nachts<br>22 - 6 Uhr</header></div></div>';
  
  return initEdit;

  /**
   * Module function
   */
  
  function getDurationString (duration){
	  var secHelper = duration % 60;
  	
	  	if (secHelper > 0){
	  		var minHelper = Math.floor(duration / 60);
	  		return 'DAUER ' + minHelper + ' min ' + secHelper + ' sek';
	  	} else {
	  		return 'DAUER ' + duration/60 + ' min';
	  	}
  }
  
  function checkForTimeWrapperVisiblity($timeWrapper){
	  if ($timeWrapper.length > 0){
		  if (!$timeWrapper[0].querySelector('.entry')){
			  $timeWrapper.hide();
			  if ($timeWrapper.parent().find('.entry').length < 1){
				  $timeWrapper.parent().parent().find('.no-data').show();
			  }
		  }
	  }
  }
  
  function initEdit() {
    this.defaultAttrs({});

    this.handleDataFromDateComplete = function(evt, data){
    	if (data.type === 'update'){
    		this.handleDataFromDateUpdate(evt, data);
    	} else {
    		if (this.swiper && !document.querySelector('.' + data.key) && (data.key.match('today') || this.swiper.slides[this.swiper.slides.length-1].className.split(' ')[2].split('-')[0] === 'yesterday')){
    			this.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report ' + data.key);
                if (this.swiper.slides.length > 9){
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.swipeTo(4, 0, false);
                }
    		}
    		
	    	for (var i = 0; i < data.items.length; i++){
	    		this.createEntry(data.items[i], '.swiper-slide.' + data.key);
	    	}
	    	
	    	this.$node.find('.swiper-slide.' + data.key).attr('data-date', data.dateHelper);
	    	
	    	var timeWrapperHelper = this.$node.find('.time-wrapper');
	    	$(timeWrapperHelper).show();
	    	for (var i = 0; i < timeWrapperHelper.length; i++){	
	    		if (!timeWrapperHelper[i].querySelector('.entry')){
	    			$(timeWrapperHelper[i]).hide();
	    		}
	    	}
	    	
	    	this.$node.find('.no-data').hide();
	    	
	    	var slideNoDataHelper = document.querySelectorAll('#edit .day-report');
	    	
	    	for (var i = 0; i < slideNoDataHelper.length; i++){
	    		if (!slideNoDataHelper[i].querySelector('.entry')){
	        		$(slideNoDataHelper[i].querySelector('.no-data')).show();
	        	}
	    	}
	    	this.$node.find('.spinner-overlay').hide();
    	}
    };
    
    this.handleDataFromDateUpdate = function(evt, data){
    	for (var i = 0; i < data.items.length; i++){
    		this.updateEntry(data.items[i], '.swiper-slide.' + data.key);
    	}
    };
    
    this.updateEntry = function(data, selector){
    	var $entry = $('#' + data.mmRequestId);
    	if (!$entry.length){
    		this.createEntry(data, selector, 'update');
    	} else if ($entry.attr('data-db-modified') !== data.modified){
    	}   
    	this.$node.find('.no-data').hide();
    	this.$node.find('.data-wrapper').show();
    	
    	var timeWrapperHelper = this.$node.find('.time-wrapper');
    	$(timeWrapperHelper).show();
    	for (var i = 0; i < timeWrapperHelper.length; i++){	
    		if (!timeWrapperHelper[i].querySelector('.entry')){
    			$(timeWrapperHelper[i]).hide();
    		}
    	}
    };
    
    this.afterInitialize = function(){
    	
    	if (localStorage.getItem('localData')){
    		$(document).trigger('dataGetDataFromDate');
    		this.$node.find('.spinner-overlay').show();
    	} else {
    		this.$node.find('.no-data').show();
    		this.$node.find('.time-wrapper').hide();
    	}
    	this.$node.find('.current-view-date').html(utils.getDateString(new Date()));
    };
    
    this.createEntry = function(data, selector, mode){
    	
    	var dateHelper = new Date (data.Accomplishment.start_time);
    	var typeHelper = typesIndex.accomplishmentTypes[data.Accomplishment.accomplishment_type_id].AccomplishmentType;
    	var entryHelper = document.createElement('div');
    	entryHelper.className = 'row entry';
    	entryHelper.id = 'a' + data.mmRequestId;
    	entryHelper.setAttribute('data-db-modified', (data.modified ? data.modified : 0));
    	//entryHelper.setAttribute('data-db-key', data.key);
    	entryHelper.setAttribute('data-start-time', data.Accomplishment.start_time);
    	entryHelper.setAttribute('data-server-id', data.Accomplishment.id);
    	
    	var categoryHelper = document.createElement('div');
    	categoryHelper.className = 'col-xs-2 category-marker category-' + subcategoriesIndex.accomplishmentSubcategories[typeHelper.accomplishment_subcategory_id].AccomplishmentSubcategory.accomplishment_category_id;
    	
    	var startTimeHelper = document.createElement('div');
    	startTimeHelper.className = 'start_time row';
    	startTimeHelper.innerHTML = utils.getTimeString(dateHelper);
    	categoryHelper.appendChild(startTimeHelper);
    	
    	entryHelper.appendChild(categoryHelper);
    	
    	var dashboardHelper = document.createElement('div');
    	dashboardHelper.className = 'dashboard col-xs-9';
    	
    	var ratingHelper = document.createElement('div');

    	if (data.Accomplishment.duration === '0' || data.Accomplishment.assistance_type === "ASSISTANCE_TYPE_UNDEFINED"){
    		ratingHelper.className = 'ui-icon col-xs-1 complete-state complete-state-not-ready';
    		ratingHelper.innerHTML = '&#xe806;';
    	} else {
    		ratingHelper.className = 'ui-icon col-xs-1 complete-state complete-state-ready';
    		ratingHelper.innerHTML = '&#xe805;';
    	}
    	
    	dashboardHelper.appendChild(ratingHelper);
    	
    	var titleHelper = document.createElement('div');
    	titleHelper.className = 'title col-xs-11';
    	titleHelper.innerHTML = typeHelper.short_name ? typeHelper.short_name : typeHelper.name;
    	dashboardHelper.appendChild(titleHelper);
    	
    	var timeHelper = document.createElement('div');
    	timeHelper.className = 'ui-icon ui-blue col-xs-1 time_rating';
    	if (!typeHelper.individual_standard_duration){
    		var durationHelper = parseInt(data.Accomplishment.duration),
    			minHelper = parseInt(typeHelper.standard_duration_min)-1,
    			maxHelper = parseInt(typeHelper.standard_duration_max)+1;
    		if ((durationHelper > minHelper) && (durationHelper < maxHelper)){
    			timeHelper.innerHTML = '&#xe801;';
    		} else {
    			if (durationHelper > maxHelper){
    				timeHelper.innerHTML = '&#xe802;';
    			} else {
    				timeHelper.innerHTML = '&#xe800;';
    			}
    		}
    	}
    	dashboardHelper.appendChild(timeHelper);

    	var durationHelper = document.createElement('div');
    	durationHelper.className = 'ui-text ui-blue col-xs-11 duration';
    	durationHelper.innerHTML = getDurationString(data.Accomplishment.duration);
    	
    	dashboardHelper.appendChild(durationHelper);
    	
    	entryHelper.appendChild(dashboardHelper);
    	
    	var helpHelper = document.createElement('div');
    	helpHelper.className = 'ui-icon ui-help';
    	helpHelper.innerHTML = '&#xe80f;';
    	entryHelper.appendChild(helpHelper);
    		
    	$(entryHelper).bind('touchstart', function(evt){
    		
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$('#editing').trigger('dataGetSingleRecordCompleted', data);
    		});
    		
    	});
    	
    	if (mode === 'update'){
    		var existingEntries = this.$node.find(selector + ' .' + this.getTimeRange(dateHelper) + ' .entry .start_time');
    		// console.log(existingEntries);
    		
    		var newEntryTime = startTimeHelper.innerHTML.replace(/:/, '');
    		
    		if (existingEntries.length === 0){
    			this.$node.find(selector + ' .' + this.getTimeRange(dateHelper)).show().append(entryHelper);
    		} else {
    			for (var i = 0; i < existingEntries.length; i++){
	    			var compareTime =  $(existingEntries[i]).text().replace(/:/, '');
	    			
	    			if (compareTime > newEntryTime){
	    				$(existingEntries[i]).parent().parent().before(entryHelper);
	    				break;
	    			}
	    			
	    			if (existingEntries.length === i + 1){
	    				$(existingEntries[i]).parent().parent().after(entryHelper);
	    			}
	    		}
    		}
    		
    		
    	} else {
    		this.$node.find(selector + ' .' + this.getTimeRange(dateHelper)).append(entryHelper);
    	}
    	var timeWrapperHelper = this.$node.find('.time-wrapper');
    	$(timeWrapperHelper).show();
    	for (var i = 0; i < timeWrapperHelper.length; i++){	
    		if (!timeWrapperHelper[i].querySelector('.entry')){
    			$(timeWrapperHelper[i]).hide();
    		}
    	}
    	
    	this.$node.find('.no-data').hide();
    	
    	var slideNoDataHelper = document.querySelectorAll('#edit .day-report');
    	
    	for (var i = 0; i < slideNoDataHelper.length; i++){
    		if (!slideNoDataHelper[i].querySelector('.entry')){
        		$(slideNoDataHelper[i].querySelector('.no-data')).show();
        	}
    	}
    	$(selector + ' .data-wrapper').show();
    	
    };
    
    this.getTimeRange = function(date){
    	
    	var returnHelper;
    	
    	var timeHelper = date.getHours() + '' + (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
    	
    	if (timeHelper >= 600 && timeHelper < 1200){
    		return 'morning';
    	}
    	
    	if (timeHelper >= 1200 && timeHelper < 1400){
    		return 'noon';
    	}
    	
    	if (timeHelper >= 1400 && timeHelper < 1800){
    		return 'afternoon';
    	}
    	
    	if (timeHelper >= 1800 && timeHelper < 2200){
    		return 'evening';
    	}
    	
    	if (timeHelper >= 2200 && timeHelper < 2400 || timeHelper >= 0 && timeHelper < 600){
    		return 'night';
    	}
    	
    };
    
    this.handleChangeModuleTo = function(evt, data){
    	var thisComponent = this;
    	
    	if (this.swiper){
    		this.destroy();
    		//this.trigger('uiUpdateDiary');
    	} 
		$('#diary .swiper-container').height(window.innerHeight - 47 - 34);
		
    	this.swiper = new Swiper('#edit .swiper-container',{
    	    //Your options here:
    	    mode : 'horizontal',
    	    slidesPerView : '1',
    	    initialSlide : activeIndex,
    	    followFinger : false,
    	    onFirstInit : function(swiper){
    	    	// console.log('onFirstInit');
    	    	swiper.swipeTo(activeIndex+2, 0, false);
    	    },
    	    onInit: function(swiper){
    	    	if (thisComponent.swiperDirection === 'prev'){
    	    		// console.log('prev');
                    // console.log(swiper.activeIndex);
    	    		swiper.swipeTo(swiper.activeIndex+1, 0);
    	    	} else {
    	    		if ($(swiper.slides[swiper.slides.length-2]).hasClass('today-2')){
        	    		// console.log('2.bedingung');
        	    		swiper.swipeTo(swiper.slides.length-2, 0, false);
        	    	}
    	    	}
    	    	
    	    },
    	    onSlideNext: function(swiper){
    	    	if ($(swiper.activeSlide()).hasClass('dummy')){
    	    		swiper.swipePrev();
    	    	} 
    	    },
    	    onSlideChangeStart: function(swiper, direction, data){
                // console.log('onSlideChangeStart');
    	    	var $activeSlide = thisComponent.$node.find('.day-report.swiper-slide-active');
    	    	thisComponent.swiperDirection = direction;
    	    	if (swiper.activeIndex === 1){
    	    		var yesterdayHelper = thisComponent.$node.find('.day-report').first().attr('class').split(' ')[2],
    	    			classHelper = yesterdayHelper.split('-'),
    	    			todayHelper = new Date();
    	    		
    	    		classHelper[1]++;
    	    		if (classHelper[0] === 'today'){
                        // console.log('test');
    	    			if (classHelper[1] == 2){
    	    				swiper.prependSlide(sliderTemplate, 'swiper-slide day-report today');
    	    				swiper.prependSlide(sliderTemplate, 'swiper-slide day-report yesterday');
    	    				swiper.prependSlide(sliderTemplate, 'swiper-slide day-report yesterday-1');
    	    				swiper.swipeTo(4,0, false);
    	    				thisComponent.getDefaultDays();
    	    				utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.today'));
    	    				utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday'));
    	    				utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday-1'));

    	    			} else {
    	    				if (isNaN(classHelper[1])){
                                // console.log('onSlideChangeStart');
    	    					swiper.prependSlide(sliderTemplate, 'swiper-slide day-report yesterday');
        	    				swiper.prependSlide(sliderTemplate, 'swiper-slide day-report yesterday-1');
        	    				swiper.swipeTo(4,0);
        	    				thisComponent.getDefaultDays();
        	    				utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday'));
        	    				utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday-1'));
    	    				} else {
    	    					classHelper[1]--;
                                classHelper[1]--;
	    	    				$(document).trigger('dataGetDataFromDate', {
			    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + classHelper[1]),
			    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + classHelper[1]+1),
			    	    			key: 'today-' + classHelper[1]
			    	    		});
			    	    		
			    	    		swiper.prependSlide(sliderTemplate, 'swiper-slide day-report today-' + classHelper[1]);
                                swiper.swipeTo(2,0);
			    	    		utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.today-' + classHelper[1]));
    	    				}
    	    			}
    	    		} else {
    	    			if (swiper.slides.length === 4 && !$(swiper.slides).hasClass('today')){
    	    				$(document).trigger('dataGetDataFromDate', {
    	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]),
    	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]+1),
    	    	    			key: 'yesterday-' + classHelper[1]
    	    	    		});
    	    			} else {
    	    				$(document).trigger('dataGetDataFromDate', {
    	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]-1),
    	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]),
    	    	    			key: 'yesterday-' + classHelper[1]
    	    	    		});
    	    	    		
    	    			}
	    	    		
                        swiper.prependSlide(sliderTemplate, 'swiper-slide day-report yesterday-' + classHelper[1]);         

                        if (swiper.slides.length > 9){
                            while (swiper.slides.length > 6) {
                                swiper.removeSlide(swiper.slides.length -1);
                            }
                            swiper.swipeTo(2, 300, false);
                        } else {
                            swiper.swipeTo(swiper.activeIndex-1, 300 , false);
                        }

	    	    		utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday-' + classHelper[1]));
    	    		}
    	    	}
    	
    	    	if ($activeSlide.length > 0){
					var dateString;
    	    		if ($activeSlide.attr('data-date')){
        	    		dateString = utils.getDateString(new Date($activeSlide.attr('data-date')));
        	    	} else {
        	    		if ($activeSlide.hasClass('today')){
        	    			dateString = utils.getDateString(new Date());
        	    		} else {
        	    			todayHelper = new Date();
        	    			if ($activeSlide.hasClass('yesterday')){
        	    				dateString = utils.getDateString(new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()-1));
        	    			} else {
        	    				classHelper = $activeSlide.attr('class').split(' ')[2].split('-');
        	    				if (classHelper[0] === 'today'){
		            	    		dateString = utils.getDateString(new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + parseInt(classHelper[1])));
        	    				} else {
        	    					dateString = utils.getDateString(new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - ++classHelper[1]));
        	    				}	
        	    			}
        	    		}	
        	    		
        	    	}
    	    	}

                if (thisComponent.$node.find('.day-report.swiper-slide-active').attr('data-date') !== undefined){                	
                	// console.log('from Element');
    	    	  	thisComponent.$node.find('.current-view-date').html(utils.getDateString(new Date(thisComponent.$node.find('.day-report.swiper-slide-active').attr('data-date'))));
                }else{
                	// console.log('dateString');               	
                    thisComponent.$node.find('.current-view-date').html(dateString);  

                }
    	    },
    	    
    	    onSlideChangeEnd : function(swiper, direction){
                // if (thisComponent.$node.find('.day-report.swiper-slide-active').attr('data-date') !== undefined){
                	// var dateString = utils.getDateString(new Date(thisComponent.$node.find('.day-report.swiper-slide-active').attr('data-date')));
    	    	  	// thisComponent.$node.find('.current-view-date').html(dateString);
                // }                

    	    	if (direction == 'next' && swiper.visibleSlides && swiper.visibleSlides[0] === document.querySelector('#diary .swiper-slide:last-child')){
    	    		
    	    		var tomorrowHelper = thisComponent.$node.find('.day-report').last().attr('class').split(' '),
    	    			classHelper = tomorrowHelper[2].split('-'),
    	    			key = 'today-';
    	    		classHelper[1]++;
    		    	    		
    	    		if (classHelper[0] === 'yesterday'){
    	
    	    			if (classHelper[1] === 3){
    	    			
    	    				thisComponent.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report yesterday-1');
    	    				thisComponent.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report yesterday');
    	    				thisComponent.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report today');
    	    				thisComponent.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report today-1');
    	    				
    	    				thisComponent.getDefaultDays();
    	    				
    	    			} else {
    	    				classHelper[1]--;
	    	    			classHelper[1]--;
	    	    			key = 'yesterday-';
	    	    			
	    	    			var todayHelper = new Date();
		    	    		$(document).trigger('dataGetDataFromDate', {
		    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]-1),
		    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]),
		    	    			key: key + classHelper[1]
		    	    		});
    	    			}
    	    		} else {
    	    			var todayHelper = new Date();
	    	    		$(document).trigger('dataGetDataFromDate', {
	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + classHelper[1]),
	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + classHelper[1]+1),
	    	    			key: key + classHelper[1]
	    	    		});
    	    		}
    	    	}
    	    	
    	    }
    	  });
    	
    	if (!data){
    		this.trigger(document, 'saveToHistory', {module: '#edit', view: '#diary'});
    	}
    };
    
    this.handleUiUpdateDiary = function(){
    	var dayReports =  document.querySelectorAll('#diary .day-report');
    	var todayHelper = new Date();
    	for (var i = 0; i < dayReports.length; i++){
    		
    		var $dayReport = $(dayReports[i]);
    		if ($dayReport.hasClass('today')){
    			$(document).trigger('dataGetDataFromDate', {
    				start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
        			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
        			key: 'today',
        			type: 'update'
    			});
    		} else if ($dayReport.hasClass('yesterday')){
    			$(document).trigger('dataGetDataFromDate', {
    				start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()-1),
        			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
        			key: 'yesterday',
        			type: 'update'
    			});
    		} else {
    			//var classHelper = parseInt(yesterdayHelper[yesterdayHelper.indexOf('yesterday')+10])+1;	
    		}	
    	}
    };
    
    this.destroy = function(){
    	if (this.swiper.destroy){
    		activeIndex = this.swiper.activeIndex;
    		this.swiper.destroy();
			$('#edit .swiper-slide-duplicate').remove();
			$('#edit .swiper-wrapper').attr('style', '');
			$('#edit .day-report').attr('style', '');
		} else {
			activeIndex = 2;
		}
    };
    
    this.handleEntryCreated = function(evt, data){
    	var gapHelper = utils.getDaysGap(data.items.Accomplishment.start_time);
    	if (gapHelper === 0 ){
    		this.createEntry(data.items, '.today', 'update');
    		this.$node.find('.today .no-data').hide();
    	} else {
    		if (gapHelper > 0){
    			if (document.querySelector('#edit .today-' + gapHelper)){
    				this.createEntry(data.items, '.today-' + gapHelper, 'update');
    				this.$node.find('.today-' + gapHelper + ' .no-data').hide();
    			}
    		} else {
    			if (gapHelper < -1){
    				if (document.querySelector('#edit .yesterday-' + ++gapHelper)){
        				this.createEntry(data.items, '.yesterday-' + ++gapHelper, 'update');
        				this.$node.find('.yesterday-' + ++gapHelper + ' .no-data').hide();
        			}
    			} else {
    				if (gapHelper === -1){
    					this.createEntry(data.items, '.yesterday', 'update');
    					this.$node.find('.yesterday .no-data').hide();
    				}
    			}
    		}
    	}
    	
    	this.$node.find('.spinner-overlay').hide();
    };
    
    this.handleEntryUpdated = function(evt, data){
    	var $entry = this.$node.find('#a' + data.items.mmRequestId);
    	var typeHelper = typesIndex.accomplishmentTypes[data.items.Accomplishment.accomplishment_type_id ? data.items.Accomplishment.accomplishment_type_id : 2].AccomplishmentType;
    	if ($entry.attr('data-start-time') !== data.items.Accomplishment.start_time){
    		checkForTimeWrapperVisiblity($entry.parent());
    		$entry.remove();
    		this.handleEntryCreated(evt, data);
    	} else {
        	$entry.find('.dashboard .title').html(typeHelper.short_name ? typeHelper.short_name : typeHelper.name);
        	$entry.find('.dashboard .duration').html(getDurationString(data.items.Accomplishment.duration));
    	}

    	if (data.items.Accomplishment.duration === 0 || data.items.Accomplishment.assistance_type === "ASSISTANCE_TYPE_UNDEFINED"){
    		$entry.find('.dashboard .complete-state').html('&#xe806;').attr('class', 'ui-icon col-xs-1 complete-state complete-state-not-ready');    		
    	} else {
    		$entry.find('.dashboard .complete-state').html('&#xe805;').attr('class', 'ui-icon col-xs-1 complete-state complete-state-ready');
    	}
    	
    	
    	if (!typeHelper.individual_standard_duration){
    		if (data.items.Accomplishment.duration >= typeHelper.standard_duration_min && data.items.Accomplishment.duration <= typeHelper.standard_duration_max){
    			$entry.find('.time_rating').html('&#xe801');
    		} else {
    			if (data.items.Accomplishment.duration > typeHelper.standard_duration_max){
    				$entry.find('.time_rating').html('&#xe802');
    			} else {
    				$entry.find('.time_rating').html('&#xe800');
    			}
    		}	
    	}
    	
    	$entry.unbind('touchstart').bind('touchstart', function(evt){
    		
    		var $this = $(this);
    		
    		$this.bind('touchmove',function(){
    			$this.unbind('touchend');
    		});
    		
    		$this.bind('touchend', function(){
    			$('#editing').trigger('dataGetSingleRecordCompleted', data.items);
    		});
    		
    	});
    	
    	this.$node.find('.spinner-overlay').hide();
    	
    };
    
    this.handleEntryDeleted = function(evt, data){
    	var $entry = this.$node.find('#a' + data.key);
    	var $timeWrapper = $entry.parent();
    	$entry.remove();
    	checkForTimeWrapperVisiblity($timeWrapper);
    	
    	this.$node.find('.spinner-overlay').hide();
    };
    
    this.handleDateFromDatePicker = function(evt, data){
    	// console.log(data);
    	var todayHelper = new Date();
    	var	dateFromPicker = new Date(data.year, utils.getMonthFromName(data.month), data.day, '00', '00', '00');
    	var	daysGap = 0;
    	var	centerKey = 'yesterday';
    	var todayHelper = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate());
    	var	thisComponent = this;
    	var daysGap = utils.getDaysGap(dateFromPicker);
		console.log(daysGap);
    	if (todayHelper.getTime() < dateFromPicker.getTime()){
    		console.log('futur Time')
    		centerKey = 'today-' + (daysGap + 1);
    	} else {
    		console.log('else')
    		if (daysGap === -1){
    			centerKey = 'today';
    		} else {
    			if (daysGap !== -2){
        			centerKey = 'yesterday' + (daysGap + 2);
        		}
    		}
    	}
    	if (this.$node.find('.' + centerKey).length === 1){
    		
            /**
             * Prüfen auf yester abfangen und zusätzlich wenn Sprung zum letzten Slide, 
             * weitere Slides hinzufügen, das swipen weiterhin möglich ist
             *
             */

            for (var i = 0; i < this.swiper.slides.length; i++){
    			if (this.swiper.slides[i].className.search(centerKey) !== -1){
    				if (i < 2){
    					var classHelper = this.swiper.slides[0].className.split(' ')[2].split('-'),
    						todayHelper = new Date();
    					this.swiper.prependSlide(sliderTemplate, 'swiper-slide day-report ' + classHelper[0] + '-'  + ++classHelper[1]);
	    	    		utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday-' + classHelper[1]));
    					
	    	    		var todayHelper = new Date();
	    	    		$(document).trigger('dataGetDataFromDate', {
	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]-1),
	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]),
	    	    			key: classHelper[0] + '-' + classHelper[1]
	    	    		});
	    	    		
	    	    		this.swiper.prependSlide(sliderTemplate, 'swiper-slide day-report ' + classHelper[0] + '-'  + ++classHelper[1]);
	    	    		utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.yesterday-' + classHelper[1]));
    					
	    	    		var todayHelper = new Date();
	    	    		$(document).trigger('dataGetDataFromDate', {
	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]-1),
	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - classHelper[1]),
	    	    			key: classHelper[0] + '-' + classHelper[1]
	    	    		});
	    	    		   				
    					console.log('swipeTo i + 2 = ' + i + 2);
	    	    		this.swiper.swipeTo(i + 2, 0, false);
    				} else {	    	    		   				
    					console.log('swipeTo i' + i)
    					this.swiper.swipeTo(i, 0, false);
    				}
    				break;
    			}
    		}
    		this.$node.find('.current-view-date').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
    	} else {
    		var centerKeySplit = centerKey.split('-');
    		console.log(centerKeySplit)
    		if ((centerKeySplit[0] === 'yesterday' && centerKeySplit[1] > 1) || (centerKeySplit[0] === 'today' && centerKeySplit[1] > 1)){
    			for (var i = 3; i < this.swiper.slides.length; i++){
        			$(this.swiper.slides[i]).remove();
        		}
        		
        		if (centerKeySplit[0] === 'yesterday'){
        			centerKeySplit[1] = parseInt(centerKeySplit[1]) + 2;
        		} else {
        			centerKeySplit[1] = parseInt(centerKeySplit[1]) - 2;
        		}
        		
        		this.$node.find('.entry').remove();
        		
    			for (var i = 0; i < this.swiper.slides.length; i++){
    				
    				if (centerKeySplit[0] === 'yesterday'){
        				$(document).trigger('dataGetDataFromDate', {
        					start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - centerKeySplit[1]-1),
        					end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - (centerKeySplit[1]-2)),
        					key: centerKeySplit[0] + '-' + centerKeySplit[1]
        				});
        				
        				this.swiper.slides[i].className= 'swiper-slide day-report ' + centerKeySplit[0] + '-' + centerKeySplit[1]--;
        				this.swiper.slides[i].removeAttribute('data-date');
        			} else {
        				if (centerKeySplit[1] === 0){
        					$(document).trigger('dataGetDataFromDate', {
            					start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + centerKeySplit[1]),
            					end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + (centerKeySplit[1]+1)),
            					key: centerKeySplit[0]
            				});
        					this.swiper.slides[i].className= 'swiper-slide day-report ' + centerKeySplit[0];
        					this.swiper.slides[i].removeAttribute('data-date');
        					centerKeySplit[1]++;
        				} else {
        					$(document).trigger('dataGetDataFromDate', {
            					start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + centerKeySplit[1]),
            					end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + (centerKeySplit[1]+1)),
            					key: centerKeySplit[0] + '-' + centerKeySplit[1]
            				});
        					this.swiper.slides[i].className= 'swiper-slide day-report ' + centerKeySplit[0] + '-' + centerKeySplit[1]++;
        					this.swiper.slides[i].removeAttribute('data-date');
        				}
        			}	
        		}

    			this.swiper.swipeTo(2, 0, false);
    		} else {
    			if (centerKeySplit[1] == 2){
    				var searchedKey = centerKey.split('-')[0] + '-1';
    				
    				for (var i = 0; i < this.swiper.slides.length; i++){
    	    			if (this.swiper.slides[i].className.search(searchedKey) !== -1){
    	    				this.swiper.swipeTo(i, 0, true); 
    	    				var todayHelper = new Date();
    	    	    		$(document).trigger('dataGetDataFromDate', {
    	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
    	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 3),
    	    	    			key: 'today-2'
    	    	    		});
    	    	    		$(document).trigger('dataGetDataFromDate', {
    	    	    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
    	    	    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 3),
    	    	    			key: 'today-3'
    	    	    		});
    	    				break;
    	    			}
    	    		}
    				if (centerKeySplit[0] === 'yesterday'){
    					this.swiper.swipePrev();
    				} else {
    					var thisComponent = this;
    				}
    				
    			} else {
    				for (var i = 4; i < this.swiper.slides.length; i++){
            			$(this.swiper.slides[i]).remove();
            		}
        			todayHelper = new Date();
        			this.swiper.slides[0].className= 'swiper-slide day-report yesterday-1';
        			this.swiper.slides[0].removeAttribute('data-date');
        			this.swiper.slides[1].className= 'swiper-slide day-report yesterday';
        			this.swiper.slides[1].removeAttribute('data-date');
        			this.swiper.slides[2].className= 'swiper-slide day-report today';
        			this.swiper.slides[2].removeAttribute('data-date');
        			this.swiper.slides[3].className= 'swiper-slide day-report today-1';
        			this.swiper.slides[3].removeAttribute('data-date');
        			this.$node.find('.entry').remove();
        		
                    this.swiper.swipeTo(2,0,false);
        				
        			this.getDefaultDays();
    			}
    		}
    		this.$node.find('.current-view-date').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
    		//this.swiper.swipeTo(2, 0);
    	} 	
    };
    
    this.handleLogout = function(){
    	this.$node.find('.spinner-overlay').show();
    	if (this.swiper){
    		for (var i = 4; i < this.swiper.slides.length; i++){
    			$(this.swiper.slides[i]).remove();
    		}
    		this.swiper.slides[0].className= 'swiper-slide day-report yesterday-1';
    		this.swiper.slides[0].removeAttribute('data-date');
    		this.swiper.slides[1].className= 'swiper-slide day-report yesterday';
    		this.swiper.slides[1].removeAttribute('data-date');
    		this.swiper.slides[2].className= 'swiper-slide day-report today';
    		this.swiper.slides[2].removeAttribute('data-date');
    		this.swiper.slides[3].className= 'swiper-slide day-report today-1';
    		this.swiper.slides[3].removeAttribute('data-date');
    	}
		this.$node.find('.entry').remove();
    };
    
    this.getDefaultDays = function () {
    	
    	var todayHelper = new Date();
    	
    	$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 2),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
			key: 'yesterday-1'
		});
		
		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
			key: 'yesterday'
		});
		
		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
			key: 'today'
		});
		
		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
			key: 'today-1'
		});
		
		
    };
    
    this.after('initialize', function () {
    	this.on('dataAccomplishmentsFromDateRetrieved', this.handleDataFromDateComplete);
    	this.on('uiChangeModuleTo', this.handleChangeModuleTo);
    	this.on('afterAfterInitialize', this.afterInitialize);
    	this.on('uiLogout', this.handleLogout);
    	this.on('uiResetForSync', this.handleLogout);
    	this.on('uiInitDataAfterSync', this.getDefaultDays);
    	//this.on('uiStartEditing', this.handleUiStartEditing);
    	this.on('uiUpdateDiary', this.handleUiUpdateDiary);
    	this.on('dataAccomplishmentUpdated', this.handleEntryUpdated);
    	this.on('dataAccomplishmentCreated', this.handleEntryCreated);
    	this.on('dataAccomplishmentDeleted', this.handleEntryDeleted);
    	this.on('uiReturnDateFromDatePicker', this.handleDateFromDatePicker);
    	
    	this.trigger('afterAfterInitialize');
    	
    	var thisComponent = this;
    	
    	this.$node.find('.subheader .datepicker').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.unbind('touchend');
    			$this.removeClass('active');
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');	
    			$('#special-controls .popup-datepicker').trigger('uiGetDatePickerPopup', {selector:'#edit'});
    			$this.unbind('touchend');
    		});
    	});
    	
    	this.$node.find('.subheader .forward-btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.unbind('touchend');
    			$this.removeClass('active');
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.swiper.swipeNext();
    			$this.unbind('touchend');
    		});
    	});
    	
    	this.$node.find('.subheader .backward-btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(){
    			$this.unbind('touchend');
    			$this.removeClass('active');
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.swiper.swipePrev(function(){});
    			$this.unbind('touchend');
    		});
    	});
    });
  }
}());