var InitEdit = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  var activeIndex = 2;
  var sliderTemplate = '<div class="no-data" style="display:block;">Für diesen Tag wurden noch keine Verrichtungen erfasst.</div><div class="data-wrapper" style="display:none;"><div class="time-wrapper morning row"><header>Morgens 6 - 12 Uhr</header></div><div class="time-wrapper noon row"><header>Mittags 12 - 14 Uhr</header></div><div class="time-wrapper afternoon row"><header>Nachmittags 14 - 18 Uhr</header></div><div class="time-wrapper evening row"><header>Abends 18 - 22 Uhr</header></div><div class="time-wrapper night row"><header>Nachts 22 - 6 Uhr</header></div></div>';
  var countOfSlidesToAdd = 2;
  var maxSwiperSlides = 9;
  var dateMode = {
      today : 'today',
      yesterday : 'yesterday',

      toggleDateMode : function(dateMode){
        if(dateMode === this.today){
          return this.yesterday;
        }else{
            return this.today;
        }
    }
  };


  return initEdit;

  /**
   * Module function
   */

  function getDurationString (duration){
	  var secHelper = duration % 60;

	  	if (secHelper > 0){
	  		var minHelper = Math.floor(duration / 60);
	  		return 'DAUER ' + minHelper + ' min ' + secHelper + ' sek';
	  	} else {
	  		return 'DAUER ' + duration/60 + ' min';
	  	}
  }

  function checkForTimeWrapperVisiblity($timeWrapper){
	  if ($timeWrapper.length > 0){
		  if (!$timeWrapper[0].querySelector('.entry')){
			  $timeWrapper.hide();
			  if ($timeWrapper.parent().find('.entry').length < 1){
				  $timeWrapper.parent().parent().find('.no-data').show();
			  }
		  }
	  }
  }

  // function addSlideAndInitDataCall(type, thisComponent, thresholdSlide, countOfRuns){
  //   var todayHelper = new Date(),
  //       classHelper = getClassHelperFromSlide(thresholdSlide),
  //       dateCategory = type === 'prepend' ? dateMode.yesterday : dateMode.today;
  //   classHelper = convertClassHelper(classHelper);
  //   for (var i = 0; i < countOfRuns; i++){
  //       thisComponent.swiper[type + 'Slide'](sliderTemplate, 'swiper-slide day-report ' + classHelper[0] + '-'  + ++classHelper[1]);
  //       utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.' + classHelper[0] + '-' + classHelper[1]));

  //       loadDataForDate(classHelper[0], todayHelper, classHelper[1]);
  //   }
  // }


  function prependSlides(thisComponent, thresholdSlide, iteration){
    var classHelper = getClassHelperFromSlide(thresholdSlide);
    classHelper = convertClassHelper(classHelper);
    for (var i = 0; i < iteration; i++){
      var classString = getNextClassHelperString(classHelper, 'prepend');
      classHelper = addSliderAndLoadData(thisComponent, classString, 'prepend');
    }
  }

  function appendSlides(thisComponent, thresholdSlide, iteration){
    var classHelper = getClassHelperFromSlide(thresholdSlide);
    classHelper = convertClassHelper(classHelper);
    for (var i = 0; i < iteration; i++){
      var classString = getNextClassHelperString(classHelper, 'append');
      classHelper = addSliderAndLoadData(thisComponent, classString, 'append');
    }
  }

  /**
  * this will add a new slider to the slider Stack
  * @param thisComponent : basicly a referece to this
  * @param classString: the Class String for the next Slider '(yesterday|today)[-0..n]'
  * @param type: to tell the method where the next slider is placed '(prepend|append)'
  * @return the classHelper String Array from the added slider ['(yesterday|today)', '(0..n)']
  **/

  function addSliderAndLoadData(thisComponent, classString, type){
    var slider = thisComponent.swiper[type + 'Slide'](sliderTemplate, 'swiper-slide day-report ' + classString)
    utils.touchScroll(document.querySelector('#edit .swiper-slide.day-report.' + classString));
    var classHelper = classString.split('-');
    var offset = classHelper[1] ? classHelper[1] : 0;
    loadDataForDate(classHelper[0], new Date(), offset);
    var newClassHelper = getClassHelperFromSlide(slider);
    return convertClassHelper(newClassHelper);
  }

  /**
  * This is where the magic happen...
  * this method is doing all the decitions to get the right next day class string
  * @param classHelper: the class string as an Array ['(yesterday|today)', '(0..n)']
  * @param mode: to tell the method where the next slider is placed before == 'prepend' after == 'append'
  * @return the Class String for the next Slider '(yesterday|today)[-0..n]'
  **/

  function getNextClassHelperString(classHelper, mode){
    var offset = parseInt(classHelper[1]),
    dayType = classHelper[0];
    if(mode === 'prepend'){
      if(offset === 0){
        if(dayType === dateMode.today){
          return dateMode.toggleDateMode(dayType);
        }
      }
      if(dayType === dateMode.yesterday){
        return dayType + '-' + ++classHelper[1];
      } else{
        if(offset === 1){
          return dayType;
        }
        return dayType + '-' + --offset;
      }
    }else{
      if(offset === 0){
        if(dayType === dateMode.yesterday){
          return dateMode.toggleDateMode(dayType);
        }
      }
      if(dayType === dateMode.yesterday){
        if(offset === 1){
          return dayType;
        }
        return dayType + '-' + --offset;
      } else{
        return dayType + '-' + ++offset;
      }
    }
  }

/**
* little helper to get '(yesterday|today)-0' instead of '(yesterday|today)' for classHelper
* !important : use only in combine with the getNextClassHelperString method witch return the right string
**/
  function convertClassHelper(classHelper){
    classHelper = classHelper.split('-');
    if(!classHelper[1]){
      classHelper[1] = 0;
    }
    return classHelper;
  }

  function setUpDefaultDays(thisComponent){
    var swiper = thisComponent.swiper;
    console.log(swiper.slides);
    for (var i = swiper.slides.length; i > 3; i--){      
      // $(this.swiper.slides[i]).remove();
      swiper.removeSlide(i);
      // thisComponent.swiper.slides[i].parentNode.removeChild(thisComponent.swiper.slides[i]);
    }
    console.log(swiper.slides);
    swiper.slides[0].className= 'swiper-slide day-report yesterday-1';
    swiper.slides[0].removeAttribute('data-date');
    swiper.slides[1].className= 'swiper-slide day-report yesterday';
    swiper.slides[1].removeAttribute('data-date');
    swiper.slides[2].className= 'swiper-slide day-report today';
    swiper.slides[2].removeAttribute('data-date');
    swiper.slides[3].className= 'swiper-slide day-report today-1';
    swiper.slides[3].removeAttribute('data-date');
    // thisComponent.swiper.slides[4].className= 'swiper-slide day-report today-2';
    // thisComponent.swiper.slides[4].removeAttribute('data-date');
    thisComponent.$node.find('.entry').remove();

    swiper.swipeTo(2,0,false);

    thisComponent.getDefaultDays();
  }

  function cleanSwiperStack(swiper, numberOfSlidesAroundActive){
    var activeIndex = swiper.activeIndex;
    var activeSlide = swiper.slides[activeIndex];
    var newActiveIndex = numberOfSlidesAroundActive;
    // var swiper = thisComponent.swiper;
    var saveSlides = new Array();
    //extract active and save slides
    for (var i = (activeIndex - numberOfSlidesAroundActive); i <= (activeIndex + numberOfSlidesAroundActive); i++) {
      if(i >= 0 && i < swiper.slides.length){
        var saveSlidesLength = saveSlides.push(swiper.slides[i]);
        if(activeSlide === swiper.slides[i]){
          newActiveIndex = saveSlidesLength - 1;
        }
      }
    };
    console.log(saveSlides);
    var i = 0;
    while(i < swiper.slides.length){
      if(utils.isObjectInArray(saveSlides, swiper.slides[i])){
        i++;
      }else{
        swiper.removeSlide(i);
      }
    }
    swiper.swipeTo(newActiveIndex, 0);
  }

  function buildSwiper(thisComponent){
        thisComponent.swiper = new Swiper('#edit .swiper-container',{
        //Your options here:
        mode : 'horizontal',
        slidesPerView : '1',
        initialSlide : 2,
        followFinger : true,
        speed : 300,
        onFirstInit : function(swiper){
          swiper.activeIndex = 2;
          swiper.swipeTo(activeIndex, 0, false);        
        },
        onSlideChangeStart: function(swiper, direction){
          var activeIndex = swiper.activeIndex;
          var activeSlide = swiper.slides[activeIndex];
          var sliderStack = swiper.slides;
          var dateString = utils.getDateString(new Date());

          thisComponent.swiperDirection = direction          

          if(activeIndex >= sliderStack.length-2){ // check if slider is the last in the stack
            appendSlides(thisComponent, sliderStack[sliderStack.length-1], countOfSlidesToAdd);//if so append two slides
            swiper.swipeTo(activeIndex, 0);
          }
          else if(activeIndex < 2){ //chkeck if slider is the first or second in stack
            prependSlides(thisComponent, sliderStack[0], countOfSlidesToAdd); // if so prepend two slides
            activeIndex += countOfSlidesToAdd;
            swiper.activeIndex = activeIndex;
            swiper.swipeTo(activeIndex, 0, false); // and swipe to the new active Position
          }
          if(activeSlide.getAttribute('data-date')){
            var date = new Date(activeSlide.getAttribute('data-date')); // get the date from the Slider
            dateString = utils.getDateString(date);
          }
          triggerDataUpdate(sliderStack[activeIndex]);
          thisComponent.$node.find('.current-view-date').html(dateString);
        },

        onSlideChangeEnd : function(swiper, direction){ 
          // clean stack 
          if(swiper.slides.length > maxSwiperSlides){

            cleanSwiperStack(swiper, countOfSlidesToAdd);
          }
        }
      });
}

  function triggerDataUpdate(slider, type){
    var classHelper = getClassHelperFromSlide(slider);
    var currentDate = new Date();
    var dayGap = utils.getDaysGap(currentDate, slider.getAttribute('data-date'));
    var startDate, endDate;
    $(slider).find('.no-date').show();
    $(slider).find('.data-wrapper').hide();
    if(dayGap < 0){
      dayGap = dayGap * -1;
      startDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() - dayGap );
      endDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() - (dayGap - 1));

    }else{
      startDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + dayGap);
      endDate =  new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + dayGap + 1);
    }
    if(!type){
      $(document).trigger('dataGetDataFromDate', {
        start: startDate,
        end: endDate,
        key: classHelper,
        type: 'update'
      });
    }else{
      $(document).trigger('dataGetDataFromDate', {
        start: startDate,
        end: endDate,
        key: classHelper,
      });
    }
  }

  function getClassHelperFromSlide(slider){
    var pattern = /((yester|to)day)(-([/d]+))*/;
    var classes = slider.className.split(' ');
    for(var i = 0; i < classes.length; i++){
      if(classes[i].match(pattern)){
        return classes[i];
      }
    }
  }

  /**
   *  Params
   *    type: STRING - 'today' oder 'yesterday'
   *    todayHelper: DATA - referenz date object
   *    offset: STRING or NUMBER
   */

  function loadDataForDate(type, todayHelper, offset){
    var startDate,
        endDate,
        key;


    offset = parseInt(offset);
    key = type + '-' + offset;
    if(!offset || offset === 0){
      key = type;
    }

    if (type === dateMode.today){
        startDate = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + offset);
        endDate = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + offset + 1);
    } else {
        startDate = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - offset -1);
        endDate = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - offset);
    }

    $(document).trigger('dataGetDataFromDate', {
        start: startDate,
        end: endDate,
        key: key
    });
  }

  function initEdit() {
    this.defaultAttrs({});

    this.handleDataFromDateComplete = function(evt, data){
    	if (data.type === 'update'){
    		this.handleDataFromDateUpdate(evt, data);
    	} else {
    		if (this.swiper && !document.querySelector('.' + data.key) && (data.key.match('today') || this.swiper.slides[this.swiper.slides.length-1].className.split(' ')[2].split('-')[0] === 'yesterday')){
    			this.swiper.appendSlide(sliderTemplate, 'swiper-slide day-report ' + data.key);
                if (this.swiper.slides.length > 9){
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.removeSlide(0);
                    this.swiper.swipeTo(4, 0, false);
                }
    		}

	    	for (var i = 0; i < data.items.length; i++){
	    		this.createEntry(data.items[i], '.swiper-slide.' + data.key);
	    	}

	    	this.$node.find('.swiper-slide.' + data.key).attr('data-date', data.dateHelper);

	    	var timeWrapperHelper = this.$node.find('.time-wrapper');
	    	$(timeWrapperHelper).show();
	    	for (var i = 0; i < timeWrapperHelper.length; i++){
	    		if (!timeWrapperHelper[i].querySelector('.entry')){
	    			$(timeWrapperHelper[i]).hide();
	    		}
	    	}

	    	this.$node.find('.no-data').hide();

	    	var slideNoDataHelper = document.querySelectorAll('#edit .day-report');

	    	for (var i = 0; i < slideNoDataHelper.length; i++){
	    		if (!slideNoDataHelper[i].querySelector('.entry')){
	        		$(slideNoDataHelper[i].querySelector('.no-data')).show();
	        	}
	    	}
	    	this.$node.find('.spinner-overlay').hide();
    	}
    };

    this.handleDataFromDateUpdate = function(evt, data){
    	for (var i = 0; i < data.items.length; i++){
    		this.updateEntry(data.items[i], '.swiper-slide.' + data.key);
    	}
    };

    this.updateEntry = function(data, selector){
      console.log(data);
      var slider = $(selector);
    	var $entry = slider.find('#a' + data.mmRequestId); 
    	// var $entry = slider.getElementById(data.mmRequestId);
    	if ($entry.length === 0){
    		this.createEntry(data, selector, 'update');

    	} else if ($entry.attr('data-db-modified') !== data.modified){

    	}
      slider.find('.no-data').hide();
    	this.$node.find('.data-wrapper').show();

    	var timeWrapperHelper = this.$node.find('.time-wrapper');
    	$(timeWrapperHelper).show();
    	for (var i = 0; i < timeWrapperHelper.length; i++){
    		if (!timeWrapperHelper[i].querySelector('.entry')){
    			$(timeWrapperHelper[i]).hide();
    		}
    	}
    };

    this.afterInitialize = function(){

    	if (localStorage.getItem('localData')){
    		$(document).trigger('dataGetDataFromDate');
    		this.$node.find('.spinner-overlay').show();
    	} else {
    		this.$node.find('.no-data').show();
    		this.$node.find('.time-wrapper').hide();
    	}
    	this.$node.find('.current-view-date').html(utils.getDateString(new Date()));
      // setUpDefaultDays(this);
    };

    this.createEntry = function(data, selector, mode){

    	var dateHelper = new Date (data.Accomplishment.start_time);
    	var typeHelper = typesIndex.accomplishmentTypes[data.Accomplishment.accomplishment_type_id].AccomplishmentType;
    	var entryHelper = document.createElement('div');
    	entryHelper.className = 'row entry';
    	entryHelper.id = 'a' + data.mmRequestId;
    	entryHelper.setAttribute('data-db-modified', (data.modified ? data.modified : 0));
    	//entryHelper.setAttribute('data-db-key', data.key);
    	entryHelper.setAttribute('data-start-time', data.Accomplishment.start_time);
    	entryHelper.setAttribute('data-server-id', data.Accomplishment.id);

    	var categoryHelper = document.createElement('div');
    	categoryHelper.className = 'col-xs-2 category-marker category-' + subcategoriesIndex.accomplishmentSubcategories[typeHelper.accomplishment_subcategory_id].AccomplishmentSubcategory.accomplishment_category_id;

    	var startTimeHelper = document.createElement('div');
    	startTimeHelper.className = 'start_time row';
    	startTimeHelper.innerHTML = utils.getTimeString(dateHelper);
    	categoryHelper.appendChild(startTimeHelper);

    	entryHelper.appendChild(categoryHelper);

    	var dashboardHelper = document.createElement('div');
    	dashboardHelper.className = 'dashboard col-xs-9';

    	var ratingHelper = document.createElement('div');

    	if (data.Accomplishment.duration === '0' || data.Accomplishment.assistance_type === "ASSISTANCE_TYPE_UNDEFINED"){
    		ratingHelper.className = 'ui-icon col-xs-1 complete-state complete-state-not-ready';
    		ratingHelper.innerHTML = '&#xe806;';
    	} else {
    		ratingHelper.className = 'ui-icon col-xs-1 complete-state complete-state-ready';
    		ratingHelper.innerHTML = '&#xe805;';
    	}

    	dashboardHelper.appendChild(ratingHelper);

    	var titleHelper = document.createElement('div');
    	titleHelper.className = 'title col-xs-11';
    	titleHelper.innerHTML = typeHelper.short_name ? typeHelper.short_name : typeHelper.name;
    	dashboardHelper.appendChild(titleHelper);

    	var timeHelper = document.createElement('div');
    	timeHelper.className = 'ui-icon ui-blue col-xs-1 time_rating';
    	if (!typeHelper.individual_standard_duration){
    		var durationHelper = parseInt(data.Accomplishment.duration),
    			minHelper = parseInt(typeHelper.standard_duration_min)-1,
    			maxHelper = parseInt(typeHelper.standard_duration_max)+1;
    		if ((durationHelper > minHelper) && (durationHelper < maxHelper)){
    			timeHelper.innerHTML = '&#xe801;';
    		} else {
    			if (durationHelper > maxHelper){
    				timeHelper.innerHTML = '&#xe802;';
    			} else {
    				timeHelper.innerHTML = '&#xe800;';
    			}
    		}
    	}
    	dashboardHelper.appendChild(timeHelper);

    	var durationHelper = document.createElement('div');
    	durationHelper.className = 'ui-text ui-blue col-xs-11 duration';
    	durationHelper.innerHTML = getDurationString(data.Accomplishment.duration);

    	dashboardHelper.appendChild(durationHelper);

    	entryHelper.appendChild(dashboardHelper);

    	var helpHelper = document.createElement('div');
    	helpHelper.className = 'ui-icon ui-help';
    	helpHelper.innerHTML = '&#xe80f;';
    	entryHelper.appendChild(helpHelper);

    	$(entryHelper).bind('touchstart', function(evt){

    		var $this = $(this);
    		$this.addClass('active');

    		$this.bind('touchmove',function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.removeClass('active');
      			$this.unbind('touchend');
          }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
          $(document).trigger('setCurrentScreen', constants.moduleEditing());
    			$('#editing').trigger('dataGetSingleRecordCompleted', data);
    		});

    	});

    	if (mode === 'update'){
    		var existingEntries = this.$node.find(selector + ' .' + this.getTimeRange(dateHelper) + ' .entry .start_time');

    		var newEntryTime = startTimeHelper.innerHTML.replace(/:/, '');

    		if (existingEntries.length === 0){
    			this.$node.find(selector + ' .' + this.getTimeRange(dateHelper)).show().append(entryHelper);
    		} else {
    			for (var i = 0; i < existingEntries.length; i++){
	    			var compareTime =  $(existingEntries[i]).text().replace(/:/, '');

	    			if (compareTime > newEntryTime){
	    				$(existingEntries[i]).parent().parent().before(entryHelper);
	    				break;
	    			}

	    			if (existingEntries.length === i + 1){
	    				$(existingEntries[i]).parent().parent().after(entryHelper);
	    			}
	    		}
    		}


    	} else {
    		this.$node.find(selector + ' .' + this.getTimeRange(dateHelper)).append(entryHelper);
    	}
    	var timeWrapperHelper = this.$node.find('.time-wrapper');
    	$(timeWrapperHelper).show();
    	for (var i = 0; i < timeWrapperHelper.length; i++){
    		if (!timeWrapperHelper[i].querySelector('.entry')){
    			$(timeWrapperHelper[i]).hide();
    		}
    	}

    	this.$node.find('.no-data').hide();

    	var slideNoDataHelper = document.querySelectorAll('#edit .day-report');

    	for (var i = 0; i < slideNoDataHelper.length; i++){
    		if (!slideNoDataHelper[i].querySelector('.entry')){
        		$(slideNoDataHelper[i].querySelector('.no-data')).show();
        	}
    	}
    	$(selector + ' .data-wrapper').show();

    };

    this.getTimeRange = function(date){

    	var returnHelper;

    	var timeHelper = date.getHours() + '' + (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());

    	if (timeHelper >= 600 && timeHelper < 1200){
    		return 'morning';
    	}

    	if (timeHelper >= 1200 && timeHelper < 1400){
    		return 'noon';
    	}

    	if (timeHelper >= 1400 && timeHelper < 1800){
    		return 'afternoon';
    	}

    	if (timeHelper >= 1800 && timeHelper < 2200){
    		return 'evening';
    	}

    	if (timeHelper >= 2200 && timeHelper < 2400 || timeHelper >= 0 && timeHelper < 600){
    		return 'night';
    	}

    };

    this.handleChangeModuleTo = function(evt, data){

    	var thisComponent = this;

    	if (!this.swiper){
        buildSwiper(thisComponent);
    		// this.destroy();
    	}
  		$('#diary .swiper-container').height(window.innerHeight - 47 - 34);
      cleanSwiperStack(this.swiper, 2);
      // setUpDefaultDays(thisComponent);
      thisComponent.notifyDataSetChanged();

    };

    this.handleUiUpdateDiary = function(){
      this.notifyDataSetChanged();
    };

    this.destroy = function(){
    	if (this.swiper.destroy){
    		activeIndex = this.swiper.activeIndex;
    		this.swiper.destroy();
  			$('#edit .swiper-slide-duplicate').remove();
  			$('#edit .swiper-wrapper').attr('style', '');
  			$('#edit .day-report').attr('style', '');
  		} else {
  			activeIndex = 2;
  		}
    };

    this.handleEntryCreated = function(evt, data){
    	var gapHelper = utils.getDaysGap(data.items.Accomplishment.start_time) * -1;
    	if (gapHelper === 0 ){
    		this.createEntry(data.items, '.today', 'update');
    		this.$node.find('.today .no-data').hide();
    	} else {
    		if (gapHelper > 0){
    			if (document.querySelector('#edit .today-' + gapHelper)){
    				this.createEntry(data.items, '.today-' + gapHelper, 'update');
    				this.$node.find('.today-' + gapHelper + ' .no-data').hide();
    			}
    		} else {
    			if (gapHelper < -1){
    				if (document.querySelector('#edit .yesterday-' + ++gapHelper)){
        				this.createEntry(data.items, '.yesterday-' + ++gapHelper, 'update');
        				this.$node.find('.yesterday-' + ++gapHelper + ' .no-data').hide();
        			}
    			} else {
    				if (gapHelper === -1){
    					this.createEntry(data.items, '.yesterday', 'update');
    					this.$node.find('.yesterday .no-data').hide();
    				}
    			}
    		}
    	}

    	this.$node.find('.spinner-overlay').hide();
    };

    this.handleEntryUpdated = function(evt, data){
    	var $entry = this.$node.find('#a' + data.items.mmRequestId);
    	var typeHelper = typesIndex.accomplishmentTypes[data.items.Accomplishment.accomplishment_type_id ? data.items.Accomplishment.accomplishment_type_id : 2].AccomplishmentType;
    	if ($entry.attr('data-start-time') !== data.items.Accomplishment.start_time){
    		checkForTimeWrapperVisiblity($entry.parent());
    		$entry.remove();
    		this.handleEntryCreated(evt, data);
    	} else {
        	$entry.find('.dashboard .title').html(typeHelper.short_name ? typeHelper.short_name : typeHelper.name);
        	$entry.find('.dashboard .duration').html(getDurationString(data.items.Accomplishment.duration));
    	}

    	if (data.items.Accomplishment.duration === 0 || data.items.Accomplishment.assistance_type === "ASSISTANCE_TYPE_UNDEFINED"){
    		$entry.find('.dashboard .complete-state').html('&#xe806;').attr('class', 'ui-icon col-xs-1 complete-state complete-state-not-ready');
    	} else {
    		$entry.find('.dashboard .complete-state').html('&#xe805;').attr('class', 'ui-icon col-xs-1 complete-state complete-state-ready');
    	}


    	if (!typeHelper.individual_standard_duration){
    		if (data.items.Accomplishment.duration >= typeHelper.standard_duration_min && data.items.Accomplishment.duration <= typeHelper.standard_duration_max){
    			$entry.find('.time_rating').html('&#xe801');
    		} else {
    			if (data.items.Accomplishment.duration > typeHelper.standard_duration_max){
    				$entry.find('.time_rating').html('&#xe802');
    			} else {
    				$entry.find('.time_rating').html('&#xe800');
    			}
    		}
    	}

    	$entry.unbind('touchstart').bind('touchstart', function(evt){

    		var $this = $(this);

    		$this.bind('touchmove',function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
          }
    		});

    		$this.bind('touchend', function(){
    			$('#editing').trigger('dataGetSingleRecordCompleted', data.items);
          $(document).trigger('setCurrentScreen', constants.moduleEditing());
    		});

    	});

    	this.$node.find('.spinner-overlay').hide();

    };

    this.handleEntryDeleted = function(evt, data){
    	var $entry = this.$node.find('#a' + data.key);
    	var $timeWrapper = $entry.parent();
    	$entry.remove();
    	checkForTimeWrapperVisiblity($timeWrapper);

    	this.$node.find('.spinner-overlay').hide();
    };

    this.handleDateFromDatePicker = function(evt, data){
    	var todayHelper = new Date();
    	var	dateFromPicker = new Date(data.year, utils.getMonthFromName(data.month), data.day, '00', '00', '00');
    	var	daysGap = 0;
    	var	centerKey = 'yesterday';
    	var todayHelper = new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate(), '00', '00', '00');
    	var	thisComponent = this;
    	var daysGap = utils.getDaysGap(todayHelper, dateFromPicker);
    	if (daysGap > 0){
    		centerKey = 'today-' + (daysGap);
    	} else {
    		if (daysGap === 0){
    			centerKey = 'today';
    		} else {
    			if (daysGap !== -1){
        			centerKey = 'yesterday' + (daysGap + 1);
        		}
    		}
    	}
        /**
         *  Suche ob Slide mit entsprechenden Center Key schon exisitiert
         *  true: Springe zu diesem
         *  false: Swiper zurücksetzen und entsprechenden Daten laden
         */
    	if (this.$node.find('.' + centerKey).length === 1){

            /**
             * Prüfen auf yesterday abfangen und zusätzlich wenn Sprung zum letzten Slide,
             * weitere Slides hinzufügen, das swipen weiterhin möglich ist
             *
             */

            var slides = this.swiper.slides,
                targetSlide = this.$node[0].querySelector('.' + centerKey);

            for (var i = 0; i < slides.length; i++){

                if (slides[i] === targetSlide){
                  triggerDataUpdate(targetSlide);
                    if (i < 2){
                        // springe zum Ersten oder Zweiten und hänge 2 weitere Slider davor
                        // swipeTo ist async deswegen, wird das zu erst gecallt, deswegen wir zu i countOfSlidesToAdd hinzugerechnet

                        prependSlides(this, slides[0], countOfSlidesToAdd);
                        this.swiper.swipeTo(i + countOfSlidesToAdd, 0, true);
                        break;
                    }

                    if(i > slides.length - 2){
                        // hänge 2 weitere Slider an wenn slide dem letzten oder vorletzten Slide im Stack entspricht

                        appendSlides(this, targetSlide, countOfSlidesToAdd);
                    }
                    // springe zum i-ten Slide
                    this.swiper.swipeTo(i, 0, false);

                    break;
                }
    		}
    		this.$node.find('.current-view-date').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
    	}  else if (daysGap === 0) {// want to go to today, so clear stack and show default days
        
        for (var i = this.swiper.slides.length - 1; i > 3; i--){          
          // $(this.swiper.slides[i]).remove();
          this.swiper.removeSlide(i);
          // this.swiper.slides[i].parentNode.removeChild(this.swiper.slides[i]);
        }
        
        todayHelper = new Date();
        this.swiper.slides[0].className= 'swiper-slide day-report yesterday-1';
        this.swiper.slides[0].removeAttribute('data-date');
        this.swiper.slides[1].className= 'swiper-slide day-report yesterday';
        this.swiper.slides[1].removeAttribute('data-date');
        this.swiper.slides[2].className= 'swiper-slide day-report today';
        this.swiper.slides[2].removeAttribute('data-date');
        this.swiper.slides[3].className= 'swiper-slide day-report today-1';
        this.swiper.slides[3].removeAttribute('data-date');
        // this.swiper.slides[4].className= 'swiper-slide day-report today-2';
        // this.swiper.slides[4].removeAttribute('data-date');
        this.$node.find('.entry').remove();

        this.swiper.swipeTo(2,0,false);

        this.getDefaultDays();
        this.$node.find('.current-view-date').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
      } else { 
          var slides = this.swiper.slides;
          // wenn der gewünschte slider nicht im stack ist stack löschen und neu aufbauen
          // slider löschen:
          // this delete all sliders except off one
          for (var i = slides.length-1; i > 0; i--){
            // $(this.swiper.slides[i]).remove();
         //    slides[i].parentNode.removeChild(slides[i]);
    			  this.swiper.removeSlide(i);
    		  }

          // change the left slider to the wisched one, and remove the entry
          var activeSlide = slides[0];
          activeSlide.className = 'swiper-slide day-report ' + centerKey;
    			activeSlide.removeAttribute('data-date');
          this.$node.find('.entry').remove();
          activeSlide.setAttribute('data-date', dateFromPicker);
          //load Data for the active slide
          triggerDataUpdate(activeSlide, 'create');

          // prepend two slides
          prependSlides(this, activeSlide, countOfSlidesToAdd);
          // // append two slides
          appendSlides(this, activeSlide, countOfSlidesToAdd);
          // addSlideAndInitDataCall('append', this, activeSlide, countOfSlidesToAdd);

          // swipe to the second slide
          this.swiper.swipeTo(2, 0, false);
          this.$node.find('.current-view-date').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
      	}
    };

    this.handleLogout = function(){
    	this.$node.find('.spinner-overlay').show();
    	if (this.swiper){
    		for (var i = this.swiper.slides.length; i > 3; i--){
          this.swiper.removeSlide(i);
    		}
    		this.swiper.slides[0].className= 'swiper-slide day-report yesterday-1';
    		this.swiper.slides[0].removeAttribute('data-date');
    		this.swiper.slides[1].className= 'swiper-slide day-report yesterday';
    		this.swiper.slides[1].removeAttribute('data-date');
    		this.swiper.slides[2].className= 'swiper-slide day-report today';
    		this.swiper.slides[2].removeAttribute('data-date');
    		this.swiper.slides[3].className= 'swiper-slide day-report today-1';
    		this.swiper.slides[3].removeAttribute('data-date');
    	}
		this.$node.find('.entry').remove();
    };

    this.getDefaultDays = function () {

    	var todayHelper = new Date();

    	$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 2),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
			key: 'yesterday-1'
		});

		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - 1),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
			key: 'yesterday'
		});

		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
			key: 'today'
		});

		$(document).trigger('dataGetDataFromDate', {
			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 1),
			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
			key: 'today-1'
		});

    // $(document).trigger('dataGetDataFromDate', {
    //   start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 2),
    //   end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 3),
    //   key: 'today-2'
    // });


    };

    this.notifyDataSetChanged = function(){
      var thisComponent = this;
      var swiper = thisComponent.swiper;
      if(!swiper){
        return;
      }
      var activeSlides = swiper.slides;
      if(activeSlides){
        for (var i = 0; i < activeSlides.length; i++){
          if(activeSlides[i]){
            triggerDataUpdate(activeSlides[i]);
          }
        }
      }
    };

    this.after('initialize', function () {
    	this.on('dataAccomplishmentsFromDateRetrieved', this.handleDataFromDateComplete);
    	this.on('uiChangeModuleTo', this.handleChangeModuleTo);
    	this.on('afterAfterInitialize', this.afterInitialize);
    	this.on('uiLogout', this.handleLogout);
    	this.on('uiResetForSync', this.handleLogout);
    	this.on('uiInitDataAfterSync', this.getDefaultDays);
      // this.on('dataSetChangeUpdateSwiper', this.notifyDataSetChanged)
    	//this.on('uiStartEditing', this.handleUiStartEditing);
    	this.on('uiUpdateDiary', this.handleUiUpdateDiary);
    	this.on('dataAccomplishmentUpdated', this.handleEntryUpdated);
    	this.on('dataAccomplishmentCreated', this.handleEntryCreated);
    	this.on('dataAccomplishmentDeleted', this.handleEntryDeleted);
    	this.on('uiReturnDateFromDatePicker', this.handleDateFromDatePicker);

    	this.trigger('afterAfterInitialize');

    	var thisComponent = this;

    	this.$node.find('.subheader .datepicker').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			$('#special-controls .popup-datepicker').trigger('uiGetDatePickerPopup', {selector:'#edit'});
    			$this.unbind('touchend');
    		});
    	});

    	this.$node.find('.subheader .forward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');
          var nextIndex = thisComponent.swiper.activeIndex + 1;
          thisComponent.swiper.swipeTo(nextIndex, 0, true);
    			// thisComponent.swiper.swipeNext();
    			$this.unbind('touchend');
    		});
    	});

    	this.$node.find('.subheader .backward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');
          var prevIndex = thisComponent.swiper.activeIndex - 1;
          thisComponent.swiper.swipeTo(prevIndex, 0, true);
    			// thisComponent.swiper.swipePrev(function(){});
    			$this.unbind('touchend');
    		});
    	});
    });
  }
}());
