var InitExport = flight.component(function () {

  'use strict';

  var processCounter = 0,
  	  changeToModule = false,
  	  monthsArray = {'Jan':0, 'Feb':1, 'Mär':2, 'Apr':3, 'Mai':4, 'Jun':5, 'Jul':6, 'Aug':7, 'Sep':8, 'Okt':9, 'Nov':10, 'Dez':11};
// important parameters for Swiper
  var sliderTemplate; // defined in devHelper.js
  var countOfSlidesToAdd = 2;
  var maxSwiperSlides = 9;

  /**
   * Module exports
   */

  return initExport;

  /**
   * Module function
   */

	function getWeekSelectorStringForDate(compareDate, weekStartDate){
		var weekGap = utils.getWeeksGap(compareDate, weekStartDate);
		var weekSelector;
		////console.log(weekGap);
			if (weekGap === 0){
				weekSelector = 'week';
			} else {
				if (weekGap < 0){
					weekSelector = 'week' + weekGap;
				} else {
					weekSelector = 'week_' + weekGap;
				}
			}
			return weekSelector

	}

	function getClassHelperFromSlide(slider){
	    var pattern = /week/;
	    var classes = slider.className.split(' ');
	    for(var i = 0; i < classes.length; i++){
	      if(classes[i].match(pattern)){
	        return classes[i];
	      }
	    }
	  }

   function prependSlides(swiper, thresholdSlide, iteration){
   	var weekStartDate = new Date(thresholdSlide.getAttribute('week-start-date'));
    var slider = thresholdSlide;
    for (var i = 0; i < iteration; i++){    	
      weekStartDate.setDate(weekStartDate.getDate() - 7);
      var classString = getNextClassHelperString(slider, 'prepend');
      slider = addSlider(swiper, classString, 'prepend');
      slider.setAttribute('week-start-date', weekStartDate);
      loadWeekDateForSlide(slider);
    }
  }

  function appendSlides(swiper, thresholdSlide, iteration){
    var weekStartDate = new Date(thresholdSlide.getAttribute('week-start-date'));
    var slider = thresholdSlide;
    for (var i = 0; i < iteration; i++){
	  weekStartDate.setDate(weekStartDate.getDate() + 7);
      var classString = getNextClassHelperString(slider, 'append');
      ////console.log(classString);
      slider = addSlider(swiper, classString, 'append');
      slider.setAttribute('week-start-date', weekStartDate);
      loadWeekDateForSlide(slider);
    }
  }

  /**
  * this will add a new slider to the slider Stack
  * @param thisComponent : basicly a referece to this
  * @param classString: the Class String for the next Slider '(week)[(-|_)0..n]'
  * @param type: to tell the method where the next slider is placed '(prepend|append)'
  * @return the slider that was added
  **/

  function addSlider(swiper, classString, type){
    var slider = swiper[type + 'Slide'](sliderTemplate, 'swiper-slide ' + classString)
    utils.touchScroll(document.querySelector('#export .swiper-slide.' + classString));
    // createAccomplishmentNodes(slider);
    return slider;
  }

  /**
  * This is where the magic happen...
  * this method is doing all the decitions to get the right next day class string
  * @param slider: the current Slide
  * @param mode: to tell the method where the next slider is placed before == 'prepend' after == 'append'
  * @return the Class String for the next Slider '(yesterday|today)[-0..n]'
  **/

  function getNextClassHelperString(slider, mode){
  	var classHelper = getClassHelperFromSlide(slider);
	var offset;
	var separator;
    var pattern = /[-|_]/;
  	var isCurrentWeek = !classHelper.match(pattern);
  	if(isCurrentWeek){
  		return mode === 'prepend' ? 'week-1' : 'week_1';
  	}else{
  		if(classHelper.match('_')){ // is in past
  			separator = '_';
  		}else{ //is in futur
  			separator = '-';
  		}
  		offset = parseInt(classHelper.split(separator)[1]);
  		////console.log(offset);
  		if(mode === 'prepend'){
  			if(separator === '_'){
  				if(offset === 1){
  					return 'week';
  				}// past
  				return 'week' + separator + --offset;
  			}else{ // futur
				return 'week' + separator + ++offset;
  			}
  		}else{
  			if(separator === '-'){
  				if(offset === 1){
  					return 'week';
  				}
  				return 'week' + separator + --offset;
  			}else{
				return 'week' + separator + ++offset;
  			}
  		}
  	}
  }

  function loadWeekDateForSlide(slide){
  	var weekStartDate = new Date(slide.getAttribute('week-start-date'));
  	var weedEndDate = new Date(weekStartDate);
  	weedEndDate.setDate(weedEndDate.getDate() + 7);

	$(slide).find('.category-wrapper').hide();
	$(slide).find('.type').hide().removeClass('active');
	$(slide).find('.category-wrapper .subcategory').removeClass('active');
	$(slide).find('.no-data').show();

  $('#summary .spinner-overlay').show();
	$(document).trigger('dataGetWeekDataFromDate', {
		start: weekStartDate,
		end: weedEndDate,
		key: 'week'
	});
  }

  function setUpDefaultSwiperSlides(swiper){
  	var date = new Date();
  	var weekStartDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - date.getDay() + 1)
  	buildSwiperForDate(swiper, weekStartDate);
  }

  function buildSwiperForDate(swiper, date){
  	var countOfSlides = 1;
  	var currentDate = new Date();
  	var weekStartDate = new Date(date);
  	if(swiper.slides.length > 1){
  		for (var i = swiper.slides.length; i >= 1; i--){      
	      // $(this.swiper.slides[i]).remove();
	      swiper.removeSlide(i);
	      // thisComponent.swiper.slides[i].parentNode.removeChild(thisComponent.swiper.slides[i]);
	    }
  	} 
    cleanUpEntriesForSlide(swiper.slides[0]);

    swiper.slides[0].className = 'swiper-slide ' + getWeekSelectorStringForDate(currentDate, weekStartDate);
    swiper.slides[0].setAttribute('week-start-date', weekStartDate);
    loadWeekDateForSlide(swiper.slides[0]);

    appendSlides(swiper, swiper.slides[0], countOfSlides);
    prependSlides(swiper, swiper.slides[0], countOfSlides);

    swiper.swipeTo(countOfSlides, 0, true);
  }

  function cleanUpEntriesForSlide(slide){
  	var nodes = $(slide).find('.row:not(header)');
  	nodes.hide();
  	var valueNodes = $(slide).find('.value-inner');
  	valueNodes.html('0');
  	// for(var i in valueNodes){
  	// 	valueNodes[i].innerHTML = '0';
  	// }
  }

  function cleanSwiperStack(swiper, numberOfSlidesAroundActive){
    var activeIndex = swiper.activeIndex;
    var activeSlide = swiper.slides[activeIndex];
    var newActiveIndex = numberOfSlidesAroundActive;
    // var swiper = thisComponent.swiper;
    var saveSlides = new Array();
    //extract active and save slides
    for (var i = (activeIndex - numberOfSlidesAroundActive); i <= (activeIndex + numberOfSlidesAroundActive); i++) {
      if(i >= 0 && i < swiper.slides.length){
        var saveSlidesLength = saveSlides.push(swiper.slides[i]);
        if(activeSlide === swiper.slides[i]){
          newActiveIndex = saveSlidesLength - 1;
        }
      }
    };
    ////console.log(saveSlides);
    var i = 0;
    while(i < swiper.slides.length){
      if(utils.isObjectInArray(saveSlides, swiper.slides[i])){
        i++;
      }else{
        swiper.removeSlide(i);
      }
    }
    swiper.swipeTo(newActiveIndex, 0);
  }

  function buildSwiper(thisComponent){
  		thisComponent.swiper = new Swiper('#summary .swiper-container',{
	    //Your options here:
	    mode:'horizontal',
	    initialSlide: 2,
	    speed: 300,
    	onFirstInit: function(swiper){
			$(document).trigger('setCurrentScreen', {module: '#export', view: '#summary'});
			// swiper.swipeTo(2, 0);
    	},

	    onSlideChangeEnd: function(swiper, direction){
    		if(swiper.slides.length > maxSwiperSlides){
            	cleanSwiperStack(swiper, countOfSlidesToAdd);
          	}
	    	// if (parseInt($('#summary .swiper-wrapper').css('-webkit-transform').split(',')[4]) === 0){
	    	// 	swiper.swipeTo(1, 0);
	    	// }
	    },
	    onSlideChangeStart: function(swiper){
	    	var sliderStack = swiper.slides;
	    	var activeIndex = swiper.activeIndex;
    		var activeSlide = swiper.slides[activeIndex];

    		if(activeIndex >= sliderStack.length-2){ // check if slider is the last in the stack
	            appendSlides(swiper, sliderStack[sliderStack.length-1], countOfSlidesToAdd);//if so append two slides
	            swiper.swipeTo(activeIndex, 0, false);
	        }
	        else if(activeIndex < 2){ //chkeck if slider is the first or second in stack
	            prependSlides(swiper, sliderStack[0], countOfSlidesToAdd); // if so prepend two slides
	            activeIndex += countOfSlidesToAdd;
	            swiper.activeIndex = activeIndex;
	            swiper.swipeTo(activeIndex, 0, false); // and swipe to the new active Position
	        }

	        var weekStartDate = new Date(swiper.slides[activeIndex].getAttribute('week-start-date'));

	        thisComponent.orientationDate = weekStartDate;
	        // loadWeekDateForSlide(swiper.slides[activeIndex]);

	        thisComponent.$node.find('.current-view-week').html(utils.getWeekString(weekStartDate));

	        if ($(swiper.slides[activeIndex]).hasClass('selection-data-not-complete')){
	    		thisComponent.$node.find('#summary .subheader .data-not-complete').show();
	    	} else {
	    		thisComponent.$node.find('#summary .subheader .data-not-complete').hide();
	    	}
	    }
	});
	setUpDefaultSwiperSlides(thisComponent.swiper);
  }

  function initExport() {
    this.defaultAttrs({

    });

    this.handleDataFromWeekComplete = function(evt, data){
    	//console.log(data);
    	var thisComponent = this;
		if (data.items){

			this.$node.find('.no-db').hide();
			if(data.items.length === 0){
				return;
			}
			this.$node.find('.spinner-overlay').show();

			this.$node.find('#summary .data-wrapper').show();
			processCounter++;
			

			
			var weekStartDate = new Date(data.week_start_date);
			var itemMap = {};
			var weekSelector;

			// create an HashMap for the entries we have to show and sum durations in it

			for(var item in data.items){
				var accomplishment = data.items[item].Accomplishment;
				var accId = accomplishment.accomplishment_type_id;
				var duration;

				if(!weekSelector){
					var accDate = new Date(accomplishment.start_time)
					
					weekSelector = getWeekSelectorStringForDate(new Date(), weekStartDate);
				}
				
				if(accId in itemMap){
					duration = parseInt(itemMap[accId].duration);
					itemMap[accId].duration = duration + parseInt(accomplishment.duration);
				}else{
					itemMap[accId] = {duration : accomplishment.duration}
				} 

    			if (accomplishment.duration === 0 || accomplishment.assistance_type === "ASSISTANCE_TYPE_UNDEFINED"){
    				$('#summary .' + weekSelector).addClass('selection-data-not-complete');
    			}
			}

			for(var accId in itemMap){
				var $entry = $('#summary .' + weekSelector + ' .type-' + accId);
				if(accId <= 2){
					console.log('test');}
					
				$('#summary .' + weekSelector + ' .no-data').hide();
				$entry.show().addClass('active');
    			if ($entry.hasClass('type')){
    				var $parentHelper = $entry.parent().parent();    				
    				$parentHelper.show().parent().show();
    				var $value = $parentHelper.find('header .value-inner');
    				if($value){
    					var subCatWeekDuration = $value.html();
    					var mapDuration = Math.round(itemMap[accId].duration / 60);
    					if(subCatWeekDuration){
    						subCatWeekDuration = parseInt(subCatWeekDuration) + mapDuration;
    					}else{
    						subCatWeekDuration = mapDuration;
    					}
						$value.html(subCatWeekDuration);
    				}
    			} else {
    				$entry.parent().show();    					
    			}
    			var $value = $entry.find('.value-inner');
				if($value){
					$value.html(Math.round(itemMap[accId].duration / 60));
				}  				
			}


    		var subCatTitles = this.$node.find('#summary .subcategory > header .title');
      		var fontSize = Number(getComputedStyle(document.body,null).fontSize.replace(/[^\d]/g, ''));
    		for (var i = 0; i < subCatTitles.length; i++){
	            var subCatTitle = subCatTitles[i];
	            //check if textnode has two lines
    			if (utils.isTwoLinedText(subCatTitle)){
    				$(subCatTitle).addClass('two-lines');
    			}
    		}
    		this.$node.find('.type-wrapper').removeAttr('style');
    		if (this.$node.find('#summary .swiper-slide-active').hasClass('selection-data-not-complete')){
    			this.$node.find('#summary .subheader .data-not-complete').show();
    		} else {
    			this.$node.find('#summary .subheader .data-not-complete').hide();
    		}

    		var summarySlides = document.querySelectorAll('#summary .swiper-slide:not(.dummy)');

    		for (var i = 0; i < summarySlides.length; i++){
    			if ($(summarySlides[i]).find('.category-wrapper:visible').length === 0 && !$(summarySlides[i]).hasClass('selection-data-not-complete')){
    				summarySlides[i].querySelector('.no-data').style.display = 'block';
    			}
    		}
    		/*
    		var activeHelper = document.querySelectorAll('#summary .subcategory.active');

    		for (var i = 0; i < activeHelper.length; i++){
    			$(activeHelper[i]).parent().show().parent().show();//.prev().hide();
    		}

    		activeHelper = document.querySelectorAll('#summary .type.active');
    		for (var i = 0; i < activeHelper.length; i++){
    			$(activeHelper[i]).show().parent().parent().show().parent().show();//.prev().hide();
    		}
    		*/

    		processCounter--;
    		if (processCounter < 1){
    			this.$node.find('.spinner-overlay').hide();
    		}
		}
	changeToModule = false;
    }

    this.handleChangeModuleTo = function(evt, data){
    	$('#summary .swiper-container').show().height(window.innerHeight - 47 - 34 -34);

		if (!this.swiper){
			buildSwiper(this);
		}else{
      for (var index in this.swiper.slides){
        cleanUpEntriesForSlide(this.swiper.slides[index]);
        loadWeekDateForSlide(this.swiper.slides[index]);
      }
    }

  //   	$('#summary .swiper-slide').removeClass('selection-data-not-complete');

  //   	if (localStorage.getItem('localData')){
  //   		this.$node.find('.spinner-overlay').show();
		// 	var $weeksHelper = this.$node.find('#summary .swiper-slide:not(.dummy)');

		// 	this.$node.find('#summary .category-wrapper').hide();
		// 	this.$node.find('#summary  .type').hide().removeClass('active');
		// 	this.$node.find('#summary  .category-wrapper .subcategory').removeClass('active');

		// 	this.$node.find('.category-wrapper:not(.category-3) .type-2').remove();
		// 	this.$node.find('.category-wrapper.category-3 .subcategory:last-child .type-2').remove();
		// 	this.$node.find('.no-data').hide();
		// 	// //console.log('handleChangeToModule');
  //   		$('#summary .value-inner').text(0);

  //   		var subCatsHelper = document.querySelectorAll('#summary .type');

  //   		for (var i = 0; i < subCatsHelper.length; i++){
  //   			$(subCatsHelper[i]).each(function() {
  //   			    var attributes = this.attributes;
  //   			    var i = attributes.length;

  //   			    while( i-- ){
  //   			    	var attrName = attributes[i].name;

  //   			    	if (attrName !== 'class' && attrName !== 'data-type-id' && attrName !== 'style'){
  //   			    		this.removeAttributeNode(attributes[i]);
  //   			    	}
  //   			    }
  //   			});
  //   		}

  //   		var subCatsHelper = document.querySelectorAll('#summary .subcategory');

  //   		for (var i = 0; i < subCatsHelper.length; i++){
  //   			$(subCatsHelper[i]).each(function() {
  //   			    var attributes = this.attributes;
  //   			    var i = attributes.length;

  //   			    while( i-- ){
  //   			    	var attrName = attributes[i].name;

  //   			    	if (attrName !== 'class' && attrName !== 'data-type-id' && attrName !== 'style'){
  //   			    		this.removeAttributeNode(attributes[i]);
  //   			    	}
  //   			    }
  //   			});
  //   		}

  //   		changeToModule = true;
  //   		this.$node.find('#summary .data-wrapper').show();
		// 	if ($weeksHelper.length === 3){
		// 		$(document).trigger('dataGetWeekDataFromDate');
		// 	} else {
		// 		this.getDataForSpecificRange($weeksHelper, 'week');
		// 	}

  //   	} else {
  //   		this.$node.find('.no-data').show();
  //   		this.$node.find('#summary .data-wrapper').hide();
  //   	}
		// this.$node.find('#summary').show();
		// this.$node.find('#pflegestufe').hide();
		// if (!data){
		// 	this.trigger(document, 'saveToHistory', {module: '#export', view: '#summary'});
		// }
    }

    this.getDataForSpecificRange = function($weeksHelper, key){
    	// //console.log('getDataForSpecificRange');    	
    	if ($weeksHelper.length > 1){
    		var weeksBefore = $weeksHelper.first().attr('class').split(' ')[1].split('-')[1];
    		var weeksAfter = $weeksHelper.last().attr('class').split(' ')[1].split('_')[1];
    	} else {
    		if ($weeksHelper.hasClass('week')){
    			// //console.log('has week class');
    			var weeksBefore = 0;
    			var weeksAfter = 0;
    		} else {
    			var weekSelector = $weeksHelper.attr('class').split(' ')[1];
       			if (weekSelector.indexOf('-') !== -1){
    				weekSelector = parseInt(weekSelector.split('-')[1]);
    				weeksBefore = weekSelector;
    				weeksAfter = -2 + weekSelector;
    			} else {
    				weekSelector = parseInt(weekSelector.split('_')[1]);
    				weeksBefore = -2 + weekSelector;
    				weeksAfter = weekSelector;
    			}
    		}
    	}

    	if (this.orientationDate){
    		var todayHelper = new Date(this.orientationDate);
    		$(document).trigger('dataGetWeekDataFromDate', {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate()),//- (7*weeksBefore)),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() + 7),// + (7*weeksAfter)),
    			fromDatePicker: true
    		});
    	} else {
    		var todayHelper = new Date();
    		$(document).trigger('dataGetWeekDataFromDate', {
    			start: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() - todayHelper.getDay() + 1 - (7*weeksBefore)),
    			end: new Date(todayHelper.getFullYear(), todayHelper.getMonth(), todayHelper.getDate() +  8 - todayHelper.getDay() + (7*weeksAfter)),
    			key: key
    		});
    	}
    }

    this.afterInitialize = function(){

    	buildWeekSwiperTemplate();
    	sliderTemplate = weekSliderTemplate; // weeksliderTemplate is defined in devHelper.js
    	// make the default swiper useing the builded template
    	this.$node.find('#summary .swiper-slide').html(weekSliderTemplate);

		this.$node.find('.no-data').show();
		this.$node.find('#summary .data-wrapper').hide();

    	this.$node.find('.current-view-week').html(utils.getWeekString(new Date()));
    }

    this.destroyUi = function(evt, data){
    	if (this.swiper){
			this.swiper.destroy();
			$('#summary .swiper-slide-duplicate').remove();
			$('#summary .swiper-wrapper').attr('style', '');
		}
    	$('#summary .swiper-slide').removeClass('selection-data-not-complete');
    }

    this.handleDateFromDatePicker = function(evt, data){
    	var orientationDate = new Date(data.year, utils.getMonthFromName(data.month), data.day);
    	this.orientationDate = orientationDate;
    	buildSwiperForDate(this.swiper, orientationDate);
		var activeSlide = this.swiper.slides[this.swiper.activeIndex];
		var weekStartDate = new Date(activeSlide.getAttribute('week-start-date'));


    	this.$node.find('.current-view-week').html(utils.getWeekString(weekStartDate, 'free'));
    }

    this.doExport = function(evt, data){
    	if (!data){
    		var exportBody = JSON.parse(localStorage.getItem('exportBody'));
    		if (exportBody.CaredPerson.name === '' &&
    				exportBody.CaredPerson.name === '' &&
    				exportBody.CaredPerson.firstname === '' &&
    				exportBody.CaredPerson.birthdate === '' &&
    				exportBody.CaredPerson.street === '' &&
    				exportBody.CaredPerson.city === '' &&
    				exportBody.CaringPerson.name === '' &&
    				exportBody.CaringPerson.firstname === ''){
    			$('#profile').trigger('uiProfileDataNeeded');
    			return;
    		}
    	}


		this.$node.find('.spinner-overlay').show();

    	$(document).trigger('dataGetDataWithoutID');
		var weekEndDateObj = utils.getEndDateFromWeekString(this.$node.find('.current-view-week').text());
		var end = utils.getServerDateObject(weekEndDateObj);
		var oneWeekInMillSec = ((7*24*60*60*1000) - (1000));
		var start = utils.getServerDateObject(new Date(weekEndDateObj - oneWeekInMillSec));

    	$(document).trigger('dataDoGetRequest', {
			url: 'accomplishments/index.json?from=' + encodeURI(start) + '&to=' + encodeURI(end),
			headers: true,
			mmRequestId: 'dataSync',
			selector: document,
		    success: 'dataSyncSuccess',
		    error: 'dataSyncFailed',
		    data: ''
		});
    	processCounter++;
		$(document).trigger('dataDoPostRequest', {
			url: 'accomplishments/export.json?from=' + encodeURI(end) + '&to=' + encodeURI(start),
			headers: true,
			mmRequestId: 'export',
			selector: document,
		    success: 'dataDoGetExport',
		    error: 'dataPostExportFailed',
		    data: localStorage.getItem('exportBody')
		});
		$(document).trigger('dataDeleteRangeForSync', {start: start,end: end});
		$('#edit').trigger('uiResetForSync');
    }

    this.after('initialize', function () {    	
    	this.on('uiReturnDateFromDatePicker', this.handleDateFromDatePicker);
    	this.on('afterAfterInitialize', this.afterInitialize);
    	this.on('dataAccomplishmentsFromWeekRetrieved', this.handleDataFromWeekComplete);
    	this.on('uiChangeModuleTo', this.handleChangeModuleTo);
    	this.on('uiDoExport', this.doExport);
    	this.on('uiReset', this.destroyUi);
    	this.on('uiProcessComplete', function(){
    		processCounter--;
    		if (processCounter < 1){
    			$('#export .spinner-overlay').hide();
    		}
    	});

    	this.on(document, 'dataPostExportFailed', function(evt, data){
    		processCounter--;
    		if (processCounter < 1){
    			$('#export .spinner-overlay').hide();
    		}
    		$('#special-controls .overlay').show();
			$('#special-controls .popup-export-failed').show();
    	});

    	var thisComponent = this;

    	this.$node.find('.btn.export').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
    			if(utils.isTouchMove(evt, e)){
    				$this.removeClass('active');
    				$this.unbind('touchend');
    			} 
    		});

    		$this.unbind('touchend').bind('touchend', function(){

    			var exportBody = JSON.parse(localStorage.getItem('exportBody'));

    			if (exportBody.LifeConstraint.constraint_level === -1){
    				$this.removeClass('active');
    				$('#lifeConstraint').trigger('uiExportLifeconstraintNeeded', {flag:'from-export'});    				
    				return;
    			}
    			$this.removeClass('active');
    			thisComponent.doExport('default');
        	});
    	});

    	this.$node.find('.btn.calc-pflegestufe').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
    			if(utils.isTouchMove(evt, e)){
	    			$this.unbind('touchend');
	    			$this.removeClass('active');    				
    			}
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$(document).trigger('setCurrentScreen', {module: '#export', view: '#pflegestufe'});
    			$this.removeClass('active');
    			//var $visibleSlide = thisComponent.$node.find('.swiper-slide-active');
        		thisComponent.$node.find('.spinner-overlay').show();

        		// var dateHelper = thisComponent.$node.find('.current-view-week').text().split(' '),
        		var	dateObjHelper = utils.getStartDateFromWeekString(thisComponent.$node.find('.current-view-week').text());
        		// //console.log(dateObjHelper + 'string: ' + thisComponent.$node.find('.current-view-week').text());
        		$(document).trigger('dataGetWeekDataFromDate', {
        			start: new Date(dateObjHelper.getFullYear(), dateObjHelper.getMonth(), dateObjHelper.getDate()),
        			end: new Date(dateObjHelper.getFullYear(), dateObjHelper.getMonth(), dateObjHelper.getDate() +  7),
        			key: 'assessment'
        		});

        		$('#pflegestufe').show().trigger('showPflegestufe', {});
        		//thisComponent.$node.find('#summary').hide();
        	});

    	});

    	this.$node.find('.subheader .forward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
    			if(utils.isTouchMove(evt, e)){
    				$this.removeClass('active');
    				$this.unbind('touchend');
    			} 
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.swiper.swipeNext();
    			$this.unbind('touchend');
    		});

    	});

    	this.$node.find('.subheader .backward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
    			if(utils.isTouchMove(evt, e)){
    				$this.removeClass('active');
    				$this.unbind('touchend');
    			} 
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.swiper.swipePrev();
    			$this.unbind('touchend');
    		});

    	});

    	this.$node.find('.subheader .datepicker').unbind('touchstart').bind('touchstart', function(evt){
    		evt.stopPropagation();
    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove', function(e){
    			if(utils.isTouchMove(evt, e)){
    				$this.removeClass('active');
    				$this.unbind('touchend');
    			}    			
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$('#special-controls .popup-datepicker').trigger('uiGetDatePickerPopup', {selector:'#export'});
    		});
    	});


    	$('#special-controls .popup-export-failed .btn').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$this.parent().parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});
    	this.trigger('afterAfterInitialize');
    });
  }

}());
