var LifeConstraint = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return lifeConstraint;

  /**
   * Module function
   */

  function lifeConstraint() {
    this.defaultAttrs({

    });

    this.handleSignUpSuccess = function(event, data){
    	var thisComponent = this;
    	$('#special-controls .overlay').show();
    	$('#special-controls .popup-lifeConstraint').show().find('.btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(e){
                if(utils.isTouchMove(evt, e)){                    
                    $this.removeClass('active');
                    $this.unbind('touchend');
                }
    		});

    		$this.unbind('touchend').bind('touchend', function(){                
                $this.removeClass('active');
    			$('#special-controls .overlay').hide();
		    	$('#special-controls .popup-lifeConstraint').hide();
    			if ($this.attr('data-option') === 'yes'){
    				thisComponent.doChangeModule();
    				if (data && data.flag === 'from-export'){
    					thisComponent.$node.addClass('from-export');
    				}
    			} else {
    				 if (data && data.flag === 'from-export'){
    					$('#export').trigger('uiDoExport');
    				 }
    			}
    		});
    	});
    }

    this.doChangeModule = function(evt, data){

    	$('.module.container-fluid').hide();
    	$('#settings').show().find('.main').hide();
    	$('#lifeConstraint').show();
    	var naviHeight = utils.getMainNavigationHeight();
    	$('#lifeConstraint').css({height : (window.innerHeight - naviHeight) + 'px'});
      $('#lifeConstraint header').css({top: naviHeight + 'px'});

      var innerWrapperHeight = (window.innerHeight - (naviHeight + $('#lifeConstraint header').height() + 75));
      $('#lifeConstraint .inner-wrapper').css({height: innerWrapperHeight + 'px'});
    	$('.subcategories-wrapper').hide();
	    $('#capturing').attr('class', '').hide();
      $('#capture .category-overview').show();
	    $('#capturing .capture-property').trigger('uiReset', {key: 'capture'}).removeClass('active activated');
    	$('.subcategory .type-wrapper').height(0);

		$('#editing').attr('class', '').hide();
		$('#diary').show();
		$('#editing .capture-property').trigger('uiReset', {key: 'edit'}).removeClass('active activated');

		if (this.$node.find('footer .col-xs-6').length === 3){
			this.$node.find('footer .col-xs-6').first().removeClass('col-xs-6').addClass('col-xs-12');
		}

    }

    this.handleTouchCustomInput = function($this){

    	$this.next().removeClass('active');
    	$this.prev().removeClass('active');
    	$this.addClass('active');

    }

    this.showNextQuestion = function(){
    	var $activeHelper = this.$node.find('.question.visible');

    	if ($activeHelper.length === 0){
    		this.$node.find('.question').first().addClass('visible');
			this.$node.find('.teaser').hide();
			return;
    	}

    	if ($activeHelper.attr('id') !== 'lifeConstraint-12'){
    		$activeHelper.removeClass('visible');
    		$activeHelper.next().addClass('visible');

    		if ($activeHelper.attr('id') === 'lifeConstraint-11'){
    			this.$node.find('footer .btn-forward').text('Speichern');
    		}

    	} else {

    		var answers = this.$node.find('.question .active.col-xs-6'),
    			exportBody = JSON.parse(localStorage.getItem('exportBody'));

    		if (!exportBody){
    			$('#account').trigger('needProfileDataInit');
    			exportBody = JSON.parse(localStorage.getItem('exportBody'));
    		}

    		for(var i = 0; i < answers.length; i++){
    			var questionId = parseInt(answers[i].parentNode.parentNode.id.split('-')[1]) + 1;

    			if (questionId < 10){
    				questionId = '0' + questionId;
    			}

    			var answerVal = 0;
    			if (answers[i].querySelector('label').innerText === 'Ja'){
    				answerVal = 1;
    			}

    			exportBody.LifeConstraint['answer_q' + questionId] = answerVal;
    		}

    		if (answers.length === 13){
    			var constraintLevel = 0;
    			var countHelper = 0;

    			for (var answer in exportBody.LifeConstraint){
    				if (answer === 'answer_q10'){
    					break;
    				}
    				if (exportBody.LifeConstraint[answer] === 1){
    					countHelper++;
    				}
    			}

    			if (countHelper > 2){
    				for (var answer in exportBody.LifeConstraint){
        				if (answer === 'answer_q01' || answer === 'answer_q02' || answer === 'answer_q03' ||
        					answer === 'answer_q04' || answer === 'answer_q05' || answer === 'answer_q09' || answer === 'answer_q11'){

        					constraintLevel = 2;
        					break;
        				}
        			}
    			} else {
    				if (countHelper === 2){
    					constraintLevel = 1;
    				}
    			}
    		   	this.$node.removeClass('not-complete complete-1 complete-2 complete-0').addClass('complete-' + constraintLevel);

    		   	exportBody.LifeConstraint.constraint_level = constraintLevel;

    		   	if (this.$node.hasClass('from-export')){
    		   		this.$node.find('footer .col-xs-12').show().find('.btn').html('Antworten ändern');
    		   		this.$node.find('footer .col-xs-12').removeClass('col-xs-12').addClass('col-xs-6').show().after('<div class="col-xs-6"><div class="btn btn-default btn-back-to-export">Zum Export</div></div>');
    		   		this.$node.find('footer .btn-back-to-export').bind('touchstart', function(){
    		   				var $this = $(this);
				    		$this.addClass('active');

				    		$this.unbind('touchmove').bind('touchmove',function(){
				    			$this.removeClass('active');
				    			$this.unbind('touchend');
				    		});

				    		$this.unbind('touchend').bind('touchend', function(){
				    			$this.removeClass('active');
				    			$('#capture header .item:not(.item-extra)').last().trigger('touchstart').trigger('touchend');
				    			$this.parent().remove();
				    		});
    		   		});
    		   	}


    		}

    		this.$node.find('#lifeConstraint-result').show();
		   	this.$node.find('footer .col-xs-12').show().find('.btn').html('Antworten ändern');
		   	this.$node.find('footer .col-xs-6 .btn').last().html('Weiter');
		   	this.$node.find('.question').removeClass('visible');

		   	this.setSaveStartButton('constraint_level', exportBody);
    		localStorage.setItem('exportBody', JSON.stringify(exportBody));
    	}
    }

    this.showQuestionBefore = function(){
    	var $activeHelper = this.$node.find('.question.visible');

    	if ($activeHelper.length === 0){
    		this.$node.find('footer .col-xs-12').show().find('.btn').html('Antworten ändern');
    		this.$node.find('.teaser').hide();
    		this.$node.find('#lifeConstraint-result').show();
			return;
    	}

    	if ($activeHelper.attr('id') !== 'lifeConstraint-0'){
    		$activeHelper.removeClass('visible');
    		$activeHelper.prev().addClass('visible');
    		if ($activeHelper.attr('id') === 'lifeConstraint-12'){
    			this.$node.find('footer .btn-forward').text('Weiter');
    		}
    	} else {
    		$activeHelper.removeClass('visible');
			this.$node.find('.teaser').show();
			if (this.$node.hasClass('not-complete')){
				this.$node.find('footer .col-xs-12').show().find('.btn').html('Weiter');
			}
    	}
    }

    this.setSaveStartButton = function(answer, existingAnswersHelper){
    	var thisComponent = this;
    	if (answer === 'constraint_level' && existingAnswersHelper.LifeConstraint[answer] !== -1){
			thisComponent.$node.removeClass('not-complete').addClass('complete-' + existingAnswersHelper.LifeConstraint[answer]);
			thisComponent.$node.find('footer .col-xs-12 .btn').html('Antworten ändern').unbind('touchstart').bind('touchstart', function(){
	    		var $this = $(this);

	    		$this.addClass('active');

	    		$this.unbind('touchmove').bind('touchmove',function(){
	    			$this.removeClass('active');
	    			$this.unbind('touchend');
	    		});

	    		$this.unbind('touchend').bind('touchend', function(){
	    			$this.removeClass('active').html('Weiter');
	    			thisComponent.$node.find('.teaser').show();
	    			thisComponent.$node.find('#lifeConstraint-result').hide();
	    			thisComponent.$node.find('footer .col-xs-12').hide();
	    		});
	    	});
		} else {
	    	thisComponent.$node.find('footer .btn.btn-start').unbind('touchstart').bind('touchstart', function(){

	    		var $this = $(this);

	    		$this.addClass('active');

	    		$this.unbind('touchmove').bind('touchmove',function(){
	    			$this.removeClass('active');
	    			$this.unbind('touchend');
	    		});

	    		$this.unbind('touchend').bind('touchend', function(){
	    			$this.removeClass('active');
	    			if (thisComponent.$node.find('.teaser').is(':visible')){
	    				thisComponent.$node.find('.question').first().addClass('visible');
		    			thisComponent.$node.find('.teaser').hide();
		    			thisComponent.$node.find('footer .col-xs-6').show();
		    			thisComponent.$node.find('footer .col-xs-12').hide();
	    			} else {
	    				thisComponent.$node.find('.teaser').show();
	    				thisComponent.$node.find('#lifeConstraint-result').hide();
		    			thisComponent.$node.find('footer .col-xs-12').hide();
	    			}

	    		});
	    	});
		}

    }

    this.after('initialize', function () {
    	this.on('uiSignUpSuccess', this.handleSignUpSuccess);
    	this.on('uiExportLifeconstraintNeeded', this.handleSignUpSuccess);
    	this.on('uiDoChangeModule', this.doChangeModule);
    	var thisComponent = this;

    	this.$node.find('.custom-input').parent().bind('touchstart', function(){

    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			thisComponent.handleTouchCustomInput($this);
    		});

    	});

    	this.$node.find('footer .btn').bind('touchstart', function(){

    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			if ($this.attr('data-option') && $this.attr('data-option') === 'forward'){
    				thisComponent.showNextQuestion();
    			} else {
    				thisComponent.showQuestionBefore($this);
    			}
    		});

    	});

    	$('#extra-flyout .lifeConstraint').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			thisComponent.doChangeModule();
    			$('#extra-flyout').css('right', '-80%');
    			$('#special-controls .overlay-light').hide();
    		});
    	});

    	var existingAnswersHelper = JSON.parse(localStorage.getItem('exportBody'));

    	for (var answer in existingAnswersHelper.LifeConstraint){
    		if (existingAnswersHelper.LifeConstraint[answer] !== -1){
    			if (existingAnswersHelper.LifeConstraint[answer] === 1){
    				thisComponent.$node.find('#lifeConstraint-' + (-1 + parseInt(answer.split('q')[1])) + ' .input-elements > .col-xs-6').first().addClass('active');
    			} else {
    				thisComponent.$node.find('#lifeConstraint-' + (-1 + parseInt(answer.split('q')[1])) + ' .input-elements > .col-xs-6').last().addClass('active');
    			}
    		}
    		thisComponent.setSaveStartButton(answer, existingAnswersHelper);
   		}
    });

  }

}());
