var Login = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return login;

  /**
   * Module function
   */

  function login() {
    this.defaultAttrs({

    });

    this.handleUiDoLogin = function(){
    	localStorage.setItem('lastLoginEmail', this.$node.find('input[name="email"]').val());
    	$(document).trigger('dataClearAccomplishments');
    	
    	var postBody = JSON.stringify({
	    	User: {
	    		email: this.$node.find('input[name="email"]').val(),
	    		password: this.$node.find('input[name="password"]').val()
		}});
    	
    	$(document).trigger('dataDoPostRequest', {
			url: 'users/token.json',
			headers: false,
			mmRequestId: 'login', 
			selector: '#login',
		    success: 'loginSuccess',
		    error: 'loginFailed',
		    data: postBody
		});
    }
    
    
    this.handleLoginSuccess = function(evt, data){
    	localStorage.setItem('publicToken', data.User.api_public_token);
	    localStorage.setItem('privateToken', data.User.api_private_token);
	    
	    $(document).trigger('dataDoGetRequest', {
			url: 'accomplishments/index.json',
			headers: 'true',
			mmRequestId: 'dataGetAllRecords', 
			selector: document,
		    success: 'dataGetAllRecordsSuccess',
		    error: 'dataGetAllRecordsFailed'
		});
	    
	    this.$node.hide();
	    $('.module.container-fluid').hide();
	    $('#capture').show();
	    
	    $(document).trigger('dataDoGetRequest', {
			url: 'users/view.json',
			headers: 'true',
			mmRequestId: 'dataGetUser', 
			selector: '#login',
		    success: 'dataGetUserSuccess',
		    error: 'dataGetUserFailed'
		});
	    
		$(document).trigger('dataDoGetRequest', {
			url: 'help_chapters/index.json',
			headers: 'true',
			mmRequestId: 'dataGetHelpFull', 
			selector: '#help',
		    success: 'dataHandleGetHelpFullSuccess',
		    error: 'dataHandleGetHelpFullFailed'
		});
		$(document).trigger('dataDoGetRequest', {
			url: 'help_articles/index_list.json',
			headers: 'true',
			mmRequestId: 'dataGetHelpArticlesList', 
			selector: '#help',
		    success: 'dataHandleGetArticlesListSuccess',
		    error: 'dataHandleGetArticlesListFailed'
		});
		
		this.$node.find('.passwort input').val('');
		this.$node.find('.advice p').hide();
	    
    }
    
    this.handleLoginFailed = function(evt, data){
    	this.$node.find('.advice p').hide();
    	this.$node.find('.advice .error').show();
    }
    
    this.handleGetUserSuccess = function(evt, data){
    	localStorage.setItem('userData', JSON.stringify(data));
    }
    
    this.handleGetUserFailed = function(evt, data){
    }
    
    this.handleCheckTokensFailed = function(){
    	this.$node.find('.advice p').hide();
    	this.$node.find('.advice .notice').show();
    	this.$node.show();
    	this.$node.find('input').first().focus();
    	
    	localStorage.setItem('publicToken', '');
	    localStorage.setItem('privateToken', '');
    }
    
    this.handleCheckTokensSuccess = function(){
    	$(document).trigger('dataCheckDataVersion');
    	$(document).trigger('dataGetDataWithoutID');
    }
    
    this.setPasswordForgetLink = function(){

    	var thisComponent = this;
    	
    	this.$node.find('#passwort-forget').text('Haben Sie Ihr Passwort vergessen?').css('color', '').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.unbind('touchend');
    			var userDataHelper = JSON.parse(localStorage.getItem('userData'));
    			
    			$(document).trigger('dataDoPutRequest', {
    				url: 'users/reset_password.json',
    				headers: true,
    				openMethod: true,
    				mmRequestId: 'resetpasswort', 
    				selector: '#login',
    			    success: 'resetPasswordSuccess',
    			    error: 'resetPasswordFailed',
    			    data: JSON.stringify({
    			    	User: {
    			    		email: thisComponent.$node.find('input[name="email"]').val()
    	    		}})
    			});
    			
    			$this.text('Neues Passwort wurde beantragt.').css('color', '#999');
    			thisComponent.$node.find('.advice p').hide();
        		thisComponent.$node.find('.reset-password-working').show();
    			
    		});
    	});
    }
    
    this.after('initialize', function () {
    
    	var thisComponent = this;
    	
    	this.on('uiDoLogin', this.handleUiDoLogin);
    	this.on('loginFailed', this.handleLoginFailed);
    	this.on('loginSuccess', this.handleLoginSuccess);
    	this.on('dataGetUserFailed', this.handleGetUserFailed);
    	this.on('dataGetUserSuccess', this.handleGetUserSuccess);
    	this.on('uiCheckTokensFailed', this.handleCheckTokensFailed);
    	this.on('uiCheckTokensSuccess', this.handleCheckTokensSuccess);
    	
    	if (localStorage.getItem('privateToken') && localStorage.getItem('publicToken')){
    		
    		$(document).trigger('dataDoGetRequest', {
    			url: 'users/check.json',
    			headers: 'true',
    			mmRequestId: 'checkTokens', 
    			selector: '#login',
    		    success: 'uiCheckTokensSuccess',
    		    error: 'uiCheckTokensFailed'
    		});
    		
    	} else {
    		this.$node.show();
    		this.$node.find('input').first().focus();
    	}
    	
    	this.$node.find('.btn-sign-up').bind('touchstart', function(){
    		
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$('#signUp').trigger('uiPrepareSignUp');
    		});
    		
    	});
    	
    	this.$node.find('.btn-forward').bind('touchstart', function(){
    		
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    		});
    		
    		thisComponent.trigger('uiDoLogin');
    	});
    	
    	$('#login input[name="password"]').keyup(function(evt){
    		if (evt.keyCode === 13){
    			thisComponent.trigger('uiDoLogin');
    		}
    	});
    	var preFill = localStorage.getItem('lastLoginEmail') ? localStorage.getItem('lastLoginEmail') : '';
    	
    	this.$node.find('input[name="email"]').val(preFill).focus().select();
    	
    	this.setPasswordForgetLink();
    	
    	this.on('resetPasswordSuccess', function(){
    		thisComponent.$node.find('.advice p').hide();
    		thisComponent.$node.find('.success-reset-password').show();
    		this.setPasswordForgetLink();
    	});
    	
    	this.on('resetPasswordFailed', function(){
    		thisComponent.$node.find('.advice p').hide();
    		thisComponent.$node.find('.error-reset-password').show();
    		this.setPasswordForgetLink();
    	});
    	
    });
  }

}());