var Pflegestufe = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return pflegestufe;

  /**
   * Module function
   */

   function toggleBackForwardButtons(activeIndex){
    if(activeIndex < 0 ){
        activeIndex = 0;
    }
    if(activeIndex > 2){
        activeIndex = 2;
    }
        var backwardBtn = $('#pflegestufe .backward-btn');
        var forwardBtn = $('#pflegestufe .forward-btn');
        switch(activeIndex){
            case 0:
                backwardBtn.css({visibility: 'hidden'});
                forwardBtn.css({visibility: 'visible'});
                break;
            case 2:
                backwardBtn.css({visibility: 'visible'});
                forwardBtn.css({visibility: 'hidden'});
                break;
            default:
                backwardBtn.css({visibility: 'visible'});
                forwardBtn.css({visibility: 'visible'});
        }

    $('#pflegestufe .table-header .pflegestufe-key').html(activeIndex + 1);
   }


  function pflegestufe() {
    this.defaultAttrs({});

    this.handleShowPflegestufe = function(evt, data){
    	var thisComponent = this;

    	this.$node.prev().hide();
    	    	
    	this.swiper = new Swiper('#pflegestufe .swiper-container', {
    		mode:'horizontal',
            initialSlide : 0,
            onFirstInit: function(swiper){
                swiper.activeIndex = 0;
                toggleBackForwardButtons(swiper.activeIndex);
            },
    		onSlideChangeStart: function(swiper){
                var activeIndex = swiper.activeIndex + 1;
    			// thisComponent.$node.find('.table-header .pflegestufe-key').html(activeIndex);
    		},
            onSlideChangeEnd: function(swiper){                
                toggleBackForwardButtons(swiper.activeIndex);
            }
    	});
    	// this.trigger(document, 'saveToHistory', {module: '#export', view: '#pflegestufe'});
    }
    
    this.handleDataForAssessment = function(evt, data){
    	console.log(data);        
    	if (data.items.length === 0){
    		$('#special-controls .overlay').show();
			$('#special-controls .popup-assessment-not-possible').show();
			this.$node.addClass('pflegestufe-1').find('.teaser .pflegestufe-key').hide();
			this.$node.find('.teaser .no-pflegestufe').show();
			this.$node.find('.teaser .hat-pflegestufe').hide();
			this.$node.find('.teaser .keine-pflegestufe').show();
    	} else {
    		var startDate = new Date (data.items[0].Accomplishment.start_time);
    		var assessmentResult = {1:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			2:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			3:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			4:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			5:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			6:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0},
    			7:{baseAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},domesticAcc:{morning:0,noon:0,afternoon:0,evening:0,night:0},baseTime:0,domesticTime:0}};
    		var currentWeekDay = 1,
    			selectedWeekDayHelper = utils.getUnixDayNumber(startDate);
    		
    		for (var i = 0; i < data.items.length; i++){
    			var dataObject = data.items[i],
					dataStartTime = new Date (dataObject.Accomplishment.start_time),
					typeHelper = typesIndex.accomplishmentTypes[dataObject.Accomplishment.accomplishment_type_id].AccomplishmentType;

				if (selectedWeekDayHelper < utils.getUnixDayNumber(dataStartTime)){
					currentWeekDay++;
					selectedWeekDayHelper++;
				}
				if (typeHelper.accomplishment_subcategory_id > 2 && typeHelper.accomplishment_subcategory_id < 9){
					//hauswirtschaft
					assessmentResult[currentWeekDay].domesticAcc[utils.getTimeRange(dataStartTime)]++;
					assessmentResult[currentWeekDay].domesticTime += parseInt(dataObject.Accomplishment.duration);
				} else {
					//grundpflege
					assessmentResult[currentWeekDay].baseAcc[utils.getTimeRange(dataStartTime)]++;
					assessmentResult[currentWeekDay].baseTime += parseInt(dataObject.Accomplishment.duration);
				}				
			}

    		var timeComplete = Math.floor((assessmentResult[1].domesticTime + assessmentResult[2].domesticTime + assessmentResult[3].domesticTime + assessmentResult[4].domesticTime + assessmentResult[5].domesticTime + assessmentResult[6].domesticTime + assessmentResult[7].domesticTime + assessmentResult[1].baseTime + assessmentResult[2].baseTime + assessmentResult[3].baseTime + assessmentResult[4].baseTime + assessmentResult[5].baseTime + assessmentResult[6].baseTime + assessmentResult[7].baseTime)/420),
    			timeBase = Math.floor((assessmentResult[1].baseTime + assessmentResult[2].baseTime + assessmentResult[3].baseTime + assessmentResult[4].baseTime + assessmentResult[5].baseTime + assessmentResult[6].baseTime + assessmentResult[7].baseTime)/420),
    			completeMinHelper = Math.ceil(Math.min((assessmentResult[1].domesticTime + assessmentResult[1].baseTime), (assessmentResult[2].domesticTime + assessmentResult[2].baseTime), (assessmentResult[3].domesticTime + assessmentResult[3].baseTime), (assessmentResult[4].domesticTime + assessmentResult[4].baseTime), (assessmentResult[5].domesticTime + assessmentResult[5].baseTime), (assessmentResult[6].domesticTime + assessmentResult[6].baseTime), (assessmentResult[7].domesticTime + assessmentResult[7].baseTime))/60),
    			completeMaxHelper = Math.ceil(Math.max((assessmentResult[1].domesticTime + assessmentResult[1].baseTime), (assessmentResult[2].domesticTime + assessmentResult[2].baseTime), (assessmentResult[3].domesticTime + assessmentResult[3].baseTime), (assessmentResult[4].domesticTime + assessmentResult[4].baseTime), (assessmentResult[5].domesticTime + assessmentResult[5].baseTime), (assessmentResult[6].domesticTime + assessmentResult[6].baseTime), (assessmentResult[7].domesticTime + assessmentResult[7].baseTime))/60),
    			baseMinHelper = Math.floor(Math.min(assessmentResult[1].baseTime, assessmentResult[2].baseTime, assessmentResult[3].baseTime, assessmentResult[4].baseTime, assessmentResult[5].baseTime, assessmentResult[6].baseTime, assessmentResult[7].baseTime)/60),
    			baseMaxHelper = Math.floor(Math.max(assessmentResult[1].baseTime, assessmentResult[2].baseTime, assessmentResult[3].baseTime, assessmentResult[4].baseTime, assessmentResult[5].baseTime, assessmentResult[6].baseTime, assessmentResult[7].baseTime)/60);

    		this.$node.find('.time-complete').html(completeMinHelper + ' - ' + completeMaxHelper + ' min');
    		this.$node.find('.time-base').html(baseMinHelper + ' - ' + baseMaxHelper + ' min');
    			
    		if (timeComplete >= 90){
    			this.$node.find('.pflegestufe-1 .time-complete').addClass('good').removeClass('bad');
    			if (timeComplete >= 180){
    				this.$node.find('.pflegestufe-2 .time-complete').addClass('good').removeClass('bad');
    				if (timeComplete >= 300){
        				this.$node.find('.pflegestufe-3 .time-complete').addClass('good').removeClass('bad');	
        			}
    			}
    		}
    		if (timeBase >= 45){
    			this.$node.find('.pflegestufe-1 .time-base').addClass('good').removeClass('bad');
    			if (timeBase >= 120){
    				this.$node.find('.pflegestufe-2 .time-base').addClass('good').removeClass('bad');
    				if (timeBase >= 240){
        				this.$node.find('.pflegestufe-3 .time-base').addClass('good').removeClass('bad');	
        			}
    			}
    		}
    		var basePossible = this.getCountsAndSetResults('base', assessmentResult);
    		var domesticPossible = this.getCountsAndSetResults('domestic', assessmentResult);
    		
    		if (this.$node.find('.pflegestufe-1 .bad').length === 0){
    			if (this.$node.find('.pflegestufe-2 .bad').length === 0){
        			if (this.$node.addClass('pflegestufe-3').find('.pflegestufe-3 .bad').length === 0){
    	    			this.$node.find('.pflegestufe-key').html(3).show();
    	    			this.swiper.swipeTo(2, 0);
    	    		} else {
    	    			this.$node.addClass('pflegestufe-2').find('.pflegestufe-key').html(2).show();
    	    			this.swiper.swipeTo(1, 0);
    	    		}
        		} else {
        			this.$node.find('.pflegestufe-key').html(1).show();
        		}
    			this.$node.find('.teaser .no-pflegestufe').hide();
    			this.$node.find('.teaser .hat-pflegestufe').show();
    			this.$node.find('.teaser .keine-pflegestufe').hide();
    		} else {
    			this.$node.find('.teaser .pflegestufe-key').hide();
    			this.$node.find('.teaser .no-pflegestufe').show();
    			this.$node.find('.teaser .hat-pflegestufe').hide();
    			this.$node.find('.teaser .keine-pflegestufe').show();
    		}
    		
    		if (!basePossible){
    			$('#special-controls .overlay').show();
    			$('#special-controls .popup-assessment-not-possible').show();
    			this.$node.addClass('pflegestufe-1');
    			this.swiper.swipeTo(0, 0);
    			this.$node.find('.teaser .hat-pflegestufe').hide();
    			this.$node.find('.teaser .keine-pflegestufe').show();
    		}
    		
    	}
    	this.$node.parent().find('.spinner-overlay').hide();
    }
    
    this.getCountsAndSetResults = function(key, assessmentResult){
        console.log(key);
    	var counterObj = {
				1:0,
				2:0,
				3:0,
				4:0,
				5:0,
				6:0,
				7:0
		}
		
		for(var day in assessmentResult){
			for (var timeRange in assessmentResult[day][key + 'Acc']){
				if (assessmentResult[day][key + 'Acc'][timeRange] !== 0){
					counterObj[day]++;
				}
			}
		}
		
		var pflege1Helper = 0,
			pflege2Helper = 0,
			pflege3Helper = 0,
			assessmentPossible = 0;
		
		if (key === 'base'){
			for (var count in counterObj){
				if (counterObj[count] >= 1){
					assessmentPossible++;
					pflege1Helper++;
					if (counterObj[count] >= 2){
						pflege2Helper++;
						if (counterObj[count] >= 5){
							pflege3Helper++;
						}
					}
				}
			}
		} else {
			for (var count in counterObj){
				if (counterObj[count] > 0){
					pflege1Helper++;
					assessmentPossible++;
				}
			}
		}
		
		if (key === 'base'){
			if (pflege1Helper === 7){
				this.$node.find('.pflegestufe-1 .count-acc-' + key).addClass('good').removeClass('bad');
				if (pflege2Helper === 7){
					this.$node.find('.pflegestufe-2 .count-acc-' + key).addClass('good').removeClass('bad');
					if (pflege3Helper === 7){
						this.$node.find('.pflegestufe-3 .count-acc-' + key).addClass('good').removeClass('bad');
		    		}
	    		}
			}
		} else {
			if (pflege1Helper >= 2){
				this.$node.find('.count-acc-' + key).addClass('good').removeClass('bad');
			}
		}
		for (var count in counterObj){
			if (counterObj[count] === 0){
				return false;
			}
		}
		
		return true;
		
		/* when only base is important for the decision wheather the assessment is possible
		if (key === 'base'){
			if (assessmentPossible === 7){
				return true;
			} else {
				return false;
			}
		}  else {
			if (assessmentPossible > 1){
				return true;
			} else {
				return false;
			}
		}*/
    }
    
    this.after('initialize', function () {
    	this.on('showPflegestufe', this.handleShowPflegestufe);
    	this.on('dataAccomplishmentsFromWeekForAssessmentRetrieved', this.handleDataForAssessment);
    	var thisComponent = this;
    	
    	this.$node.find('.subheader').unbind('touchend').bind('touchend', function(){
            $(document).trigger('setCurrentScreen', {module: '#export', view: '#summary'});
    		thisComponent.$node.prev().show();
    		thisComponent.$node.hide();
    		
    		thisComponent.$node.find('.good').addClass('bad').removeClass('good');
    		thisComponent.$node.find('.time-complete').html('');
    		thisComponent.$node.find('.time-base').html('');
    	});
    	
    	$('#special-controls .popup-assessment-not-possible .btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(e){
                if(utils.isTouchMove(evt, e)){
                    $this.removeClass('active');
                    $this.unbind('touchend');
                }
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$this.parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});
    	
    	this.$node.find('.table-header .forward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(e){
                if(utils.isTouchMove(evt, e)){
                    $this.unbind('touchend');
                    $this.removeClass('active');
                }
    			
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');
                var activeIndex = thisComponent.swiper.activeIndex;
                // activeIndex++;
                // if(activeIndex <= 3){
                    thisComponent.swiper.swipeTo(activeIndex + 1, 0, true);
                    toggleBackForwardButtons(activeIndex+1);
                // }
    			$this.unbind('touchend');
    		});
    		
    	});
    	
    	this.$node.find('.table-header .backward-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove', function(e){
                if(utils.isTouchMove(evt, e)){
                    $this.unbind('touchend');
                    $this.removeClass('active');
                }
    		});
    		
    		$this.bind('touchend', function(){
    			$this.removeClass('active');
    			var activeIndex = thisComponent.swiper.activeIndex;
                // activeIndex--;
                // if(activeIndex >= 0){

                    thisComponent.swiper.swipeTo(activeIndex - 1, 0, true);
                    toggleBackForwardButtons(activeIndex-1);
                // }
    			// thisComponent.swiper.swipePrev();
    			$this.unbind('touchend');
    		});
    	});
    });
  }

}());
