var SignUp = flight.component(function () {

  'use strict';

  /**
   * Module dependencies
   */

  //var defineComponent = require('flight/lib/component');
  //var ChangeModule = require('component/ui/changeModule');
  /**
   * Module exports
   */

  return signUp;

  /**
   * Module function
   */

  function signUp() {
    this.defaultAttrs({

    });

    this.initSignUp = function(evt, data){
    	this.$node.show();
    	this.$node.find('.page').last().hide();
    	this.$node.find('.page').first().show();

    	var thisComponent = this;

    	this.$node.find('.btn-forward').text('Einverstanden').unbind('touchstart').bind('touchstart', function(){

    		var $this = $(this);
    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.trigger('uiAcceptTerms');
    		});

    	});

    	this.$node.find('.btn-abort').unbind('touchstart').bind('touchstart', function(){

    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$('#login').show();
    			thisComponent.$node.hide();
    		});

    	});

    	$('#login').hide();

    };

    this.initSignUpForm = function(){
    	this.$node.find('.page').last().show();
    	this.$node.find('.page').first().hide();

    	var thisComponent = this;

    	this.$node.find('.btn-forward').text('Registrieren').unbind('touchstart').bind('touchstart', function(){

    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			var passwort1 = thisComponent.$node.find('input[name="password"]').first().val();
    			var passwort2 = thisComponent.$node.find('input[name="password"]').last().val();

    			var credentialsFlag = false;

          if (passwort1 === '' && passwort2 === ''){
            thisComponent.$node.find('.error-not-set').show();
    				credentialsFlag = true;
          }

    			if (passwort1 !== passwort2){
    				thisComponent.$node.find('.error-not-same').show();

    				credentialsFlag = true;
    			}
          var eMail = thisComponent.$node.find('input[name="email"]').val().trim()
    			if (!utils.validateEmail(eMail)){
    				thisComponent.$node.find('input[name="email"]').next().show();
    				credentialsFlag = true;
    			}
    			/*
    			if (navigator.network.connection.type === 'none' || navigator.network.connection.type === 'unknown'){
    				thisComponent.$node.find('.error-connection').show();
    				credentialsFlag = true;
    			}*/

    			if (!credentialsFlag){
    				$(document).trigger('dataClearAccomplishments');
	    	    	$(document).trigger('dataDoPostRequest', {
	    				url: 'users/register.json',
	    				headers: true,
	    				openMethod: true,
	    				mmRequestId: 'signUp',
	    				selector: '#signUp',
	    			    success: 'signUpSuccess',
	    			    error: 'signUpFailed',
	    			    data: JSON.stringify({
	    			    	User: {
	    			    		email: eMail,
	    			    		password: passwort1
	    	    		}})
	    			});
    			}
    		});
    	});
    };

    this.signUpFailed = function(evt, data){
    	if (data.status === 0){
    		this.$node.find('.error').hide();
    		this.$node.find('.error-default').show();
    	} else {
    		if (data._metadata['error-code'] === 2201){
	    		this.$node.find('.error-not-same').hide();
	    		if (data._metadata['error-message'] !== ''){
	    			this.$node.find('.error-not-good').text('Passwort ungültig (' + data._metadata['error-message'] + ')');
	    		}
	    		this.$node.find('.error-not-good').show();
	    	}

    		if (data._metadata['error-code'] === 2102){
	    		this.$node.find('.error-not-same').hide();
	    		if (data._metadata['error-message'] !== ''){
	    			this.$node.find('input[name="email"]').next().text(data._metadata['error-message']);
	    		}
	    		this.$node.find('input[name="email"]').next().show();
	    	}
    	}
    };

    this.signUpSuccess = function(evt, data){
    	this.$node.hide();
    	$(document).trigger('dataDoPostRequest', {
			url: 'users/token.json',
			headers: false,
			mmRequestId: 'login',
			selector: '#login',
		    success: 'loginSuccess',
		    error: 'loginFailed',
		    data: JSON.stringify({
		    	User: {
		    		email: this.$node.find('input[name="email"]').val(),
		    		password: this.$node.find('input[name="password"]').first().val()
    		}})
		});
    	$('#lifeConstraint').trigger('uiSignUpSuccess');
    	localStorage.setItem('lastLoginEmail', this.$node.find('input[name="email"]').val());
    	$('#login input').val('');
		$('#signUp input').val('');
		$('#login input[name="email"]').val(localStorage.getItem('lastLoginEmail'));

    };

    this.after('initialize', function () {
    	this.on('uiPrepareSignUp', this.initSignUp);
    	this.on('uiAcceptTerms', this.initSignUpForm);
    	this.on('signUpFailed', this.signUpFailed);
    	this.on('signUpSuccess', this.signUpSuccess);
    });
  }

}());
