var StartCapturing = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return startCapturing;

  /**
   * Module function
   */

  function startCapturing() {
    this.defaultAttrs({

    });

    this.handleStartCapturingTrigger = function(evt, data){
    	var thisComponent = this;

    	this.$node.addClass('category-' + data.category).attr('data-type-id', data.typeId);
    	this.$node.prepend($('#category-' + data.category + '-subcategories > header').first().clone());
    	this.$node.find('header .title').first().text(data.title);

    	this.$node.find('.capture-property').trigger('uiInitCapturing');
    	this.$node.find('.back-btn').parent().unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			thisComponent.trigger('uiBackToCategories', data);
    		});
    	});

    	this.$node.find('header .datepicker').unbind('touchstart').bind('touchstart', function(evt){
    		evt.stopPropagation();
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			e.stopPropagation();
            $this.unbind('touchend');
            $this.removeClass('active');
          }
        });

    		$this.unbind('touchend').bind('touchend', function(evt){
    			evt.stopPropagation();
    			$('#special-controls .popup-datepicker').trigger('uiGetDatePickerPopup', {selector:'#capturing'});
    		});
    	});

    	var dateHelper = new Date();

    	this.$node.find('.start_time header > .value').html('<div class="col-xs-4">' + utils.getTimeString(dateHelper) + ' Uhr</div><div class="col-xs-8">' + utils.getDateString(dateHelper) + '</div>');
    	this.$node.show();
    	if (document.querySelector('#capture .subcategories-wrapper .swiper-slide-active')){
    		$('#capture .subcategories-wrapper').hide().trigger('uiDestroy');
    	}
    	this.trigger(document, 'saveToHistory', {module: '#capture', view: '#capturing', data:data});
    };

    this.handleDateFromDatePicker = function(evt, data){
    	this.$node.find('.start_time header > .value .col-xs-8').html(utils.getDateString(new Date(data.year, utils.getMonthFromName(data.month), data.day)));
    }


    this.saveData = function (){
		var durationHelper = this.$node.find('.duration > header .value').text()

		if (durationHelper === '00:00'){
			durationHelper = 0;
		} else {
			durationHelper = durationHelper.split(':');
			durationHelper = parseInt(durationHelper[0])*60 + parseInt(durationHelper[1])
		}

		var assitanceTypeHelper =  this.$node.find('.assistance_type > header .value').attr('data-type');

		this.trigger(document, 'dataHandlePostData', {
			postData : {
				"Accomplishment":{
			        "accomplishment_type_id":this.$node.attr('data-type-id'),
			        "number_of_assistants":parseInt(this.$node.find('.number_of_assistants > header .value').text()),
			        "assistance_type":(assitanceTypeHelper ? assitanceTypeHelper : 'ASSISTANCE_TYPE_UNDEFINED'),
			        "start_time":  utils.getDateWithTimeFormated(this.$node), //param is the node where the date is. return must be "2014-03-27 14:29:00"
			        "duration":durationHelper
			    }
    		},
    		url : 'accomplishments/add.json'
		});
   };

    this.backToCategories = function(evt, data){
        $(document).trigger('setCurrentScreen', constants.module)
    	if (data.dataOption === 'save'){
    		$('#diary .spinner-overlay').show();
    		this.saveData();
    	}
    	$('#capture .subcategories-wrapper').trigger('uiGoToCategory', {
			target: "category-" + data.category
		});
    	this.$node.find('.capture-property').removeClass('active');
  	    $('#capturing .capture-property').trigger('uiReset', {key: 'capture'});
        $('#capturing > header').remove();
        $('#capturing').attr('class', '');
    };

    this.after('initialize', function () {

    	var thisComponent = this;
    	this.on('uiReturnDateFromDatePicker', this.handleDateFromDatePicker);
    	this.on('uiStartCapturing', this.handleStartCapturingTrigger);
    	this.on('dataBackToSelectionView', this.backToCategories);

    	this.on('uiSaveData', this.saveData);

    	this.$node.find('footer.controls .btn').unbind('touchstart').bind('touchstart', function(evt){

    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
            $this.unbind('touchend');
            $this.removeClass('active');
          }
        });

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.trigger('dataBackToSelectionView', {
        			category: thisComponent.$node.attr('class').split(' ')[0].split('-')[1],
        			dataOption: 'save'
        		});
    		});


    	});

    	this.$node.find('.back-btn').parent().unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
            $this.unbind('touchend');
            $this.removeClass('active');
          }
        });

    		$this.unbind('touchend').bind('touchend', function(){
    			thisComponent.trigger('uiBackToCategories');
    		});
    	});

    	this.$node.find('.capture-property > header').bind('touchend', function(event){
    		var parentHelper = $(this).parent();
    		if (!parentHelper.hasClass('stop-watch-running')){
    			if (parentHelper.hasClass('active')){
	    			parentHelper.removeClass('active activated');
	    			if (document.getElementById('sw-wrapper')){
	        			SpinningWheel.destroy();
	        		}
	    		} else {
	    			thisComponent.$node.find('.capture-property').removeClass('active activated');
	    			thisComponent.$node.find('.capture-property.' + $(this).parent().attr('data-property')).addClass('active');
	    			if (document.getElementById('sw-wrapper')){
	        			SpinningWheel.destroy();
	        		}
	    			thisComponent.trigger('.' + parentHelper.attr('data-property'), 'uiEditProperty');
	    			setTimeout(function(){
	    				thisComponent.$node.find('.capture-property.active').addClass('activated');
	    			}, 250);
	    		}
    		}
    	});

    });
  }

}());
