var StartEditing = flight.component(function () {

  'use strict';

  /**
   * Const
   */



  /**
   * Module exports
   */

  return startEditing;

  /**
   * Module function
   */

  function startEditing() {
    this.defaultAttrs({

    });

    this.handleDataForStartEditing = function(evt, data){
    	var thisComponent = this,
    		typeId = data.Accomplishment.accomplishment_type_id,
    		typeHelper = typesIndex.accomplishmentTypes[typeId].AccomplishmentType;
    	if (!typeId){
    		typeId = 2;
    	}
    	this.$node.addClass('category-' + subcategoriesIndex.accomplishmentSubcategories[typesIndex.accomplishmentTypes[typeId].AccomplishmentType.accomplishment_subcategory_id].AccomplishmentSubcategory.accomplishment_category_id)
    		.attr('data-mmRequestId', data.mmRequestId)
    		.attr('data-type-id', typeId)
    		.attr('data-server-id', data.Accomplishment.id);
    		//.attr('data-start_time', data.Accomplishment.start_time);

    	this.$node.find('.title').first().text(typesIndex.accomplishmentTypes[typeId].AccomplishmentType.short_name ? typesIndex.accomplishmentTypes[typeId].AccomplishmentType.short_name : typesIndex.accomplishmentTypes[typeId].AccomplishmentType.name);

    	var startTimeDateObj = new Date(data.Accomplishment.start_time);
    	var timeHelper = utils.getTimeString(startTimeDateObj).split(':');
    	this.$node.find('.start_time').trigger('uiUpdateHeader', {
    		values: [timeHelper[0],timeHelper[1], utils.getDateString(startTimeDateObj)]
    	});

   		var minutesHelper = Math.floor(data.Accomplishment.duration/60);
   		var secondsHelper = data.Accomplishment.duration%60;
    	var dataHelper = {values:[(minutesHelper < 10 ? '0' + minutesHelper : minutesHelper), (secondsHelper < 10 ? '0' + secondsHelper : secondsHelper)], defaultRange: [typeHelper.standard_duration_min, typeHelper.standard_duration_max]};
    	this.$node.find('.duration').trigger('uiUpdateHeader', dataHelper);

    	this.$node.find('.assistance_type').trigger('uiUpdateHeader', data.Accomplishment.assistance_type);

    	this.$node.find('.accomplishment_type_id > header .value').text(typesIndex.accomplishmentTypes[data.Accomplishment.accomplishment_type_id].AccomplishmentType.short_name)
    	this.$node.find('.back-btn').parent().unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

            $this.unbind('touchmove').bind('touchmove', function(e){
              if(utils.isTouchMove(evt, e)){
          			$this.unbind('touchend');
          			$this.removeClass('active');
              }
    		});

        	$this.unbind('touchned').bind('touchend', function(){
        		thisComponent.trigger('uiBackToDiary', data);
        		$this.unbind('touchend');
        		$this.removeClass('active');
        	});
    	});

    	$('#editing .capture-property').trigger('uiInitEditing', data);
    	this.$node.show();
    	$('#diary').hide();
        // $(document).trigger('saveToHistory', {module: '#edit', view: '#editing'})
    	this.trigger(document, 'saveToHistory', {module: '#edit', view: '#editing'});
    };

    this.backToDiary = function(evt, data){
    	console.log(data);
    	if (data.dataOption === 'save'){
    		$('#edit .spinner-overlay').show();
            $(document).trigger('deleteLastHistoryEntry');
            $(document).trigger('setCurrentScreen', constants.moduleEditing());
    		this.saveData();
    	}

    	if (data.dataOption === 'delete'){
    		$('#special-controls .overlay').show();
        	$('#special-controls .popup-delete-record').show();
            $(document).trigger('deleteLastHistoryEntry');
            $(document).trigger('setCurrentScreen', constants.moduleEditing());
    	} else {
            $('#edit').trigger('uiBackToDiary');
    		$('#diary').show();
        	$('#editing').hide().attr('class', '');
        	$('#editing > header .title').text('');

        	this.$node.find('.capture-property').removeClass('active activated');
        	$('#editing .capture-property').trigger('uiReset', {key: 'edit'});
    		$('#editing').attr('class', '');
    	}
    };

    this.handleDeleteRecord = function(){

    };

    this.saveData = function (){
    	// var dateHelper = this.$node.find('.start_time > header .value .col-xs-8').text().split(' ');
//
		// if (dateHelper[2] === 'Mär'){
			// var monthHelper = '03';
		// } else {
			// var monthHelperArray = {
    			// Jan : '01',
    			// Feb : '02',
    			// Apr : '04',
    			// Mai : '05',
    			// Jun : '06',
    			// Jul : '07',
    			// Aug : '08',
    			// Sep : '09',
    			// Okt : '10',
    			// Nov : '11',
    			// Dez : '12'
    		// }
//
			// var monthHelper = monthHelperArray[$.trim(dateHelper[2])];
		// }

		var durationHelper = this.$node.find('.duration > header .value').text()

		if (durationHelper === '00:00'){
			durationHelper = 0;
		} else {
			durationHelper = durationHelper.split(':');
			durationHelper = parseInt(durationHelper[0])*60 + parseInt(durationHelper[1])
		}

		var assitanceTypeHelper =  this.$node.find('.assistance_type > header .value').attr('data-type');
		var startTimeHelper = utils.getDateWithTimeFormated(this.$node);
		var serverId = this.$node.attr('data-server-id');

		if (serverId){
			this.trigger(document, 'dataHandlePutData', {
				putData : {
					"Accomplishment":{
				        "accomplishment_type_id":this.$node.attr('data-type-id'),
				        "number_of_assistants":parseInt(this.$node.find('.number_of_assistants > header .value').text()),
				        "assistance_type":(assitanceTypeHelper ? assitanceTypeHelper : 'ASSISTANCE_TYPE_UNDEFINED'),
				        "start_time":  startTimeHelper,
				        "duration": durationHelper,
				        "id": serverId
				    },
				    id: '',
				    modified: new Date(utils.getServerDateObject(new Date())),
				    mmRequestId: parseInt(this.$node.attr('data-mmRequestId')),
				    start_time:  new Date(startTimeHelper),
	    		},
	    		mmRequestId: this.$node.attr('data-mmRequestId'),
				url : 'accomplishments/edit/' + serverId + '.json'
			});
		} else {
			$(document).trigger('dataEditRecord', {
	    		key : parseInt(this.$node.attr('data-mmRequestId')),
	    		data: {
					"Accomplishment":{
				        "accomplishment_type_id":this.$node.attr('data-type-id'),
				        "number_of_assistants":parseInt(this.$node.find('.number_of_assistants > header .value').text()),
				        "assistance_type":(assitanceTypeHelper ? assitanceTypeHelper : 'ASSISTANCE_TYPE_UNDEFINED'),
				        "start_time":  startTimeHelper,
				        "duration":durationHelper,
				        "id": serverId
				    },
				    id: '',
				    modified: new Date(utils.getServerDateObject(new Date())),
				    mmRequestId: parseInt(this.$node.attr('data-mmRequestId')),
				    start_time:  new Date(startTimeHelper),
	    		}
	    	});

			$(document).trigger('dataDoPostRequest', {
    			url: 'accomplishments/add.json',
    			headers: true,
    			mmRequestId: this.$node.attr('data-mmRequestId'),
    			selector: document,
    		    success: 'dataPutSuccess',
    		    error: 'dataPutFailed',
    		    data: JSON.stringify({"Accomplishment":{
			        "accomplishment_type_id":this.$node.attr('data-type-id'),
			        "number_of_assistants":parseInt(this.$node.find('.number_of_assistants > header .value').text()),
			        "assistance_type":(assitanceTypeHelper ? assitanceTypeHelper : 'ASSISTANCE_TYPE_UNDEFINED'),
			        "start_time":  startTimeHelper,
			        "duration":durationHelper
			    }})
    		});
		}
   };

    this.after('initialize', function () {

    	var thisComponent = this;
    	this.on('dataGetSingleRecordCompleted', this.handleDataForStartEditing);
    	this.on('dataBackToSelectionView', this.backToDiary);
    	this.on('uiSaveData', this.saveData);

    	this.$node.find('footer.controls .btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

            $this.unbind('touchmove').bind('touchmove', function(e){
              if(utils.isTouchMove(evt, e)){
          			$this.unbind('touchend');
          			$this.removeClass('active');
              }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			thisComponent.trigger('dataBackToSelectionView', {
        			category: thisComponent.$node.attr('class').split('-')[1],
        			dataOption: $this.attr('data-option')
        		});
    		});
    	});

    	this.$node.find('.capture-property > header').bind('touchend', function(){

    		var parentHelper = $(this).parent();

    		if (document.getElementById('sw-wrapper')){
    			SpinningWheel.destroy();
    		}
    		if (parentHelper.hasClass('active')){
    			parentHelper.removeClass('active activated');
    			parentHelper.find('.editor').attr('style', '');
    		} else {
    			thisComponent.$node.find('.capture-property').removeClass('active activated');
        		thisComponent.$node.find('.capture-property.' + parentHelper.attr('data-property')).addClass('active').trigger('uiEditProperty');
        		setTimeout(function(){
    				thisComponent.$node.find('.capture-property.active').addClass('activated');
    			}, 250);
    		}
    	});

    	$('#special-controls .popup-delete-record footer .btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.bind('touchend', function(){
    			$this.removeClass('active');

    			if ($this.attr('data-option') === 'yes'){
    				$('#edit .spinner-overlay').show();
    	    		$(document).trigger('dataDoDeleteRequest', {
        				url: 'accomplishments/delete/' + thisComponent.$node.attr('data-server-id') + '.json',
        				headers: 'true',
        				mmRequestId: 'dataDeleteAccount-' + thisComponent.$node.attr('data-mmrequestid'),
        				selector: document,
        			    success: 'dataDeleteAccomplishmentSuccess',
        			    error: 'dataDeleteAccomplishmentFailed',
        			    //data: JSON.stringify('')
        			});

    	    		thisComponent.backToDiary('deleteSafetyQuestion', {});
    			}

    			$this.parent().parent().parent().hide().parent().find('.overlay').hide();

    			$this.unbind('touchend');
    		});

    	});

    	$('#special-controls .popup-delete-not-possible footer .btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$this.parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});

    	$('#special-controls .popup-no-internet footer .btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');

        $this.unbind('touchmove').bind('touchmove', function(e){
          if(utils.isTouchMove(evt, e)){
      			$this.unbind('touchend');
      			$this.removeClass('active');
          }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			$this.parent().parent().hide().parent().find('.overlay').hide();
    		});
    	});


    });
  }

}());
