var utils = (function () {

  'use strict';

  /**
   * Const
   */

  var monthsArray = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
  //var monthsArray = ['Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'];
  var monthsLongArray = ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'];
  var daysArray = ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa','So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'];

  var touchMoveThreshold = 100;

  var oneDay = 24*60*60*1000;
  /**
   * Module exports
   */

   function getCurrentDateAt0(){
     var date = new Date();
     return getDateAt0(date);
   }

   function getDateAt0(date){
     date.setHours('00');
     date.setMinutes('00');
     date.setSeconds('00');
     return date;
   }

   // function getUnixDayNumber(date){
   //  date = getDateAt0(date);
   //  return Math.floor(date / oneDay);
   // }

  return {

  getUnixDayNumber : function(date){
    date = getDateAt0(date);
    return Math.floor(date / oneDay);
  },


	getDaysGap : function(start, end){   
		var startUnixDay = this.getUnixDayNumber(new Date(start));
		var endUnixDay = end ? this.getUnixDayNumber(new Date(end)) : this.getUnixDayNumber(new Date());
    //days gap is positive if start is before end
    return endUnixDay - startUnixDay;
	},

	getWeeksGap : function(start, end){

    var daysGap = this.getDaysGap(start, end);

    if (daysGap >= 0) {
      return Math.floor(daysGap/7);
    } else {
      return Math.ceil(daysGap/7);
    }
	},

  setDateWithTime : function(selector){

  	var dateHelper = '<div class="col-xs-4">' +
			    	this.$node.find('.time-hour .swiper-slide-active').next().text() + ':' +
			    	this.$node.find('.time-minutes .swiper-slide-active').next().text() + ' Uhr</div><div class="col-xs-8">' +
			    	this.$node.find('.dates .swiper-slide-active').next().find('.day').text() + ' ' +
			    	this.$node.find('.dates .swiper-slide-active').next().find('.date').text() + ' ' +
			    	this.$node.find('.dates .swiper-slide-active').next().find('.month').text() + ' ' +
			    	this.$node.find('.dates .swiper-slide-active').next().find('.year').text() + '</div>';

  	this.$node.find(selector).html(dateHelper);

  },

    getCurrentDate : function(data){
    	if (data){
    		var dateHelper = new Date(data);
    	} else {
    		var dateHelper = new Date();
    	}

    	var date = new Array();

    	date.push(dateHelper.getHours());
    	date.push(dateHelper.getMinutes());
    	date.push(dateHelper.getDate());
    	date.push(dateHelper.getMonth());
    	date.push(dateHelper.getFullYear());
    	date.push(dateHelper.getDay());

    	this.date = date;
    },

    getDateString : function(date){
		var dateHelper = daysArray[date.getDay()] + '. ' +
    						(date.getDate() < 10 ? '0' + date.getDate() : date.getDate()) + '.' +
    						monthsArray[date.getMonth()] + '.' + date.getFullYear();
    	return dateHelper;
    },

    getDateStringForSwipe : function(date, swipeDirection){
    	if(!date){
  			date = new Date();
  		}
	  	switch(swipeDirection){
	  		case 'prev':
	  			date = date.setDate(date.getDate()-1);;
				break;
			case 'next':
				date = date.setDate(date.getDate()+1);;
				break;
			default:
				break;
	  	}
	  	return this.getDateString(new Date(date));
    },

    getTimeString : function(date){

    	var timeString = 	(date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':' +
    						(date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());

    	return timeString;
    },

    getWeekString : function(date, mode){
      var weekStartDate = new Date(date);
      var weekEndDate = new Date(weekStartDate);
      weekEndDate.setDate(weekEndDate.getDate() + 6);

      var weekstring = daysArray[weekStartDate.getDay()] + '. ' +  // [Mo. .. So..].
                (weekStartDate.getDate() < 10 ? '0' + weekStartDate.getDate() : weekStartDate.getDate()) + '.' + // 05.
                monthsArray[weekStartDate.getMonth()] + ' - ' + // [01..12] -
                daysArray[weekEndDate.getDay()] + '. ' + // [Mo. .. So..].
                (weekEndDate.getDate() < 10 ? '0' + weekEndDate.getDate() : weekEndDate.getDate()) + '.' + // 05.
                monthsArray[weekEndDate.getMonth()] + '.' + weekEndDate.getFullYear(); // [01..12].2015

      return weekstring;

    	if(mode === 'free'){
    		var weekDay = date.getDay(),
    		endDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() + 6),
    		weekString = daysArray[weekDay] + '. ' +
    					(date.getDate() < 10 ? '0' + date.getDate() : date.getDate()) + '.' +
    					monthsArray[date.getMonth()] + ' - ' + daysArray[weekDay + 6] + '. ' +
    					(endDate.getDate() < 10 ? '0' + endDate.getDate() : endDate.getDate()) + '.' +
    					monthsArray[endDate.getMonth()] + '.' + endDate.getFullYear();

    		return weekString;
    	} else {
    		var weekDay = date.getDay(),
    		startDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() - weekDay + 1),
    		endDate = new Date(date.getFullYear(), date.getMonth(), date.getDate() + 7 - weekDay),
    		weekString = 'Mo. ' + (startDate.getDate() < 10 ? '0' + startDate.getDate() : startDate.getDate()) + '.' +
    		monthsArray[startDate.getMonth()] + ' - So. ' +
    		(endDate.getDate() < 10 ? '0' + endDate.getDate() : endDate.getDate()) + '.' +
    		monthsArray[endDate.getMonth()] + '.' + endDate.getFullYear();

    		return weekString;
    	}

    },
    getServerDateObject : function(date){
    	return date.getFullYear() + '-' + (parseInt(date.getMonth()) + 1) + '-' + date.getDate() + ' ' + date.getHours() + ':' + date.getMinutes() + ':' + date.getSeconds();
    },
    validateEmail : function(email){
		var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	    return re.test(email);
	},
    getTimeRange : function(date){
    	var returnHelper;

    	var timeHelper = date.getHours() + '' + (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());

    	if (timeHelper >= 600 && timeHelper < 1200){
    		return 'morning';
    	}

    	if (timeHelper >= 1200 && timeHelper < 1400){
    		return 'noon';
    	}

    	if (timeHelper >= 1400 && timeHelper < 1800){
    		return 'afternoon';
    	}

    	if (timeHelper >= 1800 && timeHelper < 2200){
    		return 'evening';
    	}

    	if (timeHelper >= 2200 && timeHelper < 2400 || timeHelper >= 0 && timeHelper < 600){
    		return 'night';
    	}

    },

    getMonthNameString : function(month){
    	return monthsArray[month];
    },

    getMonthFromName : function(month){
    	for (var i = 0; i < monthsLongArray.length; i++){
    		if (monthsLongArray[i] === month){
    			return i;
    		}
    	}
    },

    getMonthFromNameShort : function(month){
    	for (var i = 0; i < monthsArray.length; i++){
    		if (monthsArray[i] === month){
    			return i;
    		}
    	}
    },

    getMonthLongnameString : function(month){
    	return monthsLongArray[month];
    },

    touchScroll : function (el){
		var scrollStartPos=0;
		el.addEventListener('touchstart', function(event) {
			scrollStartPos=this.scrollTop+event.touches[0].pageY;
			event.preventDefault();
		},false);

		el.addEventListener('touchmove', function(event) {
			this.scrollTop=scrollStartPos-event.touches[0].pageY;
			event.preventDefault();
		},false);
	},

	getDateWithTimeFormated : function(node){
		var dateHelper = node.find('.start_time > header .value .col-xs-8').text().split('.');
		var timeHelper = node.find('.start_time > header .value .col-xs-4').text();

		var time = timeHelper.split(' Uhr')[0] + ':00'; //cut away Uhr from time string "xx:xx Uhr"
		var date = parseInt(dateHelper[3]) + '-' + dateHelper[2] + '-' + $.trim(dateHelper[1]);

		return date + ' ' + time;
	},

	getEndDateFromWeekString : function(weekstring){
	  	var endDate = weekstring.split(' ');
	  	var date = endDate[endDate.length - 1].split('.');

	  	console.log('getEndDateFromWeekString:date ' + date);

	  	return new Date(date[2], parseInt(date[1]) - 1, date[0], 23, 59, 59, 0);// parseInt(date[1]) - 1 -> to avoid problem that date months are started at 0
	},

	getStartDateFromWeekString : function(weekstring){
	  	var startDate = weekstring.split(' ');
	  	var year = startDate[startDate.length - 1].split('.')[2];
	  	var date = startDate[1].split('.');

	  	return new Date(year, parseInt(date[1]) - 1, date[0], 23, 59, 59, 0); // parseInt(date[1]) - 1 -> to avoid problem that date months are started at 0
	},
	// return the main navigation bar height @param activeCategorie A string that equals the id of the current active section eg. capture, edit or something like that
	// if param is null the Method trys to find the active section
	getMainNavigationHeight : function(activeCategorie){
    var spacerHeight = $('.spacer').height();
		var naviHeight;
		if(activeCategorie){
			naviHeight = $('#' + activeCategorie + ' header').height();
      spacerHeight = $('#' + activeCategorie + ' .spacer').height();
			return naviHeight + spacerHeight;
		}else{
      activeCategorie = this.getActiveModule();
      if(activeCategorie){
        return this.getMainNavigationHeight(activeCategorie);
      }
			return 0; // should never occure but you never know
		}

	},

  getActiveModule : function(){
      var naviHeight = $('#capture header').height();
      if(naviHeight > 0){
        return 'capture';
      }
      naviHeight = $('#edit header').height();
      if(naviHeight > 0){
        return 'edit'
      }
      naviHeight = $('#export header').height();
      if(naviHeight > 0){
        return 'export';
      }
      naviHeight = $('#settings header').height();
      if(naviHeight > 0){
        return 'settings';
      }
      return undefined;
  },


  isTwoLinedText : function(selector) {
    var height = $(selector).height();
    var line_height = $(selector).css('line-height');
    line_height = parseFloat(line_height)
    var rows = height / line_height;
    return Math.round(rows) > 1;
    
  },

  /**
  * Adds a sensity to touchmove event, threshold can be adjusted via variable touchMoveThreshold
  **/
  isTouchMove : function(touchStartEvent, touchMoveEvent){
    if(!touchStartEvent || !touchMoveEvent){
      return false; // if events not there return false to ensure trigger functions work
    }
    var moveX = touchMoveEvent.originalEvent.touches[0].pageX;
    var moveY = touchMoveEvent.originalEvent.touches[0].pageY;
    var startX = touchStartEvent.originalEvent.touches[0].pageX;
    var startY = touchStartEvent.originalEvent.touches[0].pageY;

    var moveInX = (moveX - startX) < 0 ?  (moveX - startX) * -1 : (moveX - startX);
    var moveInY = (moveY - startY) < 0 ?  (moveY - startY) * -1 : (moveY - startY);

    return (moveInY > touchMoveThreshold || moveInX > touchMoveThreshold);
  },

  isObjectInArray : function(array, obj){
    var i = array.length;
    while (i--) {
       if (array[i] === obj) {
           return true;
       }
    }
    return false;
  }

}


}());
