var page = flight.component(function () {

  'use strict';

  /**
   * Module dependencies
   */

  var devHelper = 0;

  /**
   * Module exports
   */


  //return initialize;

  /**
   * Module function
   */

  function initialize() {



	  localStorage.setItem('defaultPublicToken', '00000000-0000-0000-0000-000000000000');
	  localStorage.setItem('defaultPrivateToken', '00000000-1111-2222-3333-444444444444');
	  if (!localStorage.getItem('dataVersion')) {
		  localStorage.setItem('dataVersion', '273');
	  }

	  if (!localStorage.getItem('accTypes')){
		  localStorage.setItem('accTypes', JSON.stringify(accTypes));
	  } else {
		  if (localStorage.getItem('dataVersion') > 3){
			  accTypes = JSON.parse(localStorage.getItem('accTypes'));
		  }
  	  }

	  if (!localStorage.getItem('typesIndex')){
		  localStorage.setItem('typesIndex', JSON.stringify(typesIndex));
  	  } else {
  		 if (localStorage.getItem('dataVersion') > 3){
  			 typesIndex = JSON.parse(localStorage.getItem('typesIndex'));
  		 }
  	  }

	  if (!localStorage.getItem('subcategoriesIndex')){
		  localStorage.setItem('subcategoriesIndex', JSON.stringify(subcategoriesIndex));
	  } else {
		  if (localStorage.getItem('dataVersion') > 3){
			  subcategoriesIndex = JSON.parse(localStorage.getItem('subcategoriesIndex'));
		  }
  	  }

	  var requireShim = typeof window.IDBVersionChangeEvent == 'undefined';

  	  var supportsWebSql = typeof window.openDatabase != 'undefined';

	  if(requireShim && supportsWebSql){
		  window.shimIndexedDB.__useShim(); // Verwendung des Polyfills erwzingen
	  }

	  withRequest.attachTo(document);

	  Database.attachTo(document);
	  Settings.attachTo(document);
	  HandleData.attachTo(document);
	  SetHeader.attachTo(document);
	  Popup.attachTo('.popup-container');

	  Login.attachTo('#login');
	  SignUp.attachTo('#signUp');

	  InitCapture.attachTo('#capture .category-overview');
	  InitCategory.attachTo('#capture .subcategories-wrapper');

	  $(document.querySelector('.module.container-fluid')).show();

	  var $boxesHelper = $('#capture .category-overview .box');
  	  $boxesHelper.height($boxesHelper.first().width());
  	  StartCapturing.attachTo('#capturing');
  	  DatePicker.attachTo('.start_time');
  	  SingleChoiceProperty.attachTo('.singlechoice-property');
  	  Duration.attachTo('.duration');
  	  AssistanceType.attachTo('.assistance_type');
  	  EditAccomplisment.attachTo('#editing .capture-property.accomplishment_type_id');
  	  Account.attachTo('#account');
  	  LifeConstraint.attachTo('#lifeConstraint');
  	  Profile.attachTo('#profile');
  	  Help.attachTo('#help');
  	  About.attachTo('#about');
  	  DatePickerPopup.attachTo('#special-controls .popup-datepicker');

  	  InitEdit.attachTo('#edit');
  	  StartEditing.attachTo('#editing');

  	  InitExport.attachTo('#export');
  	  Pflegestufe.attachTo('#pflegestufe');
  	  Backbutton.attachTo(document);

  	  window.onresize = function(){

  		  // $('#settings .inner-wrapper').height('50%');
    	  var naviHeight = utils.getMainNavigationHeight();
    	  $('#profile header').css({top : naviHeight + 'px'});
    	  var innerWrapperHeight = (window.innerHeight - (naviHeight + $('#profile header').height() + 75));
    	  $('#profile').height((window.innerHeight - naviHeight) * 0.9);
    	  $('#profile .inner-wrapper').css({top : naviHeight + 'px', height : innerWrapperHeight + 'px'});
		  $('#login .main').height(window.innerHeight - 50);
		  $('#signUp .main').height(window.innerHeight - 50);
		  // $('#settings .inner-wrapper').css({top : naviHeight + 'px', height : window.innerHeight - naviHeight + 'px'});
  	  };

  	  // cordova.exec(null, null, "SplashScreen", "hide", []);

  	  setTimeout(function(){
  		navigator.splashscreen.hide();
  	  }, 500);

  	  if ((parseInt(device.version) < 3 && device.platform == 'Android') || (parseInt(device.version) < 6 && device.platform == 'iOS')){

		  var scrollHelper = document.querySelectorAll('#capture .subcategories-wrapper .subcategories');
		  for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }

		  scrollHelper = document.querySelectorAll('#edit .day-report');
		  for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }

		  scrollHelper = document.querySelectorAll('#summary .swiper-slide');
	      for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }
	      utils.touchScroll(document.querySelector('#help-viewer'));

	      scrollHelper = document.querySelectorAll('#help .topics-wrapper .topics');
	      for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }

	      scrollHelper = document.querySelectorAll('#settings .inner-wrapper');
	      for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }

	      scrollHelper = document.querySelectorAll('.accounting .main');
	      for (var i = 0; i < scrollHelper.length; i++) {
				utils.touchScroll(scrollHelper[i]);
		  }
	  }

  }

  (function checkCordova() {
		// Check if Cordova exists
		if (window.cordova) {
			// Listen for the deviceready event
			document.addEventListener('deviceready', initialize, false);
		} else {
			// If Cordova does not exist, check again in 1/60th second
			devHelper++;
			if (devHelper === 10){
				setTimeout(checkCordova, 2000);
			} else {
				initialize();
			}
		}
	}());

});
