var Help = flight.component(function () {

  'use strict';

  if (localStorage.getItem('helpArticleList')){
	  var helpArticleList = JSON.parse(localStorage.getItem('helpArticleList'));  
  } else {
	  var helpArticleList = {"helpArticles":{"1":{"HelpArticle":{"id":"1","help_topic_id":"14","name":"Passwort vergessen","content":"<h1>Passwort vergessen</h1>\n\n<p>Haben Sie die App komplett neu auf Ihrem smartphone installiert oder möchten Sie sich auf einem anderen smartphone in die App einloggen und haben Ihr Passwort vergessen, so können Sie bei Start der App in der Login-Maske Ihre E-mail-Adresse, mit der Sie sich registriert haben, eingeben. Danach klicken Sie auf den Link &#8220;Passwort vergessen&#8221; unterhalb des Feldes für das Passwort und fordern damit eine neues Passwort per E-mail an.<br />\n<img alt=\"Passwort vergessen\" src=\"img/Icon_Passwort_vergessen.png\" title=\"Passwort vergessen\" /></p>\n\n<p>Der Satz &#8220;Eine Email mit Ihrem neuen Passwort wurde an Ihre Emailadresse versandt.&#8221; erscheint.</p>\n\n<p>Kurze Zeit später bekommen Sie eine E-mail mit neuem Passwort an die von Ihnen angegebene E-mail-Adresse. Mit dem neuen Passwort können Sie sich wieder in die App einloggen.</p>\n\n<blockquote>\n\t<p>Sie können das neue Passwort im Infomenü im Bereich &#8220;Nutzerkonto&#8221; verändern.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /></p>\n</blockquote>","created":"2014-05-13 16:23:55","modified":"2014-06-17 13:07:43"}},"4":{"HelpArticle":{"id":"4","help_topic_id":"3","name":"Leistungen der Pflegeversicherung","content":"<h1>Leistungen der Pflegeversicherung </h1>\n\n<p>Bei Pflegebedürftigkeit nach dem Gesetz wird eine Pflegestufe anerkannt. Dies geschieht bei Personen, die wegen einer körperlichen, geistigen oder seelischen Krankheit oder Behinderung für die gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen des täglichen Lebens erhebliche fremde Hilfe benötigen &#8211; und zwar über eine voraussichtliche Dauer von mindestens sechs Monaten.</p>\n\n<h2>Der Hilfebedarf </h2>\n\n<p>Maßgeblich für die Pflegestufen ist der Hilfebedarf bei den &#8220;gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen des täglichen Lebens&#8221;. Hiermit sind Hilfen der Grundpflege und der hauswirtschaftlichen Versorgung gemeint. Gibt es nur einen Hilfebedarf bei der hauswirtschaftlichen Versorgung, dann ist dies nicht ausreichend für eine Pflegestufe. </p>\n\n<h2>Die Pflegestufen </h2>\n\n<p>Die meisten Leistungen der sozialen Pflegeversicherung bemessen sich nach &#8220;Pflegestufen&#8221;. Sie reichen von &#8220;erheblicher&#8221; Pflegebedürftigkeit (Stufe 1) über &#8220;schwere Pflegebedürftigkeit&#8221; (Stufe 2) zu &#8220;Schwerster Pflegebedürftigkeit&#8221; (Stufe 3). Dabei wird vorrangig die häusliche Pflege, insbesondere durch Pflegegeld bzw. -sachleistungen, gefördert. </p>\n\n<p>Der <span class=\"caps\">MDK</span> (Medizinische Dienst der Krankenversicherung) gibt in sogenannten „Katalog-Verrichtungen“ vor, welche pflegerischen Verrichtungen für eine Pflegestufe anrechenbar sind. Diese Verrichtungen bilden die Grundlagen der App &#8220;interaktives Pflegetagebuch&#8221; und können darin dokumentiert werden.</p>","created":"2014-05-20 17:48:13","modified":"2014-12-30 10:13:00"}},"5":{"HelpArticle":{"id":"5","help_topic_id":"3","name":"Das Pflegetagebuch","content":"<h1>Das Pflegetagebuch</h1>\n\n<p>Zur Dokumentation der pflegerischen Verrichtungen ist es ratsam für mindestens 1 Woche vor Begutachtung durch den <span class=\"caps\">MDK</span> ein Pflegetagebuch zu führen. In diesem halten sie alle Verrichtungen <strong>minutengenau</strong> fest und notieren besondere Umstände und Tagesgeschehnisse rund um die Pflege, so dass ein Gesamtbild des Pflegeaufwandes, sowie die Pflege erschwerende Faktoren deutlich werden. Dies macht eine Einschätzung des tatsächlichen Pflegeaufwandes Ihres Angehörigen genauer und hilft Ihnen die Situation bei der Begutachtung detailliert darzulegen.</p>\n\n<p>In den Richtlinien zur Begutachtung sind Richtzeiten enthalten, die für die Verrichtung der einzelnen Tätigkeiten angesetzt werden sollen. Da jedoch die tatsächliche häusliche Situation beurteilt werden soll, kann mit entsprechender Begründung davon abgewichen werden. Zeitzuschläge gibt es, wenn die Pflege besonders schwierig ist, etwa wegen versteifter Gelenke, unkontrollierter Bewegungen, starker Schmerzen oder eines hohen Körpergewichts des Pflegebedürftigen. </p>\n\n<p>Daher ist es von Vorteil wenn Sie die Fragen zur „eingeschränkten Alltagskompetenz“ in dem Pflegetagebuch beantworten, so dass sich der Gutachter des <span class=\"caps\">MDK</span>, als auch de Pflegekasse, vor und in der Begutachtung, ein detailliertes Bild von Ihrem Angehörigen machen können und der Weg zu einer Pflegestufe für Sie und Ihren Angehörigen leichter wird.<br />\nBitte beachten Sie, dass Leistungen der so genannten medizinischen Behandlungspflege, z. B. Infusionen geben oder Verbände anlegen, nicht in das Tagebuch eingetragen werden sollten. Sie werden bei der Ermittlung der Pflegestufe nicht berücksichtigt, da dies Leistungen der Kranken- und nicht der Pflegeversicherung sind.</p>","created":"2014-05-20 17:54:09","modified":"2014-06-01 14:49:22"}},"6":{"HelpArticle":{"id":"6","help_topic_id":"1","name":"Grundpflege","content":"<h1>Die Grundpflege</h1>\n\n<p>Zur sogenannten Grundpflege gehören Verrichtungen, die den folgenden Kategorien angehören:</p>\n\n<ul>\n\t<li>Körperpflege: Waschen, Duschen, Baden, Zahnpflege, Kämmen, Rasieren, Darm- und Blasenentleerung</li>\n</ul>\n\n<ul>\n\t<li>Ernährung: mundgerechte Zubereitung der Nahrung und Hilfestellungen beim Essen und Trinken (<span class=\"caps\">NICHT</span> das Kochen)</li>\n</ul>\n\n<ul>\n\t<li>Mobilität: An- und Auskleiden, Aufstehen und Zu-Bett-gehen, Gehen, Stehen, Treppensteigen, das Verlassen und Wiederaufsuchen der Wohnung</li>\n</ul>","created":"2014-05-20 18:20:45","modified":"2015-01-30 11:28:37"}},"7":{"HelpArticle":{"id":"7","help_topic_id":"4","name":"Voraussetzungen für die Pflegestufen","content":"<h1>Voraussetzungen für die Pflegestufen</h1>\n\n<p>Der Zeitaufwand muss aufgrund der individuellen Pflegesituation, bezogen auf eine Woche, im Tagesdurchschnitt bestimme Mindestwerte erreichen:</p>\n\n<table>\n\t\t<tr>\n\t\t\t<td> <strong>Pflegestufe</strong> </td>\n\t\t\t<td> <strong>Hilfeb. Grundpfl.</strong> </td>\n\t\t\t<td> <strong>Min. ges.</strong> </td>\n\t\t\t<td> <strong>davon Grundpfl.</strong> </td>\n\t\t\t<td> <strong>davon Hauswirts.</strong> </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 1 </td>\n\t\t\t<td> wenigstens 2 Verrichtungen mind 1x tgl. </td>\n\t\t\t<td> 90 </td>\n\t\t\t<td> 45 </td>\n\t\t\t<td>45 </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 2 </td>\n\t\t\t<td> mindestens 3x tgl. zu versch. Tageszeiten </td>\n\t\t\t<td> 180 </td>\n\t\t\t<td> 120 </td>\n\t\t\t<td> 60 </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 3 </td>\n\t\t\t<td> rund um die Uhr auch nachts </td>\n\t\t\t<td> 300 </td>\n\t\t\t<td> 240 </td>\n\t\t\t<td> 60 </td>\n\t\t</tr>\n</table>\n\n<p>Anmerkungen Pflegestufe 3: zu verschiedenen Tageszeiten (6-22h) und auch regelmäßig mindestens 1x nachts (22-6h)</p>","created":"2014-05-21 09:51:30","modified":"2014-06-01 14:50:03"}},"8":{"HelpArticle":{"id":"8","help_topic_id":"4","name":"Hilfebedarf","content":"<h1>Hilfebedarf </h1>\n\n<p>Maßgeblich für die Einschätzung einer Pflegestufe ist der auf Dauer erforderliche Hilfebedarf für die gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen im Ablauf des täglichen Lebens im Bereich der Grundpflege und der hauswirtschaftlichen Versorgung. Der Hilfebedarf ist &#8220;regelmäßig&#8221; wenn er mindestens einmal pro Woche und auf Dauer &#8211; mindestens sechs Monate &#8211; anfällt. </p>\n\n<p>Der Gesetzgeber hat den Hilfebedarf, der für eine Pflegestufe wichtig ist, nach dem Zeitaufwand ausgelegt, der für die Hilfestellungen und Pflege notwendig ist. Zudem ist es für die Einstufung ausschlaggebend, welche Hilfen im Laufe eines Tages für diese definierten Verrichtungen notwendig sind. </p>\n\n<h2>Bemessung des Pflegeaufwands </h2>\n\n<p>Maßstab für die Bemessung der Pflegeaufwands ist grundsätzlich die Pflegezeit, die nicht professionelle Personen (z.B. Familienangehörige) im Sinne einer Laienpflege benötigen würden. Maßgebend ist zwar stets die individuelle Pflegesituation, jedoch gibt es Orientierungswerte für die Pflegezeit, die bei der Begutachung herangezogen werden können. Dadurch sollen pflegebedürftige Menschen mit ähnlichen Einschränkungen &#8211; unabhängig von der Pflegeperson &#8211; möglichst gleich behandelt und somit derselben Pflegestufe zugeordnet werden.</p>","created":"2014-05-21 10:22:43","modified":"2014-12-30 10:14:48"}},"9":{"HelpArticle":{"id":"9","help_topic_id":"9","name":"Hilfeformen","content":"<h1>Hilfeformen</h1>\n\n<p>Der Gesetzgeber hat den Hilfebedarf, der für eine Pflegestufe wichtig ist, nach dem Zeitaufwand ausgelegt, der für die Hilfestellungen und Pflege notwendig ist. Zudem ist es für die Einstufung ausschlaggebend, welche Hilfen im Laufe eines Tages für diese definierten Verrichtungen notwendig sind. Wenn der Gutachter des <span class=\"caps\">MDK</span> zu Ihrem Angehörigen kommt, um den Pflegebedarf zu ermitteln, nimmt er eine Pflegezeitbemessung für die Verrichtungen der Grundpflege vor. Dazu teilt er die Hilfeleistungen in so genannte Hilfeformen ein. Eine mögliche Hilfeform ist die Vollübernahme. Das heißt, Sie übernehmen die vollständige Verrichtung, und Ihr Angehöriger bleibt bei allem passiv.</p>\n\n<blockquote>\n\t<p>Wichtig: Je Verrichtung, die in der App interaktives Pflegetagebuch angelegt wird, muss neben dem Zeitpunkt, der Dauer der Verrichtung und der Anzahl der beteiligten Helfer eine Hilfeform angegeben werden um die Einschätzung der Pflegestufe so korrekt wie möglich vornehmen zu können. Die Hilfeform kann auch im Nachhinein nach Anlage einer Verrichtung unter dem Punkt &#8220;Bearbeiten&#8221; hinzugefügt werden. <br />\nDokumentierte Verrichtungen, zu denen wichtige Informationen fehlen sind mit einem orangen Ausrufezeichen markiert.<br />\n<img alt=\"Daten unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten unvollständig\" /></p>\n</blockquote>\n\n<h2>Die verschiedenen Hilfeformen</h2>\n\n<h3>Unterstützung</h3>\n\n<p>Unterstützung bedeutet, dass der Pflegebedürftige grundsätzlich zur selbständigen Erledigung einer Verrichtung in der Lage ist, jedoch zur Vorbereitung, Durchführung oder Nachbereitung ergänzende Hilfeleistungen der Pflegeperson benötigt (Beispiel: Durch eine teilweise Lähmung muss die Hand des rechten Armes zum Kämmen von einer anderen Person geführt werden).</p>\n\n<h3>Übernahme</h3>\n\n<p>Teilweise Übernahme bedeutet, dass eine Hilfe bei einer teilweise selbständig erledigten Verrichtung benötigt wird. Vollständige Übernahme bedeutet, dass die Pflegeperson die Verrichtung notwendigerweise selbst ausführt, da der Pflegebedürftige diese nicht selbst ausführen kann.</p>\n\n<h3>Anleitung</h3>\n\n<p>Anleitung und Beaufsichtigung haben zum Ziel, dass die täglichen Verrichtungen in sinnvoller Weise vom Pflegebedürftigen selbst durchgeführt werden. Anleitung bedeutet, dass die Pflegeperson bei einer konkreten Verrichtung den Ablauf der einzelnen Handlungsschritte oder den ganzen Handlungsablauf lenken oder demonstrieren muss (Beispiel: Die Pflegeperson muss beim Waschen den Ablaufder einzelnen Handlungsabschnitte lenken oder demonstrieren).</p>\n\n<h3>Beaufsichtigung</h3>\n\n<p>Bei der Beaufsichtigung steht zum einen die Sicherheit beim konkreten Handlungsablauf der Verrichtung(Eigen- oder Fremdgefährdung) im Vordergrund (z. B. beim Rasieren, wenn durch unsachgemäße Benutzung des Rasierapparates eine Selbstgefährdung beim konkreten Handlungsablauf der Verrichtung gegeben ist), zum anderen die Kontrolle darüber, ob die betreffenden Verrichtungen in der erforderlichen Art und Weise durchgeführt werden.</p>\n\n<h2>Orientierungswerte</h2>\n\n<p>Für jede Hilfeform gibt es sogenannte Orientierungswerte, in denen der zu berücksichtigende Zeitbedarf für die Pflegestufe festgelegt ist.<br />\nBei einer leichten Demenz beispielsweise genügt bei der Pflege die Aufforderung, eine Mahlzeit einzunehmen. Liegt eine schwere Demenz vor, muss der Erkrankte hingegen nahezu zu jedem Bissen einzeln aufgefordert werden. Diese Hilfeform wäre dann eine Anleitung in Verbindung mit Beaufsichtigung, hat einen wesentlich höheren Zeitaufwand als die Hilfe bei einer leichten Demenz, und gehört somit zu einer höheren Pflegestufe. </p>","created":"2014-05-21 10:28:39","modified":"2014-06-16 13:48:59"}},"10":{"HelpArticle":{"id":"10","help_topic_id":"5","name":"Pflegesachleistungen","content":"<h1>Pflegesachleistungen </h1>\n\n<p>Von Pflegesachleistungen spricht man, wenn ein Pflegebedürftiger zu Hause durch einen ambulanten Pflegedienst gepflegt wird. Die Pflegekasse rechnet direkt mit dem Pflegedienst ab. Im Angebot sind die Pflege, Hilfen im Haushalt und die sogenannte häusliche Betreuung. Pflegebedürftige können solche Sachleistungen der Pflegekasse von ambulanten Pflegediensten in Anspruch nehmen bis zu monatlich </p>\n\n<ul>\n\t<li>231 Euro in der Pflegestufe 0</li>\n\t<li>468 Euro in der Pflegestufe 1</li>\n\t<li>1.144 Euro in der Pflegestufe 2</li>\n\t<li>1.612 Euro in der Pflegestufe 3</li>\n</ul>\n\n<p>Auch Menschen mit besonderem Betreuungsbedarf aufgrund von &#8220;Einschränkungen der Alltagskompetenz&#8221;, etwa wegen einer Demenz, erhalten Leistungen der Pflegeversicherung. Wer schon in Pflegestufe 1 oder 2 eingestuft ist, erhält Zuschläge. Menschen mit Einschränkungen der Alltagskompetenz können daher Leistungen von ambulanten Pflegediensten im folgenden Umfang erhalten: </p>\n\n<ul>\n\t<li>231 Euro ohne Pflegestufe</li>\n\t<li>689 Euro in der Pflegestufe 1</li>\n\t<li>1.298 Euro in der Pflegestufe 2</li>\n</ul>\n\n<p>In Pflegestufe 3 und bei Härtefällen bleibt es bei den üblichen Leistungen.</p>","created":"2014-05-21 10:37:08","modified":"2014-12-30 10:18:55"}},"11":{"HelpArticle":{"id":"11","help_topic_id":"5","name":"Bündelung von Leistungen","content":"<h1>Bündelung von Leistungen</h1>\n\n<p>Immer mehr Menschen wollen auch im Alter weitgehend selbstbestimmt leben und suchen daher als Alternative zum Heim andere Wohnformen wie zum Beispiel Wohngemeinschaften für Senioren. Künftig soll das Zusammenleben in solchen Wohnformen verbessert werden. Daher können Versicherte ihre Ansprüche auf Sachleistungen gemeinsam mit anderen Leistungsberechtigten bündeln, die zum Beispiel auch in der Wohngemeinschaft leben. Das bedeutet etwa, dass sich eine Pflegekraft um mehrere Pflegebedürftige innerhalb einer Wohngemeinschaft kümmert. Die durch die Bündelung der Ansprüche entstehenden Kosten- und Zeitersparnisse können dann für zusätzliche Betreuungsleistungen genutzt werden.</p>","created":"2014-05-21 10:37:53","modified":"2014-06-01 14:54:08"}},"12":{"HelpArticle":{"id":"12","help_topic_id":"5","name":"Pflegegeld","content":"<h1>Pflegegeld </h1>\n\n<p>Pflegegeld erhält man, wenn ehrenamtliche Pfleger die häusliche Pflege übernehmen. Das können zum Beispiel Familienangehörige oder Nachbarn sein. In diesem Fall erhält der Pflegebedürftige das Pflegegeld direkt auf sein Konto, und zwar </p>\n\n<ul>\n\t<li>244 Euro in der Pflegestufe 1</li>\n\t<li>458 Euro in der Pflegestufe 2</li>\n\t<li>728 Euro in der Pflegestufe 3</li>\n</ul>\n\n<p>Der Pflegebedürftige bestimmt auch hier selbst, wie das Geld ausgegeben wird. Auch Menschen mit besonderem Betreuungsbedarf aufgrund von &#8220;Einschränkungen der Alltagskompetenz&#8221;, etwa wegen einer Demenz, erhalten Leistungen der Pflegeversicherung. <br />\nWer schon in Pflegestufe 1 oder 2 eingestuft ist, erhält Zuschläge. Menschen mit Einschränkungen der Alltagskompetenz können daher Pflegegeld im folgenden Umfang erhalten: </p>\n\n<ul>\n\t<li>123 Euro ohne Pflegestufe</li>\n\t<li>316 Euro in der Pflegestufe 1</li>\n\t<li>545 Euro in der Pflegestufe 2</li>\n</ul>\n\n<p>In Pflegestufe 3 bleibt es bei den üblichen Leistungen.</p>","created":"2014-05-21 10:39:30","modified":"2014-12-30 10:20:49"}},"13":{"HelpArticle":{"id":"13","help_topic_id":"5","name":"Kombination von Sachleistung und Pflegegeld","content":"<h1>Kombination von Sachleistung und Pflegegeld </h1>\n\n<p>Dabei werden prozentuale Anteile der nicht verbrauchten Pflegesachleistungen auf das Pflegegeld angerechnet. Beispiel: Ein Pflegebedürftiger (mit Pflegestufe 2) hat Anspruch auf Pflegesachleistungen von 1.144 Euro. Tatsächlich verbraucht werden aber nur 70 Prozent, also eine Summe von 800,80 Euro. Deshalb können 30 Prozent vom Pflegegeld ausgezahlt werden. Bei einem Satz von 458 Euro wären das in diesem Fall 137,40 Euro.</p>","created":"2014-05-21 10:40:33","modified":"2014-12-30 10:22:03"}},"14":{"HelpArticle":{"id":"14","help_topic_id":"1","name":"Körperpflege","content":"<h1>Körperpflege</h1>\n\n<p>Die Rubrik &#8220;Körperpflege&#8221; gehört zu der Hauptkategorie &#8220;Grundpflege&#8221; (gemeinsam mit Ernährung und Mobilität). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>Waschen, Duschen, Baden</h2>\n\n<p>Hierunter fällt das Waschen des Körpers sowie der Haare, entweder unter der Dusche, in der Badewanne, am Waschbecken oder auch im Bett. Zum Waschvorgang gehören die erforderlichen Vorbereitungen (z. B. das Zurechtlegen der erforderlichen Utensilien wie Seife/Handtuch, das Einlassen des Badewassers sowie das Bedienen der Armaturen), der Waschvorgang selbst sowie das Abtrocknen und Eincremen des Körpers und auch die Haartrocknung.</p>\n\n<h2>Mund-/Zahnpflege</h2>\n\n<p>Zur Zahnpflege zählen die Vorbereitung (z. B. das Öffnen und Schließen der Zahnpastatube einschließlich der Dosierung der Zahnpasta und das Füllen des Wasserglases), der Putzvorgang einschließlich der Mundpflege sowie die Reinigung von Zahnersatz.</p>\n\n<h2>Kämmen</h2>\n\n<p>Dies umfasst das Kämmen und Bürsten der Haare entsprechend der individuellen Frisur. Das Legen von Frisuren (z. B. Dauerwelle) oder das Haareschneiden können nicht berücksichtigt werden. Trägt der Pflegebedürftige ein Toupet oder eine Perücke, so gehört zum Hilfebedarf das Kämmen und Aufsetzen des Haarteils.</p>\n\n<h2>Rasieren</h2>\n\n<p>Rasieren beinhaltet wahlweise die Trocken oder Nassrasur einschließlich der notwendigen Hautpflege. Bei Frauen wird hier die Gesichtspflege – mit Ausnahme des Schminkens – berücksichtigt.</p>\n\n<h2>Blasen-/Darmentleerung</h2>\n\n<p>Hierzu gehören die Kontrolle des Harn- und Stuhlganges, die Reinigung und Versorgung von künstlich geschaffenen Ausgängen sowie die notwendigen Handgriffe bei dem jeweiligen Hygienevorgang, das Richten der Kleidung vor und nach dem Gang zur Toilette, die Intimhygiene wie das Säubern nach dem Wasserlassen und dem Stuhlgang sowie das Entleeren und Säubern eines Toilettenstuhls bzw. eines Stechbeckens. Ebenso zählen das Anlegen bzw. Wechseln von Windeln dazu.</p>","created":"2014-05-21 10:52:06","modified":"2014-06-15 20:11:08"}},"15":{"HelpArticle":{"id":"15","help_topic_id":"1","name":"Ernährung","content":"<h1>Ernährung</h1>\n\n<p>Die Rubrik &#8220;Ernährung&#8221; gehört zu der Hauptkategorie &#8220;Grundpflege&#8221; (gemeinsam mit Körperpflege und Mobilität). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>Mundgerechte Zubereitung</h2>\n\n<p>Hierzu zählen die Tätigkeiten, die zur unmittelbaren Vorbereitung dienen, wie die portionsgerechte Vorgabe, das Zerkleinern der zubereiteten Nahrungsmittel, z. B. das mundgerechte Zubereiten bereits belegter Brote, ebenso die notwendige Kontrolle der richtigen Essenstemperatur. Hierzu zählen nicht das Kochen oder das Eindecken des Tisches. Die Zubereitung von Diäten fällt unter die Pflegeleistung „Kochen“.</p>\n\n<h2>Nahrungsaufnahme</h2>\n\n<p>Hierunter fallen die Nahrungsaufnahme in jeder Form (fest, flüssig) sowie eine ggf. erforderliche Sondenernährung und die Verwendung bzw. der Umgang mit dem Essbesteck oder anderen geeigneten Geräten, um die Nahrung zum Mund zu führen, zu kauen und zu schlucken.</p>","created":"2014-05-21 11:00:15","modified":"2014-06-15 20:12:04"}},"16":{"HelpArticle":{"id":"16","help_topic_id":"1","name":"Mobilität","content":"<h1>Mobilität</h1>\n\n<p>Die Rubrik &#8220;Mobilität&#8221; gehört zu der Hauptkategorie &#8220;Grundplege&#8221; (gemeinsam mit Ernährung und Körperpflege). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>An-/Auskleiden</h2>\n\n<p>Das An- und Auskleiden beinhaltet neben notwendigen Handgriffen (z. B. das Öffnen und Schließen von Verschlüssen, das Auf-und Zuknöpfen sowie das An- und Ausziehen von Kleidungsstücken/Schuhen) die Auswahl der Kleidungsstücke entsprechend Jahreszeit und Witterung, die Entnahme der Kleidung aus ihrem normalen Aufbewahrungsort (z. B. Kommode oder Schrank) sowie die Überprüfung der Kleidung. Hierunter fällt auch das Anlegen von Prothesen oder Hilfsmitteln.</p>\n\n<h2>Aufstehen/zu Bett gehen</h2>\n\n<p>Das selbständige Aufstehen und Zu-Bett-Gehen umfasst die eigenständige Entscheidung, zeitgerecht das Bett aufzusuchen bzw. zu verlassen. Hierunter fällt auch das Umlagern von bettlägerigen Pflegebedürftigen. Fällt das Umlagern in Verbindung mit anderen Verrichtungen an, so erfolgt die Zuordnung bei der jeweiligen Verrichtung.</p>\n\n<h2>Gehen/Stehen/Transfer/Treppensteigen</h2>\n\n<p>Das Gehen, Stehen und Treppensteigen ist nur dann maßgebend, wenn es im Zusammenhang mit den genannten Verrichtungen der Körperpflege und der Ernährung erforderlich wird. Unter Gehen ist hier das Bewegen innerhalb der Wohnung (z. B. zum Waschen/Duschen/Baden oder zur Toilettennutzung) zu verstehen. Bei Rollstuhlfahrern fällt hierunter der Hilfebedarf, der durch die Benutzung eines Rollstuhls erforderlich wird. Zum Stehen gehört nicht nur, diese Körperhaltung zu erreichen (Aufstehen), sondern diese auch über einen längeren Zeitraum zu bewahren. Das Treppensteigen beinhaltet das notwendige Überwinden von Stufen innerhalb der Wohnung. Das Gehen und Treppensteigen im Zusammenhang mit der hauswirtschaftlichen Versorgung zählt zum Hilfebedarf im Bereich Hauswirtschaft.</p>\n\n<h2>Umlagern</h2>\n\n<p>Hierunter sind alle Positionswechsel im Bett/Stuhl etc. zu verstehen, die die pflegebedürftige Person nicht allein vornehmen kann, sondern die über eine Hilfeform durch Angehörige etc. unterstützt werden müssen. Positionswechsel sind ebenso aufgrund von Prophylaxen zu Druckgeschwüren oder Gelenkversteifungen, Unterstützung der Atmung etc. regelmäßig vorzunehmen.</p>\n\n<h2>Verlassen/Wiederaufsuchen der Wohnung</h2>\n\n<p>Das Verlassen und Wiederaufsuchen der Wohnung ist maßgebend, wenn es im<br />\nZusammenhang mit Verrichtungen erforderlich wird, die für die Aufrechterhaltung der Lebensführung zu Hause unumgänglich sind und das persönliche Erscheinen des Pflegebedürftigen notwendig machen. Hierzu zählt das Aufsuchen von Ärzten, Apotheken und Behörden sowie die Inanspruchnahme ärztlich veranlasster Therapien, wenn diese mindestens einmal pro Woche anfallen.<br />\nNeben den Fahrzeiten werden die zwangsläufig anfallenden Wartezeiten der Pflegeperson angerechnet, wenn sie dadurch zeitlich und örtlich gebunden ist. Das Verlassen/Wiederaufsuchen der Wohnung im Zusammenhang mit Freizeitaktivitäten (z. B. Spaziergänge, Besuche von kulturellen Veranstaltungen) sowie das Aufsuchen von Kindergärten, Schulen, Arbeitsplätzen oder Werkstätten für behinderte Menschen bleiben unberücksichtigt.</p>","created":"2014-05-21 11:19:23","modified":"2014-06-15 20:12:41"}},"17":{"HelpArticle":{"id":"17","help_topic_id":"1","name":"hauswirtschaftliche Versorgung","content":"<h1>Die hauswirtschaftliche Versorgung</h1>\n\n<p>Verrichtungen der hauswirtschaftlichen Versorgung finden nur insoweit Berücksichtigung in der Berechnung einer Pflegesufe, als sie sich auf die Versorgung des Pflegebedürftigen selbst beziehen. Die Versorgung möglicher weiterer Familienangehöriger bleibt unberücksichtigt.</p>\n\n<p>Hauswirtschaftliche Verrichtungen sind:</p>\n\n<h2>Einkaufen</h2>\n\n<p>Das Einkaufen beinhaltet das Planen und sich informieren über die zu beschaffenden Lebens-, Reinigungs- und Körperpflegemitteln, den Überblick darüber, welche Lebensmittel wo eingekauft werden müssen unter Berücksichtigung der Jahreszeit und der benötigten Menge, preisbewusstes, kostengünstiges Wirtschaften und die Kenntnis der Genieß- und Haltbarkeit von Lebensmitteln sowie ihrer richtigen Lagerung.</p>\n\n<h2>Kochen</h2>\n\n<p>Zum Kochen gehören das Vor- und Zubereiten der Bestandteile der Mahlzeiten sowie das Aufstellen eines Speiseplanes für die richtige Ernährung unter Berücksichtigung des Alters und der Lebensumstände des Pflegebedürftigen. Hierzu gehört auch die Bedienung der zum Kochen erforderlichen technischen Geräte sowie die Einschätzung der Mengenverhältnisse und Garzeiten unter Beachtung der Hygieneregeln.</p>\n\n<h2>Wohnungsreinigung</h2>\n\n<p>Hierzu gehören das Reinigen von Fußböden, Möbeln, Fenstern und Haushaltsgeräten im allgemein üblichen Lebensbereich des Pflegebedürftigen, die Kenntnis von Reinigungsmitteln und -geräten sowie das Bettenmachen.</p>\n\n<h2>Spülen</h2>\n\n<p>Je nach Gegebenheiten des Haushalts fällt hierunter das Hand- bzw. maschinelle Spülen.</p>\n\n<h2>Wechsel/Waschen der Kleidung/Wäsche</h2>\n\n<p>Hierzu gehören das Einteilen und Sortieren der Textilien, das Waschen, Aufhängen, Bügeln, Ausbessern und Einsortieren der Kleidung in den Schrank sowie das Bettenbeziehen.</p>\n\n<h2>Beheizen der Wohnung</h2>\n\n<p>Das Beheizen umfasst auch die Beschaffung und Entsorgung von Heizmaterial.</p>","created":"2014-05-21 11:27:07","modified":"2014-06-15 20:13:25"}},"18":{"HelpArticle":{"id":"18","help_topic_id":"2","name":"Eingeschränkte Alltagskompetenz","content":"<h1>Eingeschränkte Alltagskompetenz </h1>\n\n\n<p>Mit dem 1. Pflegeverstärkungsgesetz (Januar 2015) besteht für alle Pflegebedürftigen die Möglichkeit, zusätzliche Betreuungs- und Entlastungsleistungen in Anspruch zu nehmen. Wird eine eingeschränkte Alltagskompetenz festgestellt, können Leistungen in Höhe von 104 bis 208 Euro im Monat in Anspruch genommen werden. </p>\n\n<p>Die Gutachter beurteilen anhand von 13 festgelegten Kriterien die Schwere der &#8220;Einschränkungen der Alltagskompetenz&#8221;. Werden bei der Begutachtung wenigstens zwei dieser Kriterien erfüllt, davon eines aus einem eingegrenzten Kriterienkatalog, besteht ein Anspruch auf Leistungen der Pflegeversicherung, selbst dann, wenn keine Pflegestufe vorliegt (Pflegestufe 0). </p>\n\n<p>Die Kriterien sind: </p>\n\n<h2>Orientierung</h2>\n\n<p>Orientierung beschreibt das Bescheid wissen über Ort, Zeit, Situation und Person. </p>\n\n<h2>Örtliche Orientierung </h2>\n\n<p>Örtliche Orientierung beinhaltet die Fähigkeit seinen Aufenthaltsort zu kennen und sich im eigenen Bewegungsradius zurecht zu finden. z.B. der Ortsname kann nur mit Mühe genannt werden kann oder die Orientierung in der Wohnung gelingt nicht mehr. </p>\n\n<h2>Zeitliche Orientierung </h2>\n\n<p>Zeitliche Orientierung beinhaltet die Fähigkeit, Tag und Uhrzeit zu kennen und entsprechend den Tagesablauf strukturieren zu können. </p>\n\n<h2>Situative Orientierung </h2>\n\n<p>Situative Orientierung beinhaltet das Verständnis für die derzeitige Lebenslage und die Hintergründe, die zur derzeitigen Situation geführt haben. </p>\n\n<h2>Personelle Orientierung </h2>\n\n<p>Personelle Orientierung beinhaltet das Wissen über die aktuelle persönliche als auch lebensgeschichtliche Situation und die individuelle Beziehung zu den Kontaktpersonen. z.B. ist eine Angabe des eigenen Namens, Geburtstags und Alter nicht möglich. </p>\n\n<h2>Antrieb/Beschäftigung </h2>\n\n<p>Die geistige Fähigkeit, geprägt durch Erlebnisse und Gewohnheiten, seine Zeit sinnvoll einzuteilen, sich entsprechend zu beschäftigen und seine Aktivitäten von sich aus aufzunehmen und an seine körperlichen Fähigkeiten anzupassen. </p>\n\n<h2>Stimmung </h2>\n\n<p>Die Stimmung drückt das Empfinden und die Steuerung von Emotionen wie z. B. Freude, Trauer, Hass aus. </p>\n\n<h2>Gedächtnis </h2>\n\n<p>Die Fähigkeit, Erlebtes und Erlerntes behalten und wiedergeben zu können. Im Langzeitgedächtnis sind z.B. biografische Angaben gespeichert. Das Kurzzeitgedächtnis umfasst die Merkfähigkeit, d. h. die Speicherung neu gelernter Inhalte für einige Minuten. </p>\n\n<h2>Tag-/Nachtrhythmus</h2>\n\n<p>Hierzu gehört die Fähigkeit, einen regelmäßigen und altersentsprechenden Rhythmus sowie die Art und Weise von Wachen, Ruhen und Schlafen zu gestalten und aufrecht zu erhalten, wie z. B. der Umgang mit Schlafstörungen, auch nach nächtlichen Unterbrechungen durch Wasserlassen oder das Einplanen notwendiger Ruhepausen tagsüber. </p>\n\n<h2>Wahrnehmung und Denken </h2>\n\n<p>Hierzu gehört die Fähigkeit, Informationen aus der Umgebung aufnehmen und einordnen zu können, logische Folgerungen zu schließen und begründete Entscheidungen treffen zu können. Dabei spielt das Erkennen von Gefahren und das Einschätzen von Risiken eine wesentliche Rolle. Formale Denkstörungen zeigen sich meistens in der Sprache. Es handelt sich dabei um Veränderungen in der Geschwindigkeit, Kohärenz und Stringenz des Gedankenablaufes. </p>\n\n<h2>Kommunikation und Sprache</h2>\n\n<p>Hierzu gehört die geistige Fähigkeit zum sinnhaften, interpersonellen Austausch unter Berücksichtigung kultureller Gegebenheiten. Wesentlich sind das Verstehen der Bezugsperson (hören, sehen, lesen) und Wünsche und Gedanken äußern zu können (Sprache, Schrift, Gestik, Mimik und Ausdruck von Gefühlen). </p>\n\n<h2>Situatives Anpassen </h2>\n\n<p>Dies beinhaltet die Fähigkeit, sich auf wechselnde Anforderungen/Situationen einzustellen, wie z. B. Besuch/Alleinsein/Wechsel der Bezugsperson, Änderung des üblichen Tagesablaufes, sich in gegebenen Situationen adäquat verhalten zu können, wie z. B. die Fähigkeit, Wünsche zu äußern, bei Gefahr Hilfe einzuholen, aber auch Ablehnungen deutlich zu machen. </p>\n\n<h2>Soziale Bereiche des Lebens wahrnehmen </h2>\n\n<p>Hierzu gehört die Fähigkeit, selbstständig soziale Kontakte aufnehmen und aufrecht erhalten zu können und sein Leben verantwortlich innerhalb des gesellschaftlichen Beziehungsgeflechtes zu gestalten. Das bedeutet u. a., Kontakte zu Familie, Nachbarn und Freunden pflegen zu können oder die Geschäftsfähigkeit bezüglich finanzieller und behördlicher Angelegenheiten zu erhalten.</p>","created":"2014-05-21 11:37:59","modified":"2014-12-30 10:36:41"}},"19":{"HelpArticle":{"id":"19","help_topic_id":"8","name":"Der Antrag zur Pflegestufe","content":"<h1>Der Antrag zur Pflegestufe </h1>\n\n<p>Damit Ihr Angehöriger vom <span class=\"caps\">MDK</span> (Medizinischen Dienst der Krankenversicherung) für eine Pflegeeinstufung begutachtet wird, müssen Sie vorher einen Antrag bei der Pflegeversicherung stellen. Der Antrag auf Leistungen der Pflegekasse kann formlos sein. Daraufhin senden die Pflegekassen normalerweise ein Formular zu, um genaue Angaben über Ihren Pflegealltag zu bekommen. Dabei dürfen nur Informationen abgefragt werden, die für die Beurteilung der Pflegebedürftigkeit notwendig sind. </p>\n\n<p>Als Antragsdatum gilt bei der Beurteilung der Pflegebedürftigkeit das Eingangsdatum des formlosen Antrags, nicht der Zeitpunkt der Rücksendung des Formulars an die Pflegeversicherung. Nachdem der Antrag auf Feststellung des Pflegebedarfs gestellt wurde, beauftragt die Pflegeversicherung den Medizinischen Dienst der Krankenkassen, Ihren Angehörigen zu begutachten. Dies erfolgt durch einen vorher angemeldeten Hausbesuch.</p>","created":"2014-05-21 11:45:35","modified":"2014-12-30 10:23:10"}},"20":{"HelpArticle":{"id":"20","help_topic_id":"8","name":"Eine Höherstufung beantragen","content":"<h1>Eine Höherstufung beantragen</h1>\n\n<p>Auch bei bereits anerkannter Pflegebedürftigkeit kann ein Antrag auf eine höhere Pflegeeinstufung gestellt werden. Dafür sollte die letzte Begutachtung jedoch mindestens sechs Monate zurückliegen. Diese Wartefrist gilt nicht, wenn sich der Gesundheitszustand Ihres Angehörigen erheblich verschlechtert hat.</p>\n\n<p>Da beim Höherstufungsantrag die aktuelle Pflegebedürftigkeit geprüft wird, kann es allerdings auch passieren, dass die Einstufung in eine niedrigere Pflegestufe erfolgt. Auch hier macht der <span class=\"caps\">MDK</span> einen Hausbesuch. </p>","created":"2014-05-21 11:46:26","modified":"2014-06-01 14:57:15"}},"21":{"HelpArticle":{"id":"21","help_topic_id":"8","name":"Besuch durch den MDK","content":"<h1>Besuch durch den <span class=\"caps\">MDK</span></h1>\n\n<p>Der <span class=\"caps\">MDK</span> (Medizinischer Dienst der Krankenkassen) schickt im Auftrag der Pflegeversicherung einen Gutachter, der feststellt, ob eine Pflegebedürftigkeit vorliegt, und wenn ja, im Maße welcher Pflegestufe. Dafür sollten Sie auf jeden Fall dabei sein, denn der Gutachter muss Sie, die Pflegeperson, befragen, welche Hilfen Sie erbringen. Wird ihr pflegender Angehöriger auch von einem Pflegedienst versorgt, so ist es ratsam, eine Pflegekraft, die mit Ihrem Angehörigen vertraut ist, für das Gespräch hinzu zu holen. Für die Begutachtung ist es praktisch, das Pflegetagebuch bzw. den Ausdruck zur Hand zu haben. Sie können dem Gutachter den Ausdruck auch mitgeben – aber das müssen Sie nicht. </p>\n\n<h2>Die Begutachtung</h2>\n\n<p>Dem Gutachter zu erzählen, Sie würden alles für Ihren Angehörigen übernehmen, ist nicht empfehlenswert. Berichten Sie ihm, dass Sie sich bemühen, Ihren Angehörigen zur eigenen Ausführung von Handlungen anzuleiten. Dafür muss bei der Einschätzung des Hilfebedarfs (und der Pflegestufe) mehr Zeit berücksichtigt werden als für eine Vollübernahme. Wenn Sie während der gesamten Durchführung einer Handlung anwesend sein müssen, weisen Sie den Gutachter darauf hin. </p>","created":"2014-05-21 11:47:51","modified":"2014-06-01 14:57:59"}},"22":{"HelpArticle":{"id":"22","help_topic_id":"8","name":"Vorbereitung auf die MDK-Begutachtung","content":"<h1>Vobereitung auf die <span class=\"caps\">MDK</span>-Begutachtung</h1>\n\n<p>Je besser sich der Antragsteller auf den Besuch des Gutachters vorbereitet, umso größer ist die Chance auf ein Gutachten, das dem tatsächlichen Pflegebedarf des Betroffenen entspricht. Denn der Medizinische Dienst bekommt bei seinem Termin nur einen kurzen Einblick in die Lebens- und Pflegesituation einer Person. <br />\nWas sollten Sie beachten:</p>\n\n<ul>\n\t<li>Halten Sie über eine Spanne von mindestens 7 Tagen in dem Pflegetagebuch die Zeiten fest, die für Katalog-Verrichtungen (Körperpflege, Ernährung, Mobilität, Hauswirtschaft) benötigt werden und schicken Sie diese Dokumentation bereits im Vorhinein der Begutachtung an den <span class=\"caps\">MDK</span>.</li>\n</ul>\n\n<ul>\n\t<li>Besorgen Sie sich alle Unterlagen und Berichte von Fachleuten, die die Krankengeschichte belegen und einen entsprechenden Pflegeaufwand erklären können, zum Beispiel von Hausarzt, Facharzt, Pflegedienst, Therapeuten, Krankenkasse!</li>\n</ul>\n\n<ul>\n\t<li>Pflegepersonen sollten beim Begutachtungstermin anwesend sein.</li>\n</ul>\n\n<ul>\n\t<li>Ist bereits ein ambulanter Pflegedienst tätig, so sollte ein Mitarbeiter des Dienstes bei dem Termin dabei sein.</li>\n</ul>\n\n<ul>\n\t<li>Falsche Antworten, zum Beispiel aus Scham (&#8220;diese Hilfe habe ich nicht nötig&#8221;) oder zu optimistische Antworten (&#8220;das schaffe ich schon&#8221;) können dazu führen, dass keine oder zu wenig Leistungen gewährt werden. Besprechen Sie mir Ihrem Angehörigen im Vorhinein, dass er sich so verhält wie immer und in der Begutachtung keine besondere Leistung zeigen muss.</li>\n</ul>\n\n<ul>\n\t<li>Übrigens: Auf Wunsch muss der Gutachter den Pflegebedürftigen auch alleine anhören.</li>\n</ul>","created":"2014-05-21 11:49:40","modified":"2014-06-15 20:24:21"}},"23":{"HelpArticle":{"id":"23","help_topic_id":"8","name":"Der Einstufungsbescheid der Pflegestufe","content":"<h1>Der Einstufungsbescheid der Pflegestufe</h1>\n\n<p>Nach dem Hausbesuch teilt der Gutachter der Pflegeversicherung mit, welche Pflegeeinstufung er empfiehlt. Normalerweise übernehmen die Pflegekassen diese Einschätzung der Pflegestufe. Der Einstufungsbescheid über die Pflegebedürftigkeit und Pflegestufe wird von der Pflegeversicherung erlassen. </p>\n\n<p>Der schriftliche Bescheid sollte Ihnen nach spätestens fünf Wochen vorliegen (gemäß § 18 Abs. 3 <span class=\"caps\">SGB</span> XI). Hat der Gutachter eine Pflegebedürftigkeit festgestellt, werden die Pflegeleistungen ab dem Datum der Antragstellung gezahlt. Bei dem Einstufungsbescheid handelt es sich um einen Verwaltungsakt. Deswegen muss mit dem Bescheid auch eine sogenannte Rechtsmittelbelehrung erfolgen. Das bedeutet, dass Ihnen die Möglichkeit beschrieben wird, innerhalb eines Monats gegen die Entscheidung Widerspruch einzulegen. Wenn diese Rechtsmittelbelehrung fehlt, verlängert sich die Frist auf ein Jahr. </p>\n\n<p>Zusammen mit dem Einstufungsbescheid erhalten Sie weitere Informationen zur Unterstützungsmöglichkeiten für Ihren Angehörigen. So können Sie bspw. Anleitungen und Schulungen zu Pflegethemen über die Pflegekasse (gemäß § 45c <span class=\"caps\">SBG</span> XI)oder sogar individuelle Beratung zur Pflegesituation Ihres Angehörigen über Pflegeberater der Pflegekasse oder den Pflegestützpunkt in Ihrer Region (gemäß § 7 <span class=\"caps\">SGB</span> XI)erhalten.</p>","created":"2014-05-21 11:57:08","modified":"2014-06-01 14:59:09"}},"24":{"HelpArticle":{"id":"24","help_topic_id":"5","name":"Rentenanspruch pflegender Angehöriger","content":"<h1>Rentenanspruch pflegender Angehöriger</h1>\n\n<p>Wenn Sie eine Angehörige oder einen Angehörigen für mindestens 14 Stunden in der Woche pflegen und diese Pflege nicht erwerbsmäßig ausführen, sind Sie eine sogenannte Pflegeperson im Sinne der Pflegeversicherung. Die Zeiten, die Sie für die ehrenamtliche Pflege von mehreren Pflegebedürftigen aufwenden, werden dabei zusammengerechnet, wenn ansonsten der Mindestumfang von 14 Stunden Pflegetätigkeit pro Woche nicht erreicht wird. </p>\n\n<p>Sind Sie neben der Pflege nicht mehr als 30 Stunden in der Woche erwerbstätig, zahlt die Pflegeversicherung für Sie Beiträge zur Rentenversicherung, falls Sie nicht bereits eine Vollrente wegen Alters beziehen. Die Höhe der Rentenversicherungsbeiträge richtet sich dabei nach dem Schweregrad der Pflegebedürftigkeit und dem Umfang Ihrer Pflegetätigkeit. </p>","created":"2014-05-21 12:00:15","modified":"2014-06-01 14:55:53"}},"25":{"HelpArticle":{"id":"25","help_topic_id":"9","name":"Verrichtungen erfassen","content":"<h1>Verrichtungen erfassen</h1>\n\n<p>Unter dem Begriff &#8220;Verrichtungen&#8221; sind alle pflegerischen Handlungen zusammengefasst, die Sie als Laienpflegekraft in der Unterstützung Ihres pflegebedürftigen Angehörigen in der Häuslichkeit vornehmen. Davon ausgenommen sind Tätigkeiten der sog. Behandlungspflege (Tätigkeiten medizinischen Hintergrunds wie Medikamente verabreichen, Spritzen und Infusionen geben etc.).</p>\n\n<p>Die einzelnen Verrichtungen, die für Ihren pflegenden Angehörigen durchgeführt werden können, erreichen Sie über den Startbildschirm unter &#8220;Erfassen&#8221;.<br />\n<img alt=\"Erfassen von Verrichtungen\" src=\"img/Icon_Erfassen.png\" title=\"Erfassen von Verrichtungen\" /></p>\n\n<p>Hier sind die 4 Hauptkatgeorien in jeweils einfarbigen Würfeln voneinander unterschieden:</p>\n\n<ul>\n\t<li>Ernährung</li>\n\t<li>Körperpflege</li>\n\t<li>Mobilität</li>\n</ul>\n\n<p>Dies diesen Kategorien zugeordneten Verrichtungen werden zur Einschätzung einer möglichen Pflegestufe bei der Auswertung aufsummiert zur Gesamtkategorie &#8220;Grundpflege&#8221;.</p>\n\n<p>Weiterhin gibt es die Hauptkategorie:<br />\n<ul>\n\t<li>Hauswirtschaft (= hauswirtschaftliche Versorgung)</li><br />\n</ul></p>\n\n<p>Diese wird in der Auswertung zur Pflegestufe der Summe &#8220;Grundpflege&#8221; gegenübergestellt und mit einberechnet.</p>\n\n<p>Per Klick auf die jeweilige Hauptkategorie gelangt man zu den jeweiligen Unterkategorien und von dort zu den einzelnen Verrichtungen. </p>\n\n<blockquote>\n\t<p>Versuchen Sie zur Beantragung einer Pflegestufe Ihres Angehörigen für mindestens sieben Tage alle pflegerischen Verrichtungen, die Sie tagtäglich vornehmen, auf die Minute genau mit dem interaktiven Pflegetagebuch zu dokumentieren. Danach können Sie eine provisorische Einschätzung einer möglichen Pflegestufe vornehmen und die Dokumentationsdatei an die Pflegeversicherung Ihres Angehörigen zusammen mit dem Antrag auf Pflegestufe schicken.</p>\n</blockquote>","created":"2014-05-21 12:24:26","modified":"2014-06-16 13:47:58"}},"26":{"HelpArticle":{"id":"26","help_topic_id":"9","name":"Angaben zu Verrichtungen","content":"<h1>Angaben zu den Verrichtungen</h1>\n\n<p>Je einzelner Verrichtung, die gespeichert wird, müssen zwingend weitere Angaben zu derjenigen Verrichtung angelegt werden. </p>\n\n<p>Es ist möglich jede Verrichtung nur mit Verrichtungsname und Startzeit zu speichern und die weiteren Angaben vor der Einschätzung der Pflegestufe und dem Export nachzupflegen. </p>\n\n<p>Die notwendigen Angaben je Verrichtung sind:</p>\n\n<h2>Startzeit</h2>\n\n<p>Die Startzeit enthält das Datum und den Zeitpunkt, an dem die Verrichtung durchgeführt wurde<br />\nDie Startzeit kann per Klick auf das voreingestellte Datum oder den voreingestellten Zeitpunkt verändert werden.</p>\n\n<h2>Dauer</h2>\n\n<p>Die Dauer der Verrichtung kann zweierlei festgelegt werden:</p>\n\n<ul>\n\t<li>Das blaue Icon steht für eine Stoppuhr die bei Start einer Verrichtung gestartet und bei erneutem Klick auf das Symbol gestoppt werden kann. Die gestoppte Zeit wird dann als Dauer der Verrichtung übernommen.<br />\nDie Stoppuhr kann jederzeit per Klick auf den Ausgangspunkt zurückgestellt und ein erneutes Stoppen der Zeit durchgeführt werden.<br />\n<img alt=\"Starten der Stoppuhr\" src=\"img/Icon_Stoppuhr.png\" title=\"Starten der Stoppuhr\" /><br />\n<img alt=\"Laufende Stoppuhr zurückstellen\" src=\"img/Icon_Zurueckstellen.png\" title=\"Laufende Stoppuhr zurückstellen\" /></li>\n</ul>\n\n<ul>\n\t<li>Die Dauer kann ebenso bei Klick auf das Symbol individuell eingestellt werden. Wichtig: Die Dauer wird immer in Minuten: Sekunden angegeben.<br />\n<img alt=\"Dauer bearbeiten\" src=\"img/Icon_Dauer.png\" title=\"Dauer bearbeiten\" /></li>\n</ul>\n\n<ul>\n\t<li>Hilfeform:<br />\nAn dieser Stelle muss ausgewählt werden welche Form der Hilfestellung Sie Ihrem Angehörigen gegeben haben. Dies kann eine der folgenden Hilfeformen sein: Anleitung, Beaufsichtigung, teilweise Übernahme, vollständige Übernahme oder Unterstützung. Weitere Information zu den einzelnen Hilfeformen finden Sie unter &#8220;Hilfeformen&#8221;.</li>\n</ul>\n\n<ul>\n\t<li>Anzahl der beteiligten Helfer:<br />\nHier wählen Sie aus wieviele Laienpfleger_innen bei einer Verrichtung mit/an der pflegebedürftigen Person beteilgt sind. Im Normalfall werden dies 1-2 sein.</li>\n</ul>\n\n<p>Nach Eingabe dieser Angaben je Verrichtung können Sie die Verrichtung speichern per Klick auf den Knopf &#8220;Speichern&#8221;.<br />\n<img alt=\"Speichern\" src=\"img/Icon_Speichern.png\" title=\"Speichern\" /></p>","created":"2014-05-21 12:47:54","modified":"2014-06-16 13:50:09"}},"27":{"HelpArticle":{"id":"27","help_topic_id":"10","name":"Verrichtungen ändern","content":"<h1>Verrichtungen ändern</h1>\n\n<p>Sobald Verrichtungen unter dem Menüpunkt &#8220;Erfassen&#8221; dokumentiert wurden, sind diese im Menüpunkt &#8220;Bearbeiten&#8221; als Liste aller angelegten Verrichtungen nach Tag und Uhrzeit (Zeitraum) und in der jeweiligen Farbe der Hauptkategorie markiert (Ernährung, Mobilität, Körperpflege, Hauswirtschaft) aufgelistet. <br />\n<img alt=\"Bearbeiten von Verrichtungen\" src=\"img/Icon_Bearbeiten.png\" title=\"Bearbeiten von Verrichtungen\" /></p>\n\n<p>Die Verrichtungen werden den folgenden Zeiträumen zugeordnet:<br />\n<ul>\n\t<li>morgens (6-12h)</li>\n\t<li>mittags (12-14h)</li>\n\t<li>nachmittags (14-18h)</li>\n\t<li>abends (18-22h)</li>\n\t<li>nachts (22-6h)</li><br />\n</ul></p>\n\n<p>Folgende Funktionalitäten sind hier verfügbar:</p>\n\n<ul>\n\t<li>per wischen (swipen) über den Bildschirm oder Verwendung der Pfeile in der Menüleiste des smartphones kann die Tagesansicht gewechselt werden</li>\n</ul>\n\n<ul>\n\t<li>per Klick auf die einzelne Verrichtung können an derselbigen Änderungen und Einträge vorgenommen und wiederum gespeichert werden</li>\n</ul>\n\n<ul>\n\t<li>In der Einzelübersicht der jeweiligen Verrichtung wird im Feld &#8220;Dauer&#8221; ein Orientierungswert in Klammern angegeben. Dieser zeigt die vom <span class=\"caps\">MDK</span> vorgegebene Maximaldauer der Verrichtung und ist damit Bemessungsgrundage für eine mögliche Pflegestufe. Sollte Ihr tatsächlich gestoppter oder eingegebener Wert darüberliegen, so wird dies in der persönlichen Begutachtung selbst nochmals besprochen bzw. überprüft werden.</li>\n</ul>\n\n<ul>\n\t<li>per Klick auf &#8220;Eintrag löschen&#8221; können in diesem Menü Verrichtungen gelöscht werden</li>\n</ul>","created":"2014-05-21 14:26:51","modified":"2014-06-16 13:51:12"}},"28":{"HelpArticle":{"id":"28","help_topic_id":"11","name":"Auswertung","content":"<h1>Auswertung </h1>\n\n<p>Im Menü &#8220;Auswerten&#8221; finden sich alle bisher dokumentierten Verrichtungen aufgelistet nach Hauptkategorie (Ernährung, Körperpflege, Mobilität und Hauswirtschaftliche Versorgung) und Unterkategorien farblich entsprechend angestimmt aufgelistet wieder.</p>\n\n<p>Die Verrichtungen werden jeweils mit der Angabe der Dauer der Durchführung aufsummiert über den angegebenen Zeitraum dargestellt.</p>\n\n<p>Folgende Funktionalitäten stehen hier zur Verfügung:<br />\n<ul>\n\t<li>per wischen (swipen) oder Verwendung der Pfeile kann in der Listenansicht vor- oder zurück geblättert werden</li><br />\n</ul></p>\n\n<ul>\n\t<li>per Klick auf den Kalender oder Verwendung der Pfeile für &#8220;vor&#8221; und &#8220;zurück&#8221; kann ein Starttag individuell ausgewählt werden. Hier können auch alle anderen Wochentage als der Montag als Startag gewählt werden. Vom ausgewählten Starttag an werden automatisch 7 Tage in Folge für die Auswertung herangezogen. Daraufhin aktualisiert sich die Verrichtungsliste anhand des neu gewählten Zeitraums.<br />\n<img alt=\"Kalender\" src=\"img/Icon_Kalender.png\" title=\"Kalender\" /><br />\n<img alt=\"Vor- und Zurück-Blättern\" src=\"img/Icon_Pfeile.png\" title=\"Vor- und Zurück-Blättern\" /></li>\n</ul>\n\n<ul>\n\t<li>Einzelverrichtungen können aus dieser Ansicht nicht mehr verändert werden. Dies kann unter &#8220;Bearbeiten&#8221; vorgenommen werden.</li>\n</ul>\n\n<ul>\n\t<li>Falls Sie zu einer oder mehrerer Verrichtungen unvollständige Angaben gemacht haben (z.B. nur die Verrichtungen und die Dauer, jedoch nicht die Hilfeleitung und die Anzahl der beteiligten Helfer), wird Ihnen dies mit einem roten Hinweistext im oberen Bereich der Auswertungsliste angezeigt. Sie können nun im Menü auf &#8220;Bearbeiten&#8221; gehen und dort die Verrichtungen, die mit einem orangenen Ausrufezeichen markiert sind, öffnen, die Details nachtragen und speichern. <br />\n<img alt=\"Daten sind unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind unvollständig\" /></li>\n</ul>\n\n<p>So gelangen Sie zu einer korrekten und vollständigen Dokumentation der pflegerischen Verrichtungen, die eine optimale Voraussetzung für die Einschätzung einer Pflegestufe bietet.</p>","created":"2014-05-21 14:45:10","modified":"2014-06-17 14:34:06"}},"29":{"HelpArticle":{"id":"29","help_topic_id":"12","name":"Export der Auswertungsdatei","content":"<h1>Export der Auswertungsdatei</h1>\n\n<p>Im Menü &#8220;Auswerten&#8221; können Sie per Klick auf &#8220;Export&#8221; die Auswertungsdatei über verschiedene digtale Kanäle, z.B. E-mail (Angebot je nach Typ Ihres smartphones) im pdf-Format versenden.<br />\n<img alt=\"Versenden der Auswertung\" src=\"img/Icon_Export.png\" title=\"Versenden der Auswertung\" /></p>\n\n<p>Sollten Sie bereits eine Pflegestufeneinschätzung per Klick auf &#8220;Einschätzung Pflegestufe&#8221; vorgenommen haben, so kommen Sie per Klick auf den Pfeil &#8220;&gt; Einschätzung Pflegestufe&#8221; zurück in die Liste der Verrichtungen und können von dort den Export vornehmen.<br />\n<img alt=\"Pflegestufe\" src=\"img/Icon_Einschaetzung_Pflegestufe.png\" title=\"Pflegestufe\" /><br />\n<img alt=\"zurückblättern\" src=\"img/Icon_Pfeil_Zurueck.png\" title=\"zurückblättern\" /></p>\n\n<p>Bevor die Exportdatei generiert wird, werden Sie gefragt, ob Sie die Daten aus Ihrem Profil eingeben (Angaben zur pflegebedürftigen Person und zur Pflegetagebuch führenden Person) und somit dem Deckblatt hinzufügen möchten.</p>\n\n<p>Ebenso wird darauf hingewiesen, die Fragen zur Einschätzung der Alltagskompetenz Ihres pflegebedürftigen Angehörigen, zu beantworten. Diese sind die Grundlage für evtl. zusätzliche Betreuungsleistungen, die Ihr Angehöriger aus der Pflegeversicherun erhalten kann.</p>\n\n<h2>Die Exportdatei</h2>\n\n<p>Die Exportdatei beinhaltet die Übersicht der Verrichtungen der einzelnen Tage des Zeitraums, den Sie für die Auswertung ausgewählt haben (immer 7 Tage). Dazu folgt die Auswertung der gesamten Woche mit der Berechnung der benötigten Zeitdauer in den Verrichtungen nach täglichem Druchschnitt und Angabe der Häufigkeit. Diese Angaben werden aufsummiert nach Grundpflege (Ernährung, Körperpflege und Mobilität) und Hauswirtschaftlicher Versorgung. </p>\n\n<p>Sollten Sie sich für die Pflege Ihres Profils bzw. dafür entscheiden haben, persönliche Daten dem Deckblatt hinzufügen zu wollen, so sind diese auf der ersten Seite der Datei zu finden.</p>\n\n<h2>Angaben zur Alltagskompetenz</h2>\n\n<p>Weiterhin wird nach der Übersicht der Verrichtungen nach Tagen und der Wochenübersicht der Fragebogen der Fragen zur Einschätzung der Alltagskompetenz angehängt und Ihre jeweiligen Antworten dort eingetragen. Hier finden Sie im Anschluss einen Orientierungssatz zur Einschätzung ob für Ihren Angehörigen keine, eine erheblich eingeschränkte oder eine in erhöhten Maße eingeschränkte Alltagskompetenz vorzuliegen scheint.</p>\n\n<p>Diese Exportdatei entspricht den Daten des Pflegetagebuchs, die für den Medizinischen Dienst der Krankenkassen notwendig sind um zusammen mit dem Antrag auf Pflegestufe und der persönlichen Begutachtung über eine Pflegestufe Ihres Angehörigen zu entscheiden.</p>","created":"2014-05-21 15:06:30","modified":"2014-06-17 13:13:22"}},"30":{"HelpArticle":{"id":"30","help_topic_id":"2","name":"Einstellungen im Infomenü","content":"<h1>Die Einstellungen im Infomenü</h1>\n\n<p>Unter dem Punkt &#8220;Info&#8221; können persönliche Angaben als auch Einstellungen des Nutzerkontos vorgenommen werden. Außerdem kann von hier aus die Hilfe genutzt werden und es sind Informationen über die App erhältlich.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /></p>","created":"2014-06-01 16:33:50","modified":"2014-06-16 14:58:02"}},"31":{"HelpArticle":{"id":"31","help_topic_id":"2","name":"Profil","content":"<h1>Profil</h1>\n\n<p>Im Infomenü werden sowohl persönliche Angben als auch die Angaben zur eingeschränkten Alltagskompetenz verwaltet.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /></p>\n\n<p>Unter &#8220;Profil&#8221; werden persönliche Daten zur pflegebedürftigen Person und zur Tagebuch führenden Person verwaltet. Diese Angaben werden entweder bei Registrierung in der App bereits erfragt und eingegeben oder aber spätestens bevor eine Datei mit Verrichtungen exportiert wird. Die persönlichen Angaben sowie die Angaben zur eingeschränkten Alltagskompetenz sind Voraussetzung für die Beantragung einer Pflegestufe und müssen daher zur Zuordnung der Antrags auf Pflegestufe angegeben werden.<br />\n<img alt=\"Persönliche Angaben und Einstellungen\" src=\"img/Icon_Profil.png\" title=\"Persönliche Angaben und Einstellungen\" /></p>","created":"2014-06-01 16:38:57","modified":"2014-06-16 15:05:34"}},"34":{"HelpArticle":{"id":"34","help_topic_id":"2","name":"Nutzerkonto","content":"<h1>Nutzerkonto</h1>\n\n<p>Im Infomenü ist die Verwaltung des Nutzerkontos zu finden. Hier ist ales erstes die E-mail-Adresse, mit der Sie sich registriert haben, platziert. Darunter befinden sich Nutzer &#8211; und Sicherheitseinstellungen.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /></p>\n\n<h2>Nutzerwechsel</h2>\n\n<p>Über den Knopf &#8220;Abmelden&#8221; können Sie den derzeitigen Nutzer der App abmelden und einen neuen Nutzer anmelden oder registrieren. Sie gelangen dazu auf die Login- bzw. Registrierungsseite der App.<br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></p>\n\n<p>Über den Knopf &#8220;Passwort ändern&#8221; können Sie das für den derzeitigen Nutzer verwendete Passwort ändern und erneut abspeichern. <br />\n<img alt=\"Passwort ändern\" src=\"img/Icon_Passwort_aendern.png\" title=\"Passwort ändern\" /></p>\n\n<p>Über den Knopf &#8220;Konto löschen&#8221; können Sie Ihr Nutzerkonto für die App komplett löschen. Bevor dies geschieht werden Sie erneut gefragt ob Sie Ihr Konto wirklich löschen wollen. Wenn Sie dies möchten, können Sie &#8220;Ja&#8221; klicken und müssen sich damit bei erneuter Nutzung der App neu registrieren. Wenn Sie &#8220;nein&#8221; klicken, kehren Sie in der Ansicht zurück auf Ihr Nutzerkonto.<br />\n<img alt=\"Benutzerkonto löschen\" src=\"img/Icon_Konto_loeschen.png\" title=\"Benutzerkonto löschen\" /></p>","created":"2014-06-01 16:59:21","modified":"2014-06-16 15:01:50"}},"35":{"HelpArticle":{"id":"35","help_topic_id":"2","name":"Hilfe","content":"<h1>Hilfe</h1>\n\n<p>Über die &#8220;Hilfe&#8221; im Infomenü stehen Ihnen Artikel zur Nutzung und Einstellungen der App als auch zu Informationen zum Pflegetagebuch, der Beantragung einer Pflegestufe etc. zur Verfügung.</p>\n\n<p>Einzelne Hilfeartikel sind ebenso von den jeweiligen Verrichtungen in den Menüs &#8220;Erfassen&#8221; und &#8220;Bearbeiten&#8221; bei Ihrer Dokumentation zugänglich.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Hilfe\" src=\"img/Icon_Hilfe.png\" title=\"Hilfe\" /></p>","created":"2014-06-01 17:02:55","modified":"2014-06-16 15:03:37"}},"36":{"HelpArticle":{"id":"36","help_topic_id":"2","name":"Über diese App","content":"<h1>Über diese App</h1>\n\n<p>Im Infomenü im Punkt &#8220;Über diese App&#8221; sind Informationen zur App interaktives Pflegetagebuch zu finden. Hier ist einerseits die enstsprechende Versionsnummer der App, die auf Ihrem Smartphone installiert ist, aufgezeigt. Andererseits finden Sie Informationen zu der Institution, die die Entwicklung dieser App beauftragt hat und zu derjenigen, die sie entwickelt hat und eine E-mail-Adresse, an die Sie sich bei Problemen zur App wenden können.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Informationen über diese App\" src=\"img/Icon_Ueber_diese_App.png\" title=\"Informationen über diese App\" /></p>","created":"2014-06-01 17:06:49","modified":"2014-08-27 08:42:07"}},"37":{"HelpArticle":{"id":"37","help_topic_id":"10","name":"weitere Angaben einpflegen","content":"<h1>weitere Angaben einpflegen</h1>\n\n<p>Alle bereits dokumentierten Verrichtungen werden in der Listenansicht &#8220;Bearbeiten&#8221; in den verschiedenen Zeitintervallen, in denen Sie vorgenommen wurden, angezeigt. Die Zeit, mit der eine Verrichtung dokumentiert wurde, ist mit der Farbe der Hauptkategorie markiert (Ernährung, Körperpflege, Mobilität oder Hauswirtschaft).<br />\n<img alt=\"Bearbeiten von Verrichtungen\" src=\"img/Icon_Bearbeiten.png\" title=\"Bearbeiten von Verrichtungen\" /></p>\n\n<p>Zu den einzelnen Verrichtungen können Sie folgende Symbole erkennen:<br />\nDas orange Ausrufezeichen zeigt an, dass die Angaben zu der Verrichtung noch unvollständig sind. Indem Sie auf die jeweilige Verrichtung klicken kommen Sie zu den einzelnen Angaben und können diejenigen, die fehlen oder falsch sind, angeben und speichern.<br />\n<img alt=\"Daten sind unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind unvollständig\" /></p>\n\n<blockquote>\n\t<p>Um eine korrekte Einschätzung einer möglichen Pflegestufe vornehmen zu können sind je Verrichtung alle Angaben zu Startzeit, Dauer, Hilfeform und Anzahl beteiligter Helfer zu machen!</p>\n\n\t<p>Der grüne Haken zeigt an, dass alle erforderlichen Angaben zu einer Verrichtung dokumentiert worden sind. Sollten Sie dennoch Änderungen vornehmen wollen, so können Sie einfach über Klick auf die jeweilige Verrichtung in die Details gelangen.<br />\n<img alt=\"Daten sind vollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind vollständig\" /></p>\n\n\t<p>Der blaue Pfeil nach oben zeigt an, dass Sie den Orientierungswert des Zeitraums für die Verrichtung, der vom <span class=\"caps\">MDK</span> vorgegeben ist, überschritten haben. Überprüfen Sie die Dauer, indem Sie per Klick in die Details der Verrichtung gelangen. Sollten Sie bei der von Ihnen angegeben Dauer bleiben, so wird diese dokumentierte Dauer in die Auswertung übernommen.<br />\n<img alt=\"Dauer liegt über Orientierungswert\" src=\"img/Icon_Dauer_lang.png\" title=\"Dauer liegt über Orientierungswert\" /></p>\n\n\t<p>Der blaue Pfeil nach unten zeigt an, dass Sie den Orientierungswert des Zeitraums für die Verrichtung, der vom <span class=\"caps\">MDK</span> vorgegeben ist, unterschritten haben. Überprüfen Sie die Dauer indem Sie per Klick in die Details der Verrichtung gelangen. Sollten Sie bei der von Ihnen angegeben Dauer bleiben, so wird diese dokumentierte Dauer in die Auswertung übernommen.<br />\n<img alt=\"Dauer liegt unter Orientierungswert\" src=\"img/Icon_Dauer_kurz.png\" title=\"Dauer liegt unter Orientierungswert\" /></p>\n\n\t<p>Der blaue Pfeil nach rechts zeigt an, dass Sie sich mit der Zeitdauer der Verrichtung innerhalb des Orientierungswertes, der vom <span class=\"caps\">MDK</span> vorgegeben ist, befinden. <br />\n<img alt=\"Dauer liegt im Orientierungswert\" src=\"img/Icon_Dauer_ok.png\" title=\"Dauer liegt im Orientierungswert\" /></p>\n</blockquote>","created":"2014-06-03 12:44:04","modified":"2014-06-16 13:55:46"}},"39":{"HelpArticle":{"id":"39","help_topic_id":"7","name":"Eingeschränkte Alltagskompetenz","content":"<h1>Eingeschränkte Alltagskompetenz </h1>\n\n\n<p>Mit dem 1. Pflegeverstärkungsgesetz (Januar 2015) besteht für alle Pflegebedürftigen die Möglichkeit, zusätzliche Betreuungs- und Entlastungsleistungen in Anspruch zu nehmen. Wird eine eingeschränkte Alltagskompetenz festgestellt, können Leistungen in Höhe von 104 bis 208 Euro im Monat in Anspruch genommen werden. </p>\n\n<p>Die Gutachter beurteilen anhand von 13 festgelegten Kriterien die Schwere der &#8220;Einschränkungen der Alltagskompetenz&#8221;. Werden bei der Begutachtung wenigstens zwei dieser Kriterien erfüllt, davon eines aus einem eingegrenzten Kriterienkatalog, besteht ein Anspruch auf Leistungen der Pflegeversicherung, selbst dann, wenn keine Pflegestufe vorliegt (Pflegestufe 0). </p>\n\n<p>Die Kriterien sind: </p>\n\n<h2>Orientierung</h2>\n\n<p>Orientierung beschreibt das Bescheid wissen über Ort, Zeit, Situation und Person. </p>\n\n<h2>Örtliche Orientierung </h2>\n\n<p>Örtliche Orientierung beinhaltet die Fähigkeit seinen Aufenthaltsort zu kennen und sich im eigenen Bewegungsradius zurecht zu finden. z.B. der Ortsname kann nur mit Mühe genannt werden kann oder die Orientierung in der Wohnung gelingt nicht mehr. </p>\n\n<h2>Zeitliche Orientierung </h2>\n\n<p>Zeitliche Orientierung beinhaltet die Fähigkeit, Tag und Uhrzeit zu kennen und entsprechend den Tagesablauf strukturieren zu können. </p>\n\n<h2>Situative Orientierung </h2>\n\n<p>Situative Orientierung beinhaltet das Verständnis für die derzeitige Lebenslage und die Hintergründe, die zur derzeitigen Situation geführt haben. </p>\n\n<h2>Personelle Orientierung </h2>\n\n<p>Personelle Orientierung beinhaltet das Wissen über die aktuelle persönliche als auch lebensgeschichtliche Situation und die individuelle Beziehung zu den Kontaktpersonen. z.B. ist eine Angabe des eigenen Namens, Geburtstags und Alter nicht möglich. </p>\n\n<h2>Antrieb/Beschäftigung </h2>\n\n<p>Die geistige Fähigkeit, geprägt durch Erlebnisse und Gewohnheiten, seine Zeit sinnvoll einzuteilen, sich entsprechend zu beschäftigen und seine Aktivitäten von sich aus aufzunehmen und an seine körperlichen Fähigkeiten anzupassen. </p>\n\n<h2>Stimmung </h2>\n\n<p>Die Stimmung drückt das Empfinden und die Steuerung von Emotionen wie z. B. Freude, Trauer, Hass aus. </p>\n\n<h2>Gedächtnis </h2>\n\n<p>Die Fähigkeit, Erlebtes und Erlerntes behalten und wiedergeben zu können. Im Langzeitgedächtnis sind z.B. biografische Angaben gespeichert. Das Kurzzeitgedächtnis umfasst die Merkfähigkeit, d. h. die Speicherung neu gelernter Inhalte für einige Minuten. </p>\n\n<h2>Tag-/Nachtrhythmus</h2>\n\n<p>Hierzu gehört die Fähigkeit, einen regelmäßigen und altersentsprechenden Rhythmus sowie die Art und Weise von Wachen, Ruhen und Schlafen zu gestalten und aufrecht zu erhalten, wie z. B. der Umgang mit Schlafstörungen, auch nach nächtlichen Unterbrechungen durch Wasserlassen oder das Einplanen notwendiger Ruhepausen tagsüber. </p>\n\n<h2>Wahrnehmung und Denken </h2>\n\n<p>Hierzu gehört die Fähigkeit, Informationen aus der Umgebung aufnehmen und einordnen zu können, logische Folgerungen zu schließen und begründete Entscheidungen treffen zu können. Dabei spielt das Erkennen von Gefahren und das Einschätzen von Risiken eine wesentliche Rolle. Formale Denkstörungen zeigen sich meistens in der Sprache. Es handelt sich dabei um Veränderungen in der Geschwindigkeit, Kohärenz und Stringenz des Gedankenablaufes. </p>\n\n<h2>Kommunikation und Sprache</h2>\n\n<p>Hierzu gehört die geistige Fähigkeit zum sinnhaften, interpersonellen Austausch unter Berücksichtigung kultureller Gegebenheiten. Wesentlich sind das Verstehen der Bezugsperson (hören, sehen, lesen) und Wünsche und Gedanken äußern zu können (Sprache, Schrift, Gestik, Mimik und Ausdruck von Gefühlen). </p>\n\n<h2>Situatives Anpassen </h2>\n\n<p>Dies beinhaltet die Fähigkeit, sich auf wechselnde Anforderungen/Situationen einzustellen, wie z. B. Besuch/Alleinsein/Wechsel der Bezugsperson, Änderung des üblichen Tagesablaufes, sich in gegebenen Situationen adäquat verhalten zu können, wie z. B. die Fähigkeit, Wünsche zu äußern, bei Gefahr Hilfe einzuholen, aber auch Ablehnungen deutlich zu machen. </p>\n\n<h2>Soziale Bereiche des Lebens wahrnehmen </h2>\n\n<p>Hierzu gehört die Fähigkeit, selbstständig soziale Kontakte aufnehmen und aufrecht erhalten zu können und sein Leben verantwortlich innerhalb des gesellschaftlichen Beziehungsgeflechtes zu gestalten. Das bedeutet u. a., Kontakte zu Familie, Nachbarn und Freunden pflegen zu können oder die Geschäftsfähigkeit bezüglich finanzieller und behördlicher Angelegenheiten zu erhalten.</p>","created":"2014-06-12 19:54:25","modified":"2014-12-30 10:32:58"}},"40":{"HelpArticle":{"id":"40","help_topic_id":"7","name":"Angaben zur eingeschränkten Alltagskompetenz","content":"<h1>Angaben zur eingeschränkten Alltagskompetenz </h1>\n\n<p>Diese Angaben werden zur Einschätzung des Betreuungsaufwands der zu pflegenden Person benötigt und können zur Leistungen der Pflegeversicherung von 104 oder 208 Euro im Monat je nach Einschränkung der Alltagskompetenz führen. Aus diesem Grund werden Ihre Angaben dazu in die Exportdatei zusammen mit den pflegerischen Verrichtungen aufgenommen. </p>\n\n<p>Die Angaben zur Alltagskompetenz werden anhand von 13 Fragen an zwei Punkten innerhalb der App erfragt. Bereits nach Registrierung der App gibt es einen Hinweis, der Ihnen anbietet, die Angaben direkt zu machen. Wenn Sie an dieser Stelle ablehnen, werden Sie nochmals vor dem Start eines Exports der Auswertungsdatei Ihrer dokumentierten Verrichtungen darauf hingewiesen.</p>\n\n<p>Weiterhin können Sie die Angaben zur Alltagskompetenz wann immer Sie wollen im Profil selbst eingeben und speichern. <br />\n<img alt=\"Profil\" src=\"img/Icon_Profil.png\" title=\"Profil\" /> <br />\n<img alt=\"Eingeschränkte Alltagskompetenz\" src=\"img/Icon_Eingalltagskomp.png\" title=\"Eingeschränkte Alltagskompetenz\" /> </p>\n\n<p>Eine Einschätzung des tatsächlichen Betreuungsaufwandes können Sie der Exportdatei entnehmen.</p>","created":"2014-06-12 20:29:23","modified":"2014-12-30 10:09:42"}},"41":{"HelpArticle":{"id":"41","help_topic_id":"11","name":"Pflegestufe einschätzen","content":"<h1>Pflegestufe einschätzen</h1>\n\n<p>Zur Einschätzung der Pflegestufe klicken Sie in der Ansicht &#8220;Auswerten&#8221; auf den Knopf &#8220;Einschätzung Pflegestufe&#8221;.<br />\n<img alt=\"Enschätzung\" src=\"img/Icon_Einschaetzung_Pflegestufe.png\" title=\"Enschätzung\" /></p>\n\n<p>Daraufhin sehen Sie einen Text, der Ihnen mitteilt welche Pflegestufe Ihr zu pflegender Angehöriger laut den Angaben im interaktiven Pflegetagebuch nach zugeordnet werden kann. Hier gibt es folgenden Möglichkeiten der Zuordnung:</p>\n\n<ul>\n\t<li>keine Pflegestufe</li>\n\t<li>Pflegestufe 1</li>\n\t<li>Pflegestufe 2</li>\n\t<li>Pflegestufe 3</li>\n</ul>\n\n<p>Unter dem Text finden Sie eine Übersicht der erfüllten bzw. nicht erfüllten Vorgaben zur Erreichung jeweiligen Pflegestufe. Dabei sind die aufgrund Ihrer Dokumentation erreichten Vorgaben als &#8220;erfüllt&#8221; mit grüner Farbe hinerlegt; die nicht erreichten Vorgaben werden mit orangener Farbe als &#8220;nicht erfüllt&#8221; markiert. So können Sie einen Überblick gewinnen, wo Ihr zu pflegender Angehöriger in der Einschätzung einer Pflegestufe zu finden ist.</p>\n\n<p>Folgende weitere Funktionen stehen Ihnen hier zur Verfügung:</p>\n\n<ul>\n\t<li>wischen (swipen) mit dem Finger über den Bildschirm nach rechts oder links zur nächst niedrigeren bzw. höheren Pflegestufe. Hiermit können Sie überblicken welche Vorgaben zu einer höheren Pflegestufe zu erfüllen wären.</li>\n</ul>","created":"2014-06-12 20:57:05","modified":"2014-06-17 13:11:46"}},"42":{"HelpArticle":{"id":"42","help_topic_id":"14","name":"Anlegen eines Nutzers","content":"<h1>Anlegen eines Nutzers</h1>\n\n<ol>\n\t<li>Wenn Sie die App öffnen können Sie dort direkt einen neuen Nutzer registrieren, indem Sie auf den Knopf &#8220;Registrieren&#8221; klicken und dann einen neuen Nutzer mit Email-Adresse und Passwort anlegen.<br />\n<img alt=\"Nutzer registrieren\" src=\"img/Icon_Registrieren.png\" title=\"Nutzer registrieren\" /></li>\n</ol>\n\n<ol>\n\t<li>Weiterhin können Sie im Infomenü in der Verwaltung unter &#8220;Nutzerkonto&#8221; den derzeitigen Nutzer abmelden, indem Sie auf &#8220;Abmelden&#8221; klicken. Von dort aus gelangen Sie direkt zur Login (Registrierungs) Seite und können dort einen neuen Nutzer anlegen.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></li>\n</ol>","created":"2014-06-12 21:20:42","modified":"2014-06-16 15:09:16"}},"44":{"HelpArticle":{"id":"44","help_topic_id":"14","name":"Nutzerwechsel","content":"<h1>Nutzerwechsel</h1>\n\n<p>Im Infomenü unter &#8220;Nutzerkonto&#8221; können Sie per Klick auf &#8220;Abmelden&#8221; den Nutzer wechseln. Sie gelangen von hier zur Login (Registrierungs) Seite und können sich dort per Email-Adresse und Passwort einen anderen Nutzers anmelden oder einen neuen Nutzer registrieren.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></p>","created":"2014-06-12 21:27:08","modified":"2014-06-16 15:11:12"}},"45":{"HelpArticle":{"id":"45","help_topic_id":"14","name":"Passwort ändern","content":"<h1>Passwort ändern</h1>\n\n<p>Im Infomenü in der Ansicht &#8220;Profil&#8221; können Sie per Klick auf &#8220;Passwort ändern&#8221; das bisherige Passwort in ein anderen verändern und speichern.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Profil\" src=\"img/Icon_Profil.png\" title=\"Profil\" /><br />\n<img alt=\"Passwort ändern\" src=\"img/Icon_Passwort_aendern.png\" title=\"Passwort ändern\" /></p>","created":"2014-06-12 21:29:23","modified":"2014-06-16 15:12:40"}},"46":{"HelpArticle":{"id":"46","help_topic_id":"14","name":"Konto löschen","content":"<h1>Konto löschen</h1>\n\n<p>Im Infomenü in der Ansicht &#8220;Nutzerkonto&#8221; können Sie per Klick auf &#8220;Konto löschen&#8221; können Sie Ihr Nutzerkonto für die App interaktives Pflegetagebuch löschen. Wenn Sie hier auf &#8220;Ja&#8221; klicken erscheint die Frage: Wollen Sie wirklich Ihre Daten löschen? &#8211; Sie können den Löschvorgang hier abbrechen oder weiterführen. Wenn Sie &#8220;Ja&#8221; klicken, so werden Ihre Email.Adresse und das Passwort gelöscht und Sie müssen sich erneut mit einer Emai-Adresse und Passwort auf der Login (Registrierungs) Seite registrieren.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzerkonto löschen\" src=\"img/Icon_Konto_loeschen.png\" title=\"Nutzerkonto löschen\" /></p>","created":"2014-06-12 21:32:42","modified":"2014-06-16 15:14:20"}}},"_metadata":{"descriptor":"Pflegetagebuch App API","api_version":"1","request_id":"dataGetHelpArticlesList","status":"OK"}};
  }
  
  if (localStorage.getItem('helpFull')){
	  var helpDummy = JSON.parse(localStorage.getItem('helpFull'));  
  } else {
	  var helpDummy = {"helpChapters":[{"HelpChapter":{"id":"1","name":"Erfassen des Hilfebedarfs","created":"2014-05-08 14:09:16","modified":"2014-06-16 20:42:04"},"HelpTopic":[{"id":"1","help_chapter_id":"1","name":"Die pflegerischen Verrichtungen","created":"2014-05-08 14:10:13","modified":"2014-05-21 12:24:45","HelpChapter":{"id":"1","name":"Erfassen des Hilfebedarfs","created":"2014-05-08 14:09:16","modified":"2014-06-16 20:42:04"},"HelpArticle":[{"id":"6","help_topic_id":"1","name":"Grundpflege","content":"<h1>Die Grundpflege</h1>\n\n<p>Zur sogenannten Grundpflege gehören Verrichtungen, die den folgenden Kategorien angehören:</p>\n\n<ul>\n\t<li>Körperpflege: Waschen, Duschen, Baden, Zahnpflege, Kämmen, Rasieren, Darm- und Blasenentleerung</li>\n</ul>\n\n<ul>\n\t<li>Ernährung: mundgerechte Zubereitung der Nahrung und Hilfestellungen beim Essen und Trinken (<span class=\"caps\">NICHT</span> das Kochen)</li>\n</ul>\n\n<ul>\n\t<li>Mobilität: An- und Auskleiden, Aufstehen und Zu-Bett-gehen, Gehen, Stehen, Treppensteigen, das Verlassen und Wiederaufsuchen der Wohnung</li>\n</ul>","created":"2014-05-20 18:20:45","modified":"2015-01-30 11:28:37"},{"id":"14","help_topic_id":"1","name":"Körperpflege","content":"<h1>Körperpflege</h1>\n\n<p>Die Rubrik &#8220;Körperpflege&#8221; gehört zu der Hauptkategorie &#8220;Grundpflege&#8221; (gemeinsam mit Ernährung und Mobilität). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>Waschen, Duschen, Baden</h2>\n\n<p>Hierunter fällt das Waschen des Körpers sowie der Haare, entweder unter der Dusche, in der Badewanne, am Waschbecken oder auch im Bett. Zum Waschvorgang gehören die erforderlichen Vorbereitungen (z. B. das Zurechtlegen der erforderlichen Utensilien wie Seife/Handtuch, das Einlassen des Badewassers sowie das Bedienen der Armaturen), der Waschvorgang selbst sowie das Abtrocknen und Eincremen des Körpers und auch die Haartrocknung.</p>\n\n<h2>Mund-/Zahnpflege</h2>\n\n<p>Zur Zahnpflege zählen die Vorbereitung (z. B. das Öffnen und Schließen der Zahnpastatube einschließlich der Dosierung der Zahnpasta und das Füllen des Wasserglases), der Putzvorgang einschließlich der Mundpflege sowie die Reinigung von Zahnersatz.</p>\n\n<h2>Kämmen</h2>\n\n<p>Dies umfasst das Kämmen und Bürsten der Haare entsprechend der individuellen Frisur. Das Legen von Frisuren (z. B. Dauerwelle) oder das Haareschneiden können nicht berücksichtigt werden. Trägt der Pflegebedürftige ein Toupet oder eine Perücke, so gehört zum Hilfebedarf das Kämmen und Aufsetzen des Haarteils.</p>\n\n<h2>Rasieren</h2>\n\n<p>Rasieren beinhaltet wahlweise die Trocken oder Nassrasur einschließlich der notwendigen Hautpflege. Bei Frauen wird hier die Gesichtspflege – mit Ausnahme des Schminkens – berücksichtigt.</p>\n\n<h2>Blasen-/Darmentleerung</h2>\n\n<p>Hierzu gehören die Kontrolle des Harn- und Stuhlganges, die Reinigung und Versorgung von künstlich geschaffenen Ausgängen sowie die notwendigen Handgriffe bei dem jeweiligen Hygienevorgang, das Richten der Kleidung vor und nach dem Gang zur Toilette, die Intimhygiene wie das Säubern nach dem Wasserlassen und dem Stuhlgang sowie das Entleeren und Säubern eines Toilettenstuhls bzw. eines Stechbeckens. Ebenso zählen das Anlegen bzw. Wechseln von Windeln dazu.</p>","created":"2014-05-21 10:52:06","modified":"2014-06-15 20:11:08"},{"id":"15","help_topic_id":"1","name":"Ernährung","content":"<h1>Ernährung</h1>\n\n<p>Die Rubrik &#8220;Ernährung&#8221; gehört zu der Hauptkategorie &#8220;Grundpflege&#8221; (gemeinsam mit Körperpflege und Mobilität). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>Mundgerechte Zubereitung</h2>\n\n<p>Hierzu zählen die Tätigkeiten, die zur unmittelbaren Vorbereitung dienen, wie die portionsgerechte Vorgabe, das Zerkleinern der zubereiteten Nahrungsmittel, z. B. das mundgerechte Zubereiten bereits belegter Brote, ebenso die notwendige Kontrolle der richtigen Essenstemperatur. Hierzu zählen nicht das Kochen oder das Eindecken des Tisches. Die Zubereitung von Diäten fällt unter die Pflegeleistung „Kochen“.</p>\n\n<h2>Nahrungsaufnahme</h2>\n\n<p>Hierunter fallen die Nahrungsaufnahme in jeder Form (fest, flüssig) sowie eine ggf. erforderliche Sondenernährung und die Verwendung bzw. der Umgang mit dem Essbesteck oder anderen geeigneten Geräten, um die Nahrung zum Mund zu führen, zu kauen und zu schlucken.</p>","created":"2014-05-21 11:00:15","modified":"2014-06-15 20:12:04"},{"id":"16","help_topic_id":"1","name":"Mobilität","content":"<h1>Mobilität</h1>\n\n<p>Die Rubrik &#8220;Mobilität&#8221; gehört zu der Hauptkategorie &#8220;Grundplege&#8221; (gemeinsam mit Ernährung und Körperpflege). Ihr zugehörige Verrichtungen sind:</p>\n\n<h2>An-/Auskleiden</h2>\n\n<p>Das An- und Auskleiden beinhaltet neben notwendigen Handgriffen (z. B. das Öffnen und Schließen von Verschlüssen, das Auf-und Zuknöpfen sowie das An- und Ausziehen von Kleidungsstücken/Schuhen) die Auswahl der Kleidungsstücke entsprechend Jahreszeit und Witterung, die Entnahme der Kleidung aus ihrem normalen Aufbewahrungsort (z. B. Kommode oder Schrank) sowie die Überprüfung der Kleidung. Hierunter fällt auch das Anlegen von Prothesen oder Hilfsmitteln.</p>\n\n<h2>Aufstehen/zu Bett gehen</h2>\n\n<p>Das selbständige Aufstehen und Zu-Bett-Gehen umfasst die eigenständige Entscheidung, zeitgerecht das Bett aufzusuchen bzw. zu verlassen. Hierunter fällt auch das Umlagern von bettlägerigen Pflegebedürftigen. Fällt das Umlagern in Verbindung mit anderen Verrichtungen an, so erfolgt die Zuordnung bei der jeweiligen Verrichtung.</p>\n\n<h2>Gehen/Stehen/Transfer/Treppensteigen</h2>\n\n<p>Das Gehen, Stehen und Treppensteigen ist nur dann maßgebend, wenn es im Zusammenhang mit den genannten Verrichtungen der Körperpflege und der Ernährung erforderlich wird. Unter Gehen ist hier das Bewegen innerhalb der Wohnung (z. B. zum Waschen/Duschen/Baden oder zur Toilettennutzung) zu verstehen. Bei Rollstuhlfahrern fällt hierunter der Hilfebedarf, der durch die Benutzung eines Rollstuhls erforderlich wird. Zum Stehen gehört nicht nur, diese Körperhaltung zu erreichen (Aufstehen), sondern diese auch über einen längeren Zeitraum zu bewahren. Das Treppensteigen beinhaltet das notwendige Überwinden von Stufen innerhalb der Wohnung. Das Gehen und Treppensteigen im Zusammenhang mit der hauswirtschaftlichen Versorgung zählt zum Hilfebedarf im Bereich Hauswirtschaft.</p>\n\n<h2>Umlagern</h2>\n\n<p>Hierunter sind alle Positionswechsel im Bett/Stuhl etc. zu verstehen, die die pflegebedürftige Person nicht allein vornehmen kann, sondern die über eine Hilfeform durch Angehörige etc. unterstützt werden müssen. Positionswechsel sind ebenso aufgrund von Prophylaxen zu Druckgeschwüren oder Gelenkversteifungen, Unterstützung der Atmung etc. regelmäßig vorzunehmen.</p>\n\n<h2>Verlassen/Wiederaufsuchen der Wohnung</h2>\n\n<p>Das Verlassen und Wiederaufsuchen der Wohnung ist maßgebend, wenn es im<br />\nZusammenhang mit Verrichtungen erforderlich wird, die für die Aufrechterhaltung der Lebensführung zu Hause unumgänglich sind und das persönliche Erscheinen des Pflegebedürftigen notwendig machen. Hierzu zählt das Aufsuchen von Ärzten, Apotheken und Behörden sowie die Inanspruchnahme ärztlich veranlasster Therapien, wenn diese mindestens einmal pro Woche anfallen.<br />\nNeben den Fahrzeiten werden die zwangsläufig anfallenden Wartezeiten der Pflegeperson angerechnet, wenn sie dadurch zeitlich und örtlich gebunden ist. Das Verlassen/Wiederaufsuchen der Wohnung im Zusammenhang mit Freizeitaktivitäten (z. B. Spaziergänge, Besuche von kulturellen Veranstaltungen) sowie das Aufsuchen von Kindergärten, Schulen, Arbeitsplätzen oder Werkstätten für behinderte Menschen bleiben unberücksichtigt.</p>","created":"2014-05-21 11:19:23","modified":"2014-06-15 20:12:41"},{"id":"17","help_topic_id":"1","name":"hauswirtschaftliche Versorgung","content":"<h1>Die hauswirtschaftliche Versorgung</h1>\n\n<p>Verrichtungen der hauswirtschaftlichen Versorgung finden nur insoweit Berücksichtigung in der Berechnung einer Pflegesufe, als sie sich auf die Versorgung des Pflegebedürftigen selbst beziehen. Die Versorgung möglicher weiterer Familienangehöriger bleibt unberücksichtigt.</p>\n\n<p>Hauswirtschaftliche Verrichtungen sind:</p>\n\n<h2>Einkaufen</h2>\n\n<p>Das Einkaufen beinhaltet das Planen und sich informieren über die zu beschaffenden Lebens-, Reinigungs- und Körperpflegemitteln, den Überblick darüber, welche Lebensmittel wo eingekauft werden müssen unter Berücksichtigung der Jahreszeit und der benötigten Menge, preisbewusstes, kostengünstiges Wirtschaften und die Kenntnis der Genieß- und Haltbarkeit von Lebensmitteln sowie ihrer richtigen Lagerung.</p>\n\n<h2>Kochen</h2>\n\n<p>Zum Kochen gehören das Vor- und Zubereiten der Bestandteile der Mahlzeiten sowie das Aufstellen eines Speiseplanes für die richtige Ernährung unter Berücksichtigung des Alters und der Lebensumstände des Pflegebedürftigen. Hierzu gehört auch die Bedienung der zum Kochen erforderlichen technischen Geräte sowie die Einschätzung der Mengenverhältnisse und Garzeiten unter Beachtung der Hygieneregeln.</p>\n\n<h2>Wohnungsreinigung</h2>\n\n<p>Hierzu gehören das Reinigen von Fußböden, Möbeln, Fenstern und Haushaltsgeräten im allgemein üblichen Lebensbereich des Pflegebedürftigen, die Kenntnis von Reinigungsmitteln und -geräten sowie das Bettenmachen.</p>\n\n<h2>Spülen</h2>\n\n<p>Je nach Gegebenheiten des Haushalts fällt hierunter das Hand- bzw. maschinelle Spülen.</p>\n\n<h2>Wechsel/Waschen der Kleidung/Wäsche</h2>\n\n<p>Hierzu gehören das Einteilen und Sortieren der Textilien, das Waschen, Aufhängen, Bügeln, Ausbessern und Einsortieren der Kleidung in den Schrank sowie das Bettenbeziehen.</p>\n\n<h2>Beheizen der Wohnung</h2>\n\n<p>Das Beheizen umfasst auch die Beschaffung und Entsorgung von Heizmaterial.</p>","created":"2014-05-21 11:27:07","modified":"2014-06-15 20:13:25"}]},{"id":"7","help_chapter_id":"1","name":"Eingeschränkte Alltagskompetenz","created":"2014-05-21 11:34:12","modified":"2014-05-21 11:34:12","HelpChapter":{"id":"1","name":"Erfassen des Hilfebedarfs","created":"2014-05-08 14:09:16","modified":"2014-06-16 20:42:04"},"HelpArticle":[{"id":"39","help_topic_id":"7","name":"Eingeschränkte Alltagskompetenz","content":"<h1>Eingeschränkte Alltagskompetenz </h1>\n\n\n<p>Mit dem 1. Pflegeverstärkungsgesetz (Januar 2015) besteht für alle Pflegebedürftigen die Möglichkeit, zusätzliche Betreuungs- und Entlastungsleistungen in Anspruch zu nehmen. Wird eine eingeschränkte Alltagskompetenz festgestellt, können Leistungen in Höhe von 104 bis 208 Euro im Monat in Anspruch genommen werden. </p>\n\n<p>Die Gutachter beurteilen anhand von 13 festgelegten Kriterien die Schwere der &#8220;Einschränkungen der Alltagskompetenz&#8221;. Werden bei der Begutachtung wenigstens zwei dieser Kriterien erfüllt, davon eines aus einem eingegrenzten Kriterienkatalog, besteht ein Anspruch auf Leistungen der Pflegeversicherung, selbst dann, wenn keine Pflegestufe vorliegt (Pflegestufe 0). </p>\n\n<p>Die Kriterien sind: </p>\n\n<h2>Orientierung</h2>\n\n<p>Orientierung beschreibt das Bescheid wissen über Ort, Zeit, Situation und Person. </p>\n\n<h2>Örtliche Orientierung </h2>\n\n<p>Örtliche Orientierung beinhaltet die Fähigkeit seinen Aufenthaltsort zu kennen und sich im eigenen Bewegungsradius zurecht zu finden. z.B. der Ortsname kann nur mit Mühe genannt werden kann oder die Orientierung in der Wohnung gelingt nicht mehr. </p>\n\n<h2>Zeitliche Orientierung </h2>\n\n<p>Zeitliche Orientierung beinhaltet die Fähigkeit, Tag und Uhrzeit zu kennen und entsprechend den Tagesablauf strukturieren zu können. </p>\n\n<h2>Situative Orientierung </h2>\n\n<p>Situative Orientierung beinhaltet das Verständnis für die derzeitige Lebenslage und die Hintergründe, die zur derzeitigen Situation geführt haben. </p>\n\n<h2>Personelle Orientierung </h2>\n\n<p>Personelle Orientierung beinhaltet das Wissen über die aktuelle persönliche als auch lebensgeschichtliche Situation und die individuelle Beziehung zu den Kontaktpersonen. z.B. ist eine Angabe des eigenen Namens, Geburtstags und Alter nicht möglich. </p>\n\n<h2>Antrieb/Beschäftigung </h2>\n\n<p>Die geistige Fähigkeit, geprägt durch Erlebnisse und Gewohnheiten, seine Zeit sinnvoll einzuteilen, sich entsprechend zu beschäftigen und seine Aktivitäten von sich aus aufzunehmen und an seine körperlichen Fähigkeiten anzupassen. </p>\n\n<h2>Stimmung </h2>\n\n<p>Die Stimmung drückt das Empfinden und die Steuerung von Emotionen wie z. B. Freude, Trauer, Hass aus. </p>\n\n<h2>Gedächtnis </h2>\n\n<p>Die Fähigkeit, Erlebtes und Erlerntes behalten und wiedergeben zu können. Im Langzeitgedächtnis sind z.B. biografische Angaben gespeichert. Das Kurzzeitgedächtnis umfasst die Merkfähigkeit, d. h. die Speicherung neu gelernter Inhalte für einige Minuten. </p>\n\n<h2>Tag-/Nachtrhythmus</h2>\n\n<p>Hierzu gehört die Fähigkeit, einen regelmäßigen und altersentsprechenden Rhythmus sowie die Art und Weise von Wachen, Ruhen und Schlafen zu gestalten und aufrecht zu erhalten, wie z. B. der Umgang mit Schlafstörungen, auch nach nächtlichen Unterbrechungen durch Wasserlassen oder das Einplanen notwendiger Ruhepausen tagsüber. </p>\n\n<h2>Wahrnehmung und Denken </h2>\n\n<p>Hierzu gehört die Fähigkeit, Informationen aus der Umgebung aufnehmen und einordnen zu können, logische Folgerungen zu schließen und begründete Entscheidungen treffen zu können. Dabei spielt das Erkennen von Gefahren und das Einschätzen von Risiken eine wesentliche Rolle. Formale Denkstörungen zeigen sich meistens in der Sprache. Es handelt sich dabei um Veränderungen in der Geschwindigkeit, Kohärenz und Stringenz des Gedankenablaufes. </p>\n\n<h2>Kommunikation und Sprache</h2>\n\n<p>Hierzu gehört die geistige Fähigkeit zum sinnhaften, interpersonellen Austausch unter Berücksichtigung kultureller Gegebenheiten. Wesentlich sind das Verstehen der Bezugsperson (hören, sehen, lesen) und Wünsche und Gedanken äußern zu können (Sprache, Schrift, Gestik, Mimik und Ausdruck von Gefühlen). </p>\n\n<h2>Situatives Anpassen </h2>\n\n<p>Dies beinhaltet die Fähigkeit, sich auf wechselnde Anforderungen/Situationen einzustellen, wie z. B. Besuch/Alleinsein/Wechsel der Bezugsperson, Änderung des üblichen Tagesablaufes, sich in gegebenen Situationen adäquat verhalten zu können, wie z. B. die Fähigkeit, Wünsche zu äußern, bei Gefahr Hilfe einzuholen, aber auch Ablehnungen deutlich zu machen. </p>\n\n<h2>Soziale Bereiche des Lebens wahrnehmen </h2>\n\n<p>Hierzu gehört die Fähigkeit, selbstständig soziale Kontakte aufnehmen und aufrecht erhalten zu können und sein Leben verantwortlich innerhalb des gesellschaftlichen Beziehungsgeflechtes zu gestalten. Das bedeutet u. a., Kontakte zu Familie, Nachbarn und Freunden pflegen zu können oder die Geschäftsfähigkeit bezüglich finanzieller und behördlicher Angelegenheiten zu erhalten.</p>","created":"2014-06-12 19:54:25","modified":"2014-12-30 10:32:58"},{"id":"40","help_topic_id":"7","name":"Angaben zur eingeschränkten Alltagskompetenz","content":"<h1>Angaben zur eingeschränkten Alltagskompetenz </h1>\n\n<p>Diese Angaben werden zur Einschätzung des Betreuungsaufwands der zu pflegenden Person benötigt und können zur Leistungen der Pflegeversicherung von 104 oder 208 Euro im Monat je nach Einschränkung der Alltagskompetenz führen. Aus diesem Grund werden Ihre Angaben dazu in die Exportdatei zusammen mit den pflegerischen Verrichtungen aufgenommen. </p>\n\n<p>Die Angaben zur Alltagskompetenz werden anhand von 13 Fragen an zwei Punkten innerhalb der App erfragt. Bereits nach Registrierung der App gibt es einen Hinweis, der Ihnen anbietet, die Angaben direkt zu machen. Wenn Sie an dieser Stelle ablehnen, werden Sie nochmals vor dem Start eines Exports der Auswertungsdatei Ihrer dokumentierten Verrichtungen darauf hingewiesen.</p>\n\n<p>Weiterhin können Sie die Angaben zur Alltagskompetenz wann immer Sie wollen im Profil selbst eingeben und speichern. <br />\n<img alt=\"Profil\" src=\"img/Icon_Profil.png\" title=\"Profil\" /> <br />\n<img alt=\"Eingeschränkte Alltagskompetenz\" src=\"img/Icon_Eingalltagskomp.png\" title=\"Eingeschränkte Alltagskompetenz\" /> </p>\n\n<p>Eine Einschätzung des tatsächlichen Betreuungsaufwandes können Sie der Exportdatei entnehmen.</p>","created":"2014-06-12 20:29:23","modified":"2014-12-30 10:09:42"}]},{"id":"9","help_chapter_id":"1","name":"Erfassen","created":"2014-05-21 12:12:57","modified":"2014-06-03 12:51:23","HelpChapter":{"id":"1","name":"Erfassen des Hilfebedarfs","created":"2014-05-08 14:09:16","modified":"2014-06-16 20:42:04"},"HelpArticle":[{"id":"9","help_topic_id":"9","name":"Hilfeformen","content":"<h1>Hilfeformen</h1>\n\n<p>Der Gesetzgeber hat den Hilfebedarf, der für eine Pflegestufe wichtig ist, nach dem Zeitaufwand ausgelegt, der für die Hilfestellungen und Pflege notwendig ist. Zudem ist es für die Einstufung ausschlaggebend, welche Hilfen im Laufe eines Tages für diese definierten Verrichtungen notwendig sind. Wenn der Gutachter des <span class=\"caps\">MDK</span> zu Ihrem Angehörigen kommt, um den Pflegebedarf zu ermitteln, nimmt er eine Pflegezeitbemessung für die Verrichtungen der Grundpflege vor. Dazu teilt er die Hilfeleistungen in so genannte Hilfeformen ein. Eine mögliche Hilfeform ist die Vollübernahme. Das heißt, Sie übernehmen die vollständige Verrichtung, und Ihr Angehöriger bleibt bei allem passiv.</p>\n\n<blockquote>\n\t<p>Wichtig: Je Verrichtung, die in der App interaktives Pflegetagebuch angelegt wird, muss neben dem Zeitpunkt, der Dauer der Verrichtung und der Anzahl der beteiligten Helfer eine Hilfeform angegeben werden um die Einschätzung der Pflegestufe so korrekt wie möglich vornehmen zu können. Die Hilfeform kann auch im Nachhinein nach Anlage einer Verrichtung unter dem Punkt &#8220;Bearbeiten&#8221; hinzugefügt werden. <br />\nDokumentierte Verrichtungen, zu denen wichtige Informationen fehlen sind mit einem orangen Ausrufezeichen markiert.<br />\n<img alt=\"Daten unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten unvollständig\" /></p>\n</blockquote>\n\n<h2>Die verschiedenen Hilfeformen</h2>\n\n<h3>Unterstützung</h3>\n\n<p>Unterstützung bedeutet, dass der Pflegebedürftige grundsätzlich zur selbständigen Erledigung einer Verrichtung in der Lage ist, jedoch zur Vorbereitung, Durchführung oder Nachbereitung ergänzende Hilfeleistungen der Pflegeperson benötigt (Beispiel: Durch eine teilweise Lähmung muss die Hand des rechten Armes zum Kämmen von einer anderen Person geführt werden).</p>\n\n<h3>Übernahme</h3>\n\n<p>Teilweise Übernahme bedeutet, dass eine Hilfe bei einer teilweise selbständig erledigten Verrichtung benötigt wird. Vollständige Übernahme bedeutet, dass die Pflegeperson die Verrichtung notwendigerweise selbst ausführt, da der Pflegebedürftige diese nicht selbst ausführen kann.</p>\n\n<h3>Anleitung</h3>\n\n<p>Anleitung und Beaufsichtigung haben zum Ziel, dass die täglichen Verrichtungen in sinnvoller Weise vom Pflegebedürftigen selbst durchgeführt werden. Anleitung bedeutet, dass die Pflegeperson bei einer konkreten Verrichtung den Ablauf der einzelnen Handlungsschritte oder den ganzen Handlungsablauf lenken oder demonstrieren muss (Beispiel: Die Pflegeperson muss beim Waschen den Ablaufder einzelnen Handlungsabschnitte lenken oder demonstrieren).</p>\n\n<h3>Beaufsichtigung</h3>\n\n<p>Bei der Beaufsichtigung steht zum einen die Sicherheit beim konkreten Handlungsablauf der Verrichtung(Eigen- oder Fremdgefährdung) im Vordergrund (z. B. beim Rasieren, wenn durch unsachgemäße Benutzung des Rasierapparates eine Selbstgefährdung beim konkreten Handlungsablauf der Verrichtung gegeben ist), zum anderen die Kontrolle darüber, ob die betreffenden Verrichtungen in der erforderlichen Art und Weise durchgeführt werden.</p>\n\n<h2>Orientierungswerte</h2>\n\n<p>Für jede Hilfeform gibt es sogenannte Orientierungswerte, in denen der zu berücksichtigende Zeitbedarf für die Pflegestufe festgelegt ist.<br />\nBei einer leichten Demenz beispielsweise genügt bei der Pflege die Aufforderung, eine Mahlzeit einzunehmen. Liegt eine schwere Demenz vor, muss der Erkrankte hingegen nahezu zu jedem Bissen einzeln aufgefordert werden. Diese Hilfeform wäre dann eine Anleitung in Verbindung mit Beaufsichtigung, hat einen wesentlich höheren Zeitaufwand als die Hilfe bei einer leichten Demenz, und gehört somit zu einer höheren Pflegestufe. </p>","created":"2014-05-21 10:28:39","modified":"2014-06-16 13:48:59"},{"id":"25","help_topic_id":"9","name":"Verrichtungen erfassen","content":"<h1>Verrichtungen erfassen</h1>\n\n<p>Unter dem Begriff &#8220;Verrichtungen&#8221; sind alle pflegerischen Handlungen zusammengefasst, die Sie als Laienpflegekraft in der Unterstützung Ihres pflegebedürftigen Angehörigen in der Häuslichkeit vornehmen. Davon ausgenommen sind Tätigkeiten der sog. Behandlungspflege (Tätigkeiten medizinischen Hintergrunds wie Medikamente verabreichen, Spritzen und Infusionen geben etc.).</p>\n\n<p>Die einzelnen Verrichtungen, die für Ihren pflegenden Angehörigen durchgeführt werden können, erreichen Sie über den Startbildschirm unter &#8220;Erfassen&#8221;.<br />\n<img alt=\"Erfassen von Verrichtungen\" src=\"img/Icon_Erfassen.png\" title=\"Erfassen von Verrichtungen\" /></p>\n\n<p>Hier sind die 4 Hauptkatgeorien in jeweils einfarbigen Würfeln voneinander unterschieden:</p>\n\n<ul>\n\t<li>Ernährung</li>\n\t<li>Körperpflege</li>\n\t<li>Mobilität</li>\n</ul>\n\n<p>Dies diesen Kategorien zugeordneten Verrichtungen werden zur Einschätzung einer möglichen Pflegestufe bei der Auswertung aufsummiert zur Gesamtkategorie &#8220;Grundpflege&#8221;.</p>\n\n<p>Weiterhin gibt es die Hauptkategorie:<br />\n<ul>\n\t<li>Hauswirtschaft (= hauswirtschaftliche Versorgung)</li><br />\n</ul></p>\n\n<p>Diese wird in der Auswertung zur Pflegestufe der Summe &#8220;Grundpflege&#8221; gegenübergestellt und mit einberechnet.</p>\n\n<p>Per Klick auf die jeweilige Hauptkategorie gelangt man zu den jeweiligen Unterkategorien und von dort zu den einzelnen Verrichtungen. </p>\n\n<blockquote>\n\t<p>Versuchen Sie zur Beantragung einer Pflegestufe Ihres Angehörigen für mindestens sieben Tage alle pflegerischen Verrichtungen, die Sie tagtäglich vornehmen, auf die Minute genau mit dem interaktiven Pflegetagebuch zu dokumentieren. Danach können Sie eine provisorische Einschätzung einer möglichen Pflegestufe vornehmen und die Dokumentationsdatei an die Pflegeversicherung Ihres Angehörigen zusammen mit dem Antrag auf Pflegestufe schicken.</p>\n</blockquote>","created":"2014-05-21 12:24:26","modified":"2014-06-16 13:47:58"},{"id":"26","help_topic_id":"9","name":"Angaben zu Verrichtungen","content":"<h1>Angaben zu den Verrichtungen</h1>\n\n<p>Je einzelner Verrichtung, die gespeichert wird, müssen zwingend weitere Angaben zu derjenigen Verrichtung angelegt werden. </p>\n\n<p>Es ist möglich jede Verrichtung nur mit Verrichtungsname und Startzeit zu speichern und die weiteren Angaben vor der Einschätzung der Pflegestufe und dem Export nachzupflegen. </p>\n\n<p>Die notwendigen Angaben je Verrichtung sind:</p>\n\n<h2>Startzeit</h2>\n\n<p>Die Startzeit enthält das Datum und den Zeitpunkt, an dem die Verrichtung durchgeführt wurde<br />\nDie Startzeit kann per Klick auf das voreingestellte Datum oder den voreingestellten Zeitpunkt verändert werden.</p>\n\n<h2>Dauer</h2>\n\n<p>Die Dauer der Verrichtung kann zweierlei festgelegt werden:</p>\n\n<ul>\n\t<li>Das blaue Icon steht für eine Stoppuhr die bei Start einer Verrichtung gestartet und bei erneutem Klick auf das Symbol gestoppt werden kann. Die gestoppte Zeit wird dann als Dauer der Verrichtung übernommen.<br />\nDie Stoppuhr kann jederzeit per Klick auf den Ausgangspunkt zurückgestellt und ein erneutes Stoppen der Zeit durchgeführt werden.<br />\n<img alt=\"Starten der Stoppuhr\" src=\"img/Icon_Stoppuhr.png\" title=\"Starten der Stoppuhr\" /><br />\n<img alt=\"Laufende Stoppuhr zurückstellen\" src=\"img/Icon_Zurueckstellen.png\" title=\"Laufende Stoppuhr zurückstellen\" /></li>\n</ul>\n\n<ul>\n\t<li>Die Dauer kann ebenso bei Klick auf das Symbol individuell eingestellt werden. Wichtig: Die Dauer wird immer in Minuten: Sekunden angegeben.<br />\n<img alt=\"Dauer bearbeiten\" src=\"img/Icon_Dauer.png\" title=\"Dauer bearbeiten\" /></li>\n</ul>\n\n<ul>\n\t<li>Hilfeform:<br />\nAn dieser Stelle muss ausgewählt werden welche Form der Hilfestellung Sie Ihrem Angehörigen gegeben haben. Dies kann eine der folgenden Hilfeformen sein: Anleitung, Beaufsichtigung, teilweise Übernahme, vollständige Übernahme oder Unterstützung. Weitere Information zu den einzelnen Hilfeformen finden Sie unter &#8220;Hilfeformen&#8221;.</li>\n</ul>\n\n<ul>\n\t<li>Anzahl der beteiligten Helfer:<br />\nHier wählen Sie aus wieviele Laienpfleger_innen bei einer Verrichtung mit/an der pflegebedürftigen Person beteilgt sind. Im Normalfall werden dies 1-2 sein.</li>\n</ul>\n\n<p>Nach Eingabe dieser Angaben je Verrichtung können Sie die Verrichtung speichern per Klick auf den Knopf &#8220;Speichern&#8221;.<br />\n<img alt=\"Speichern\" src=\"img/Icon_Speichern.png\" title=\"Speichern\" /></p>","created":"2014-05-21 12:47:54","modified":"2014-06-16 13:50:09"}]},{"id":"10","help_chapter_id":"1","name":"Bearbeiten","created":"2014-05-21 13:37:32","modified":"2014-06-03 12:51:36","HelpChapter":{"id":"1","name":"Erfassen des Hilfebedarfs","created":"2014-05-08 14:09:16","modified":"2014-06-16 20:42:04"},"HelpArticle":[{"id":"27","help_topic_id":"10","name":"Verrichtungen ändern","content":"<h1>Verrichtungen ändern</h1>\n\n<p>Sobald Verrichtungen unter dem Menüpunkt &#8220;Erfassen&#8221; dokumentiert wurden, sind diese im Menüpunkt &#8220;Bearbeiten&#8221; als Liste aller angelegten Verrichtungen nach Tag und Uhrzeit (Zeitraum) und in der jeweiligen Farbe der Hauptkategorie markiert (Ernährung, Mobilität, Körperpflege, Hauswirtschaft) aufgelistet. <br />\n<img alt=\"Bearbeiten von Verrichtungen\" src=\"img/Icon_Bearbeiten.png\" title=\"Bearbeiten von Verrichtungen\" /></p>\n\n<p>Die Verrichtungen werden den folgenden Zeiträumen zugeordnet:<br />\n<ul>\n\t<li>morgens (6-12h)</li>\n\t<li>mittags (12-14h)</li>\n\t<li>nachmittags (14-18h)</li>\n\t<li>abends (18-22h)</li>\n\t<li>nachts (22-6h)</li><br />\n</ul></p>\n\n<p>Folgende Funktionalitäten sind hier verfügbar:</p>\n\n<ul>\n\t<li>per wischen (swipen) über den Bildschirm oder Verwendung der Pfeile in der Menüleiste des smartphones kann die Tagesansicht gewechselt werden</li>\n</ul>\n\n<ul>\n\t<li>per Klick auf die einzelne Verrichtung können an derselbigen Änderungen und Einträge vorgenommen und wiederum gespeichert werden</li>\n</ul>\n\n<ul>\n\t<li>In der Einzelübersicht der jeweiligen Verrichtung wird im Feld &#8220;Dauer&#8221; ein Orientierungswert in Klammern angegeben. Dieser zeigt die vom <span class=\"caps\">MDK</span> vorgegebene Maximaldauer der Verrichtung und ist damit Bemessungsgrundage für eine mögliche Pflegestufe. Sollte Ihr tatsächlich gestoppter oder eingegebener Wert darüberliegen, so wird dies in der persönlichen Begutachtung selbst nochmals besprochen bzw. überprüft werden.</li>\n</ul>\n\n<ul>\n\t<li>per Klick auf &#8220;Eintrag löschen&#8221; können in diesem Menü Verrichtungen gelöscht werden</li>\n</ul>","created":"2014-05-21 14:26:51","modified":"2014-06-16 13:51:12"},{"id":"37","help_topic_id":"10","name":"weitere Angaben einpflegen","content":"<h1>weitere Angaben einpflegen</h1>\n\n<p>Alle bereits dokumentierten Verrichtungen werden in der Listenansicht &#8220;Bearbeiten&#8221; in den verschiedenen Zeitintervallen, in denen Sie vorgenommen wurden, angezeigt. Die Zeit, mit der eine Verrichtung dokumentiert wurde, ist mit der Farbe der Hauptkategorie markiert (Ernährung, Körperpflege, Mobilität oder Hauswirtschaft).<br />\n<img alt=\"Bearbeiten von Verrichtungen\" src=\"img/Icon_Bearbeiten.png\" title=\"Bearbeiten von Verrichtungen\" /></p>\n\n<p>Zu den einzelnen Verrichtungen können Sie folgende Symbole erkennen:<br />\nDas orange Ausrufezeichen zeigt an, dass die Angaben zu der Verrichtung noch unvollständig sind. Indem Sie auf die jeweilige Verrichtung klicken kommen Sie zu den einzelnen Angaben und können diejenigen, die fehlen oder falsch sind, angeben und speichern.<br />\n<img alt=\"Daten sind unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind unvollständig\" /></p>\n\n<blockquote>\n\t<p>Um eine korrekte Einschätzung einer möglichen Pflegestufe vornehmen zu können sind je Verrichtung alle Angaben zu Startzeit, Dauer, Hilfeform und Anzahl beteiligter Helfer zu machen!</p>\n\n\t<p>Der grüne Haken zeigt an, dass alle erforderlichen Angaben zu einer Verrichtung dokumentiert worden sind. Sollten Sie dennoch Änderungen vornehmen wollen, so können Sie einfach über Klick auf die jeweilige Verrichtung in die Details gelangen.<br />\n<img alt=\"Daten sind vollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind vollständig\" /></p>\n\n\t<p>Der blaue Pfeil nach oben zeigt an, dass Sie den Orientierungswert des Zeitraums für die Verrichtung, der vom <span class=\"caps\">MDK</span> vorgegeben ist, überschritten haben. Überprüfen Sie die Dauer, indem Sie per Klick in die Details der Verrichtung gelangen. Sollten Sie bei der von Ihnen angegeben Dauer bleiben, so wird diese dokumentierte Dauer in die Auswertung übernommen.<br />\n<img alt=\"Dauer liegt über Orientierungswert\" src=\"img/Icon_Dauer_lang.png\" title=\"Dauer liegt über Orientierungswert\" /></p>\n\n\t<p>Der blaue Pfeil nach unten zeigt an, dass Sie den Orientierungswert des Zeitraums für die Verrichtung, der vom <span class=\"caps\">MDK</span> vorgegeben ist, unterschritten haben. Überprüfen Sie die Dauer indem Sie per Klick in die Details der Verrichtung gelangen. Sollten Sie bei der von Ihnen angegeben Dauer bleiben, so wird diese dokumentierte Dauer in die Auswertung übernommen.<br />\n<img alt=\"Dauer liegt unter Orientierungswert\" src=\"img/Icon_Dauer_kurz.png\" title=\"Dauer liegt unter Orientierungswert\" /></p>\n\n\t<p>Der blaue Pfeil nach rechts zeigt an, dass Sie sich mit der Zeitdauer der Verrichtung innerhalb des Orientierungswertes, der vom <span class=\"caps\">MDK</span> vorgegeben ist, befinden. <br />\n<img alt=\"Dauer liegt im Orientierungswert\" src=\"img/Icon_Dauer_ok.png\" title=\"Dauer liegt im Orientierungswert\" /></p>\n</blockquote>","created":"2014-06-03 12:44:04","modified":"2014-06-16 13:55:46"}]}]},{"HelpChapter":{"id":"2","name":"Informationen zur Pflegestufe","created":"2014-05-08 14:09:23","modified":"2014-05-21 10:30:04"},"HelpTopic":[{"id":"3","help_chapter_id":"2","name":"Pflegebedürftigkeit","created":"2014-05-16 11:54:16","modified":"2014-05-20 17:08:22","HelpChapter":{"id":"2","name":"Informationen zur Pflegestufe","created":"2014-05-08 14:09:23","modified":"2014-05-21 10:30:04"},"HelpArticle":[{"id":"4","help_topic_id":"3","name":"Leistungen der Pflegeversicherung","content":"<h1>Leistungen der Pflegeversicherung </h1>\n\n<p>Bei Pflegebedürftigkeit nach dem Gesetz wird eine Pflegestufe anerkannt. Dies geschieht bei Personen, die wegen einer körperlichen, geistigen oder seelischen Krankheit oder Behinderung für die gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen des täglichen Lebens erhebliche fremde Hilfe benötigen &#8211; und zwar über eine voraussichtliche Dauer von mindestens sechs Monaten.</p>\n\n<h2>Der Hilfebedarf </h2>\n\n<p>Maßgeblich für die Pflegestufen ist der Hilfebedarf bei den &#8220;gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen des täglichen Lebens&#8221;. Hiermit sind Hilfen der Grundpflege und der hauswirtschaftlichen Versorgung gemeint. Gibt es nur einen Hilfebedarf bei der hauswirtschaftlichen Versorgung, dann ist dies nicht ausreichend für eine Pflegestufe. </p>\n\n<h2>Die Pflegestufen </h2>\n\n<p>Die meisten Leistungen der sozialen Pflegeversicherung bemessen sich nach &#8220;Pflegestufen&#8221;. Sie reichen von &#8220;erheblicher&#8221; Pflegebedürftigkeit (Stufe 1) über &#8220;schwere Pflegebedürftigkeit&#8221; (Stufe 2) zu &#8220;Schwerster Pflegebedürftigkeit&#8221; (Stufe 3). Dabei wird vorrangig die häusliche Pflege, insbesondere durch Pflegegeld bzw. -sachleistungen, gefördert. </p>\n\n<p>Der <span class=\"caps\">MDK</span> (Medizinische Dienst der Krankenversicherung) gibt in sogenannten „Katalog-Verrichtungen“ vor, welche pflegerischen Verrichtungen für eine Pflegestufe anrechenbar sind. Diese Verrichtungen bilden die Grundlagen der App &#8220;interaktives Pflegetagebuch&#8221; und können darin dokumentiert werden.</p>","created":"2014-05-20 17:48:13","modified":"2014-12-30 10:13:00"},{"id":"5","help_topic_id":"3","name":"Das Pflegetagebuch","content":"<h1>Das Pflegetagebuch</h1>\n\n<p>Zur Dokumentation der pflegerischen Verrichtungen ist es ratsam für mindestens 1 Woche vor Begutachtung durch den <span class=\"caps\">MDK</span> ein Pflegetagebuch zu führen. In diesem halten sie alle Verrichtungen <strong>minutengenau</strong> fest und notieren besondere Umstände und Tagesgeschehnisse rund um die Pflege, so dass ein Gesamtbild des Pflegeaufwandes, sowie die Pflege erschwerende Faktoren deutlich werden. Dies macht eine Einschätzung des tatsächlichen Pflegeaufwandes Ihres Angehörigen genauer und hilft Ihnen die Situation bei der Begutachtung detailliert darzulegen.</p>\n\n<p>In den Richtlinien zur Begutachtung sind Richtzeiten enthalten, die für die Verrichtung der einzelnen Tätigkeiten angesetzt werden sollen. Da jedoch die tatsächliche häusliche Situation beurteilt werden soll, kann mit entsprechender Begründung davon abgewichen werden. Zeitzuschläge gibt es, wenn die Pflege besonders schwierig ist, etwa wegen versteifter Gelenke, unkontrollierter Bewegungen, starker Schmerzen oder eines hohen Körpergewichts des Pflegebedürftigen. </p>\n\n<p>Daher ist es von Vorteil wenn Sie die Fragen zur „eingeschränkten Alltagskompetenz“ in dem Pflegetagebuch beantworten, so dass sich der Gutachter des <span class=\"caps\">MDK</span>, als auch de Pflegekasse, vor und in der Begutachtung, ein detailliertes Bild von Ihrem Angehörigen machen können und der Weg zu einer Pflegestufe für Sie und Ihren Angehörigen leichter wird.<br />\nBitte beachten Sie, dass Leistungen der so genannten medizinischen Behandlungspflege, z. B. Infusionen geben oder Verbände anlegen, nicht in das Tagebuch eingetragen werden sollten. Sie werden bei der Ermittlung der Pflegestufe nicht berücksichtigt, da dies Leistungen der Kranken- und nicht der Pflegeversicherung sind.</p>","created":"2014-05-20 17:54:09","modified":"2014-06-01 14:49:22"}]},{"id":"4","help_chapter_id":"2","name":"Die Pflegestufen","created":"2014-05-20 17:10:49","modified":"2014-05-20 17:10:49","HelpChapter":{"id":"2","name":"Informationen zur Pflegestufe","created":"2014-05-08 14:09:23","modified":"2014-05-21 10:30:04"},"HelpArticle":[{"id":"7","help_topic_id":"4","name":"Voraussetzungen für die Pflegestufen","content":"<h1>Voraussetzungen für die Pflegestufen</h1>\n\n<p>Der Zeitaufwand muss aufgrund der individuellen Pflegesituation, bezogen auf eine Woche, im Tagesdurchschnitt bestimme Mindestwerte erreichen:</p>\n\n<table>\n\t\t<tr>\n\t\t\t<td> <strong>Pflegestufe</strong> </td>\n\t\t\t<td> <strong>Hilfeb. Grundpfl.</strong> </td>\n\t\t\t<td> <strong>Min. ges.</strong> </td>\n\t\t\t<td> <strong>davon Grundpfl.</strong> </td>\n\t\t\t<td> <strong>davon Hauswirts.</strong> </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 1 </td>\n\t\t\t<td> wenigstens 2 Verrichtungen mind 1x tgl. </td>\n\t\t\t<td> 90 </td>\n\t\t\t<td> 45 </td>\n\t\t\t<td>45 </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 2 </td>\n\t\t\t<td> mindestens 3x tgl. zu versch. Tageszeiten </td>\n\t\t\t<td> 180 </td>\n\t\t\t<td> 120 </td>\n\t\t\t<td> 60 </td>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td> 3 </td>\n\t\t\t<td> rund um die Uhr auch nachts </td>\n\t\t\t<td> 300 </td>\n\t\t\t<td> 240 </td>\n\t\t\t<td> 60 </td>\n\t\t</tr>\n</table>\n\n<p>Anmerkungen Pflegestufe 3: zu verschiedenen Tageszeiten (6-22h) und auch regelmäßig mindestens 1x nachts (22-6h)</p>","created":"2014-05-21 09:51:30","modified":"2014-06-01 14:50:03"},{"id":"8","help_topic_id":"4","name":"Hilfebedarf","content":"<h1>Hilfebedarf </h1>\n\n<p>Maßgeblich für die Einschätzung einer Pflegestufe ist der auf Dauer erforderliche Hilfebedarf für die gewöhnlichen und regelmäßig wiederkehrenden Verrichtungen im Ablauf des täglichen Lebens im Bereich der Grundpflege und der hauswirtschaftlichen Versorgung. Der Hilfebedarf ist &#8220;regelmäßig&#8221; wenn er mindestens einmal pro Woche und auf Dauer &#8211; mindestens sechs Monate &#8211; anfällt. </p>\n\n<p>Der Gesetzgeber hat den Hilfebedarf, der für eine Pflegestufe wichtig ist, nach dem Zeitaufwand ausgelegt, der für die Hilfestellungen und Pflege notwendig ist. Zudem ist es für die Einstufung ausschlaggebend, welche Hilfen im Laufe eines Tages für diese definierten Verrichtungen notwendig sind. </p>\n\n<h2>Bemessung des Pflegeaufwands </h2>\n\n<p>Maßstab für die Bemessung der Pflegeaufwands ist grundsätzlich die Pflegezeit, die nicht professionelle Personen (z.B. Familienangehörige) im Sinne einer Laienpflege benötigen würden. Maßgebend ist zwar stets die individuelle Pflegesituation, jedoch gibt es Orientierungswerte für die Pflegezeit, die bei der Begutachung herangezogen werden können. Dadurch sollen pflegebedürftige Menschen mit ähnlichen Einschränkungen &#8211; unabhängig von der Pflegeperson &#8211; möglichst gleich behandelt und somit derselben Pflegestufe zugeordnet werden.</p>","created":"2014-05-21 10:22:43","modified":"2014-12-30 10:14:48"}]},{"id":"5","help_chapter_id":"2","name":"Leistungen der Pflegeversicherung","created":"2014-05-20 17:11:25","modified":"2014-05-21 09:41:01","HelpChapter":{"id":"2","name":"Informationen zur Pflegestufe","created":"2014-05-08 14:09:23","modified":"2014-05-21 10:30:04"},"HelpArticle":[{"id":"10","help_topic_id":"5","name":"Pflegesachleistungen","content":"<h1>Pflegesachleistungen </h1>\n\n<p>Von Pflegesachleistungen spricht man, wenn ein Pflegebedürftiger zu Hause durch einen ambulanten Pflegedienst gepflegt wird. Die Pflegekasse rechnet direkt mit dem Pflegedienst ab. Im Angebot sind die Pflege, Hilfen im Haushalt und die sogenannte häusliche Betreuung. Pflegebedürftige können solche Sachleistungen der Pflegekasse von ambulanten Pflegediensten in Anspruch nehmen bis zu monatlich </p>\n\n<ul>\n\t<li>231 Euro in der Pflegestufe 0</li>\n\t<li>468 Euro in der Pflegestufe 1</li>\n\t<li>1.144 Euro in der Pflegestufe 2</li>\n\t<li>1.612 Euro in der Pflegestufe 3</li>\n</ul>\n\n<p>Auch Menschen mit besonderem Betreuungsbedarf aufgrund von &#8220;Einschränkungen der Alltagskompetenz&#8221;, etwa wegen einer Demenz, erhalten Leistungen der Pflegeversicherung. Wer schon in Pflegestufe 1 oder 2 eingestuft ist, erhält Zuschläge. Menschen mit Einschränkungen der Alltagskompetenz können daher Leistungen von ambulanten Pflegediensten im folgenden Umfang erhalten: </p>\n\n<ul>\n\t<li>231 Euro ohne Pflegestufe</li>\n\t<li>689 Euro in der Pflegestufe 1</li>\n\t<li>1.298 Euro in der Pflegestufe 2</li>\n</ul>\n\n<p>In Pflegestufe 3 und bei Härtefällen bleibt es bei den üblichen Leistungen.</p>","created":"2014-05-21 10:37:08","modified":"2014-12-30 10:18:55"},{"id":"11","help_topic_id":"5","name":"Bündelung von Leistungen","content":"<h1>Bündelung von Leistungen</h1>\n\n<p>Immer mehr Menschen wollen auch im Alter weitgehend selbstbestimmt leben und suchen daher als Alternative zum Heim andere Wohnformen wie zum Beispiel Wohngemeinschaften für Senioren. Künftig soll das Zusammenleben in solchen Wohnformen verbessert werden. Daher können Versicherte ihre Ansprüche auf Sachleistungen gemeinsam mit anderen Leistungsberechtigten bündeln, die zum Beispiel auch in der Wohngemeinschaft leben. Das bedeutet etwa, dass sich eine Pflegekraft um mehrere Pflegebedürftige innerhalb einer Wohngemeinschaft kümmert. Die durch die Bündelung der Ansprüche entstehenden Kosten- und Zeitersparnisse können dann für zusätzliche Betreuungsleistungen genutzt werden.</p>","created":"2014-05-21 10:37:53","modified":"2014-06-01 14:54:08"},{"id":"12","help_topic_id":"5","name":"Pflegegeld","content":"<h1>Pflegegeld </h1>\n\n<p>Pflegegeld erhält man, wenn ehrenamtliche Pfleger die häusliche Pflege übernehmen. Das können zum Beispiel Familienangehörige oder Nachbarn sein. In diesem Fall erhält der Pflegebedürftige das Pflegegeld direkt auf sein Konto, und zwar </p>\n\n<ul>\n\t<li>244 Euro in der Pflegestufe 1</li>\n\t<li>458 Euro in der Pflegestufe 2</li>\n\t<li>728 Euro in der Pflegestufe 3</li>\n</ul>\n\n<p>Der Pflegebedürftige bestimmt auch hier selbst, wie das Geld ausgegeben wird. Auch Menschen mit besonderem Betreuungsbedarf aufgrund von &#8220;Einschränkungen der Alltagskompetenz&#8221;, etwa wegen einer Demenz, erhalten Leistungen der Pflegeversicherung. <br />\nWer schon in Pflegestufe 1 oder 2 eingestuft ist, erhält Zuschläge. Menschen mit Einschränkungen der Alltagskompetenz können daher Pflegegeld im folgenden Umfang erhalten: </p>\n\n<ul>\n\t<li>123 Euro ohne Pflegestufe</li>\n\t<li>316 Euro in der Pflegestufe 1</li>\n\t<li>545 Euro in der Pflegestufe 2</li>\n</ul>\n\n<p>In Pflegestufe 3 bleibt es bei den üblichen Leistungen.</p>","created":"2014-05-21 10:39:30","modified":"2014-12-30 10:20:49"},{"id":"13","help_topic_id":"5","name":"Kombination von Sachleistung und Pflegegeld","content":"<h1>Kombination von Sachleistung und Pflegegeld </h1>\n\n<p>Dabei werden prozentuale Anteile der nicht verbrauchten Pflegesachleistungen auf das Pflegegeld angerechnet. Beispiel: Ein Pflegebedürftiger (mit Pflegestufe 2) hat Anspruch auf Pflegesachleistungen von 1.144 Euro. Tatsächlich verbraucht werden aber nur 70 Prozent, also eine Summe von 800,80 Euro. Deshalb können 30 Prozent vom Pflegegeld ausgezahlt werden. Bei einem Satz von 458 Euro wären das in diesem Fall 137,40 Euro.</p>","created":"2014-05-21 10:40:33","modified":"2014-12-30 10:22:03"},{"id":"24","help_topic_id":"5","name":"Rentenanspruch pflegender Angehöriger","content":"<h1>Rentenanspruch pflegender Angehöriger</h1>\n\n<p>Wenn Sie eine Angehörige oder einen Angehörigen für mindestens 14 Stunden in der Woche pflegen und diese Pflege nicht erwerbsmäßig ausführen, sind Sie eine sogenannte Pflegeperson im Sinne der Pflegeversicherung. Die Zeiten, die Sie für die ehrenamtliche Pflege von mehreren Pflegebedürftigen aufwenden, werden dabei zusammengerechnet, wenn ansonsten der Mindestumfang von 14 Stunden Pflegetätigkeit pro Woche nicht erreicht wird. </p>\n\n<p>Sind Sie neben der Pflege nicht mehr als 30 Stunden in der Woche erwerbstätig, zahlt die Pflegeversicherung für Sie Beiträge zur Rentenversicherung, falls Sie nicht bereits eine Vollrente wegen Alters beziehen. Die Höhe der Rentenversicherungsbeiträge richtet sich dabei nach dem Schweregrad der Pflegebedürftigkeit und dem Umfang Ihrer Pflegetätigkeit. </p>","created":"2014-05-21 12:00:15","modified":"2014-06-01 14:55:53"}]},{"id":"8","help_chapter_id":"2","name":"Beantragung der Pflegestufe","created":"2014-05-21 11:44:30","modified":"2014-05-21 11:44:30","HelpChapter":{"id":"2","name":"Informationen zur Pflegestufe","created":"2014-05-08 14:09:23","modified":"2014-05-21 10:30:04"},"HelpArticle":[{"id":"19","help_topic_id":"8","name":"Der Antrag zur Pflegestufe","content":"<h1>Der Antrag zur Pflegestufe </h1>\n\n<p>Damit Ihr Angehöriger vom <span class=\"caps\">MDK</span> (Medizinischen Dienst der Krankenversicherung) für eine Pflegeeinstufung begutachtet wird, müssen Sie vorher einen Antrag bei der Pflegeversicherung stellen. Der Antrag auf Leistungen der Pflegekasse kann formlos sein. Daraufhin senden die Pflegekassen normalerweise ein Formular zu, um genaue Angaben über Ihren Pflegealltag zu bekommen. Dabei dürfen nur Informationen abgefragt werden, die für die Beurteilung der Pflegebedürftigkeit notwendig sind. </p>\n\n<p>Als Antragsdatum gilt bei der Beurteilung der Pflegebedürftigkeit das Eingangsdatum des formlosen Antrags, nicht der Zeitpunkt der Rücksendung des Formulars an die Pflegeversicherung. Nachdem der Antrag auf Feststellung des Pflegebedarfs gestellt wurde, beauftragt die Pflegeversicherung den Medizinischen Dienst der Krankenkassen, Ihren Angehörigen zu begutachten. Dies erfolgt durch einen vorher angemeldeten Hausbesuch.</p>","created":"2014-05-21 11:45:35","modified":"2014-12-30 10:23:10"},{"id":"20","help_topic_id":"8","name":"Eine Höherstufung beantragen","content":"<h1>Eine Höherstufung beantragen</h1>\n\n<p>Auch bei bereits anerkannter Pflegebedürftigkeit kann ein Antrag auf eine höhere Pflegeeinstufung gestellt werden. Dafür sollte die letzte Begutachtung jedoch mindestens sechs Monate zurückliegen. Diese Wartefrist gilt nicht, wenn sich der Gesundheitszustand Ihres Angehörigen erheblich verschlechtert hat.</p>\n\n<p>Da beim Höherstufungsantrag die aktuelle Pflegebedürftigkeit geprüft wird, kann es allerdings auch passieren, dass die Einstufung in eine niedrigere Pflegestufe erfolgt. Auch hier macht der <span class=\"caps\">MDK</span> einen Hausbesuch. </p>","created":"2014-05-21 11:46:26","modified":"2014-06-01 14:57:15"},{"id":"21","help_topic_id":"8","name":"Besuch durch den MDK","content":"<h1>Besuch durch den <span class=\"caps\">MDK</span></h1>\n\n<p>Der <span class=\"caps\">MDK</span> (Medizinischer Dienst der Krankenkassen) schickt im Auftrag der Pflegeversicherung einen Gutachter, der feststellt, ob eine Pflegebedürftigkeit vorliegt, und wenn ja, im Maße welcher Pflegestufe. Dafür sollten Sie auf jeden Fall dabei sein, denn der Gutachter muss Sie, die Pflegeperson, befragen, welche Hilfen Sie erbringen. Wird ihr pflegender Angehöriger auch von einem Pflegedienst versorgt, so ist es ratsam, eine Pflegekraft, die mit Ihrem Angehörigen vertraut ist, für das Gespräch hinzu zu holen. Für die Begutachtung ist es praktisch, das Pflegetagebuch bzw. den Ausdruck zur Hand zu haben. Sie können dem Gutachter den Ausdruck auch mitgeben – aber das müssen Sie nicht. </p>\n\n<h2>Die Begutachtung</h2>\n\n<p>Dem Gutachter zu erzählen, Sie würden alles für Ihren Angehörigen übernehmen, ist nicht empfehlenswert. Berichten Sie ihm, dass Sie sich bemühen, Ihren Angehörigen zur eigenen Ausführung von Handlungen anzuleiten. Dafür muss bei der Einschätzung des Hilfebedarfs (und der Pflegestufe) mehr Zeit berücksichtigt werden als für eine Vollübernahme. Wenn Sie während der gesamten Durchführung einer Handlung anwesend sein müssen, weisen Sie den Gutachter darauf hin. </p>","created":"2014-05-21 11:47:51","modified":"2014-06-01 14:57:59"},{"id":"22","help_topic_id":"8","name":"Vorbereitung auf die MDK-Begutachtung","content":"<h1>Vobereitung auf die <span class=\"caps\">MDK</span>-Begutachtung</h1>\n\n<p>Je besser sich der Antragsteller auf den Besuch des Gutachters vorbereitet, umso größer ist die Chance auf ein Gutachten, das dem tatsächlichen Pflegebedarf des Betroffenen entspricht. Denn der Medizinische Dienst bekommt bei seinem Termin nur einen kurzen Einblick in die Lebens- und Pflegesituation einer Person. <br />\nWas sollten Sie beachten:</p>\n\n<ul>\n\t<li>Halten Sie über eine Spanne von mindestens 7 Tagen in dem Pflegetagebuch die Zeiten fest, die für Katalog-Verrichtungen (Körperpflege, Ernährung, Mobilität, Hauswirtschaft) benötigt werden und schicken Sie diese Dokumentation bereits im Vorhinein der Begutachtung an den <span class=\"caps\">MDK</span>.</li>\n</ul>\n\n<ul>\n\t<li>Besorgen Sie sich alle Unterlagen und Berichte von Fachleuten, die die Krankengeschichte belegen und einen entsprechenden Pflegeaufwand erklären können, zum Beispiel von Hausarzt, Facharzt, Pflegedienst, Therapeuten, Krankenkasse!</li>\n</ul>\n\n<ul>\n\t<li>Pflegepersonen sollten beim Begutachtungstermin anwesend sein.</li>\n</ul>\n\n<ul>\n\t<li>Ist bereits ein ambulanter Pflegedienst tätig, so sollte ein Mitarbeiter des Dienstes bei dem Termin dabei sein.</li>\n</ul>\n\n<ul>\n\t<li>Falsche Antworten, zum Beispiel aus Scham (&#8220;diese Hilfe habe ich nicht nötig&#8221;) oder zu optimistische Antworten (&#8220;das schaffe ich schon&#8221;) können dazu führen, dass keine oder zu wenig Leistungen gewährt werden. Besprechen Sie mir Ihrem Angehörigen im Vorhinein, dass er sich so verhält wie immer und in der Begutachtung keine besondere Leistung zeigen muss.</li>\n</ul>\n\n<ul>\n\t<li>Übrigens: Auf Wunsch muss der Gutachter den Pflegebedürftigen auch alleine anhören.</li>\n</ul>","created":"2014-05-21 11:49:40","modified":"2014-06-15 20:24:21"},{"id":"23","help_topic_id":"8","name":"Der Einstufungsbescheid der Pflegestufe","content":"<h1>Der Einstufungsbescheid der Pflegestufe</h1>\n\n<p>Nach dem Hausbesuch teilt der Gutachter der Pflegeversicherung mit, welche Pflegeeinstufung er empfiehlt. Normalerweise übernehmen die Pflegekassen diese Einschätzung der Pflegestufe. Der Einstufungsbescheid über die Pflegebedürftigkeit und Pflegestufe wird von der Pflegeversicherung erlassen. </p>\n\n<p>Der schriftliche Bescheid sollte Ihnen nach spätestens fünf Wochen vorliegen (gemäß § 18 Abs. 3 <span class=\"caps\">SGB</span> XI). Hat der Gutachter eine Pflegebedürftigkeit festgestellt, werden die Pflegeleistungen ab dem Datum der Antragstellung gezahlt. Bei dem Einstufungsbescheid handelt es sich um einen Verwaltungsakt. Deswegen muss mit dem Bescheid auch eine sogenannte Rechtsmittelbelehrung erfolgen. Das bedeutet, dass Ihnen die Möglichkeit beschrieben wird, innerhalb eines Monats gegen die Entscheidung Widerspruch einzulegen. Wenn diese Rechtsmittelbelehrung fehlt, verlängert sich die Frist auf ein Jahr. </p>\n\n<p>Zusammen mit dem Einstufungsbescheid erhalten Sie weitere Informationen zur Unterstützungsmöglichkeiten für Ihren Angehörigen. So können Sie bspw. Anleitungen und Schulungen zu Pflegethemen über die Pflegekasse (gemäß § 45c <span class=\"caps\">SBG</span> XI)oder sogar individuelle Beratung zur Pflegesituation Ihres Angehörigen über Pflegeberater der Pflegekasse oder den Pflegestützpunkt in Ihrer Region (gemäß § 7 <span class=\"caps\">SGB</span> XI)erhalten.</p>","created":"2014-05-21 11:57:08","modified":"2014-06-01 14:59:09"}]}]},{"HelpChapter":{"id":"3","name":"Auswertung und Export","created":"2014-05-08 14:09:31","modified":"2014-05-20 17:06:47"},"HelpTopic":[{"id":"11","help_chapter_id":"3","name":"Verrichtungen auswerten","created":"2014-05-21 14:32:54","modified":"2014-05-21 14:48:45","HelpChapter":{"id":"3","name":"Auswertung und Export","created":"2014-05-08 14:09:31","modified":"2014-05-20 17:06:47"},"HelpArticle":[{"id":"28","help_topic_id":"11","name":"Auswertung","content":"<h1>Auswertung </h1>\n\n<p>Im Menü &#8220;Auswerten&#8221; finden sich alle bisher dokumentierten Verrichtungen aufgelistet nach Hauptkategorie (Ernährung, Körperpflege, Mobilität und Hauswirtschaftliche Versorgung) und Unterkategorien farblich entsprechend angestimmt aufgelistet wieder.</p>\n\n<p>Die Verrichtungen werden jeweils mit der Angabe der Dauer der Durchführung aufsummiert über den angegebenen Zeitraum dargestellt.</p>\n\n<p>Folgende Funktionalitäten stehen hier zur Verfügung:<br />\n<ul>\n\t<li>per wischen (swipen) oder Verwendung der Pfeile kann in der Listenansicht vor- oder zurück geblättert werden</li><br />\n</ul></p>\n\n<ul>\n\t<li>per Klick auf den Kalender oder Verwendung der Pfeile für &#8220;vor&#8221; und &#8220;zurück&#8221; kann ein Starttag individuell ausgewählt werden. Hier können auch alle anderen Wochentage als der Montag als Startag gewählt werden. Vom ausgewählten Starttag an werden automatisch 7 Tage in Folge für die Auswertung herangezogen. Daraufhin aktualisiert sich die Verrichtungsliste anhand des neu gewählten Zeitraums.<br />\n<img alt=\"Kalender\" src=\"img/Icon_Kalender.png\" title=\"Kalender\" /><br />\n<img alt=\"Vor- und Zurück-Blättern\" src=\"img/Icon_Pfeile.png\" title=\"Vor- und Zurück-Blättern\" /></li>\n</ul>\n\n<ul>\n\t<li>Einzelverrichtungen können aus dieser Ansicht nicht mehr verändert werden. Dies kann unter &#8220;Bearbeiten&#8221; vorgenommen werden.</li>\n</ul>\n\n<ul>\n\t<li>Falls Sie zu einer oder mehrerer Verrichtungen unvollständige Angaben gemacht haben (z.B. nur die Verrichtungen und die Dauer, jedoch nicht die Hilfeleitung und die Anzahl der beteiligten Helfer), wird Ihnen dies mit einem roten Hinweistext im oberen Bereich der Auswertungsliste angezeigt. Sie können nun im Menü auf &#8220;Bearbeiten&#8221; gehen und dort die Verrichtungen, die mit einem orangenen Ausrufezeichen markiert sind, öffnen, die Details nachtragen und speichern. <br />\n<img alt=\"Daten sind unvollständig\" src=\"img/Icon_Ausrufezeichen.png\" title=\"Daten sind unvollständig\" /></li>\n</ul>\n\n<p>So gelangen Sie zu einer korrekten und vollständigen Dokumentation der pflegerischen Verrichtungen, die eine optimale Voraussetzung für die Einschätzung einer Pflegestufe bietet.</p>","created":"2014-05-21 14:45:10","modified":"2014-06-17 14:34:06"},{"id":"41","help_topic_id":"11","name":"Pflegestufe einschätzen","content":"<h1>Pflegestufe einschätzen</h1>\n\n<p>Zur Einschätzung der Pflegestufe klicken Sie in der Ansicht &#8220;Auswerten&#8221; auf den Knopf &#8220;Einschätzung Pflegestufe&#8221;.<br />\n<img alt=\"Enschätzung\" src=\"img/Icon_Einschaetzung_Pflegestufe.png\" title=\"Enschätzung\" /></p>\n\n<p>Daraufhin sehen Sie einen Text, der Ihnen mitteilt welche Pflegestufe Ihr zu pflegender Angehöriger laut den Angaben im interaktiven Pflegetagebuch nach zugeordnet werden kann. Hier gibt es folgenden Möglichkeiten der Zuordnung:</p>\n\n<ul>\n\t<li>keine Pflegestufe</li>\n\t<li>Pflegestufe 1</li>\n\t<li>Pflegestufe 2</li>\n\t<li>Pflegestufe 3</li>\n</ul>\n\n<p>Unter dem Text finden Sie eine Übersicht der erfüllten bzw. nicht erfüllten Vorgaben zur Erreichung jeweiligen Pflegestufe. Dabei sind die aufgrund Ihrer Dokumentation erreichten Vorgaben als &#8220;erfüllt&#8221; mit grüner Farbe hinerlegt; die nicht erreichten Vorgaben werden mit orangener Farbe als &#8220;nicht erfüllt&#8221; markiert. So können Sie einen Überblick gewinnen, wo Ihr zu pflegender Angehöriger in der Einschätzung einer Pflegestufe zu finden ist.</p>\n\n<p>Folgende weitere Funktionen stehen Ihnen hier zur Verfügung:</p>\n\n<ul>\n\t<li>wischen (swipen) mit dem Finger über den Bildschirm nach rechts oder links zur nächst niedrigeren bzw. höheren Pflegestufe. Hiermit können Sie überblicken welche Vorgaben zu einer höheren Pflegestufe zu erfüllen wären.</li>\n</ul>","created":"2014-06-12 20:57:05","modified":"2014-06-17 13:11:46"}]},{"id":"12","help_chapter_id":"3","name":"Verrichtungen exportieren","created":"2014-05-21 14:46:40","modified":"2014-05-21 14:49:06","HelpChapter":{"id":"3","name":"Auswertung und Export","created":"2014-05-08 14:09:31","modified":"2014-05-20 17:06:47"},"HelpArticle":[{"id":"29","help_topic_id":"12","name":"Export der Auswertungsdatei","content":"<h1>Export der Auswertungsdatei</h1>\n\n<p>Im Menü &#8220;Auswerten&#8221; können Sie per Klick auf &#8220;Export&#8221; die Auswertungsdatei über verschiedene digtale Kanäle, z.B. E-mail (Angebot je nach Typ Ihres smartphones) im pdf-Format versenden.<br />\n<img alt=\"Versenden der Auswertung\" src=\"img/Icon_Export.png\" title=\"Versenden der Auswertung\" /></p>\n\n<p>Sollten Sie bereits eine Pflegestufeneinschätzung per Klick auf &#8220;Einschätzung Pflegestufe&#8221; vorgenommen haben, so kommen Sie per Klick auf den Pfeil &#8220;&gt; Einschätzung Pflegestufe&#8221; zurück in die Liste der Verrichtungen und können von dort den Export vornehmen.<br />\n<img alt=\"Pflegestufe\" src=\"img/Icon_Einschaetzung_Pflegestufe.png\" title=\"Pflegestufe\" /><br />\n<img alt=\"zurückblättern\" src=\"img/Icon_Pfeil_Zurueck.png\" title=\"zurückblättern\" /></p>\n\n<p>Bevor die Exportdatei generiert wird, werden Sie gefragt, ob Sie die Daten aus Ihrem Profil eingeben (Angaben zur pflegebedürftigen Person und zur Pflegetagebuch führenden Person) und somit dem Deckblatt hinzufügen möchten.</p>\n\n<p>Ebenso wird darauf hingewiesen, die Fragen zur Einschätzung der Alltagskompetenz Ihres pflegebedürftigen Angehörigen, zu beantworten. Diese sind die Grundlage für evtl. zusätzliche Betreuungsleistungen, die Ihr Angehöriger aus der Pflegeversicherun erhalten kann.</p>\n\n<h2>Die Exportdatei</h2>\n\n<p>Die Exportdatei beinhaltet die Übersicht der Verrichtungen der einzelnen Tage des Zeitraums, den Sie für die Auswertung ausgewählt haben (immer 7 Tage). Dazu folgt die Auswertung der gesamten Woche mit der Berechnung der benötigten Zeitdauer in den Verrichtungen nach täglichem Druchschnitt und Angabe der Häufigkeit. Diese Angaben werden aufsummiert nach Grundpflege (Ernährung, Körperpflege und Mobilität) und Hauswirtschaftlicher Versorgung. </p>\n\n<p>Sollten Sie sich für die Pflege Ihres Profils bzw. dafür entscheiden haben, persönliche Daten dem Deckblatt hinzufügen zu wollen, so sind diese auf der ersten Seite der Datei zu finden.</p>\n\n<h2>Angaben zur Alltagskompetenz</h2>\n\n<p>Weiterhin wird nach der Übersicht der Verrichtungen nach Tagen und der Wochenübersicht der Fragebogen der Fragen zur Einschätzung der Alltagskompetenz angehängt und Ihre jeweiligen Antworten dort eingetragen. Hier finden Sie im Anschluss einen Orientierungssatz zur Einschätzung ob für Ihren Angehörigen keine, eine erheblich eingeschränkte oder eine in erhöhten Maße eingeschränkte Alltagskompetenz vorzuliegen scheint.</p>\n\n<p>Diese Exportdatei entspricht den Daten des Pflegetagebuchs, die für den Medizinischen Dienst der Krankenkassen notwendig sind um zusammen mit dem Antrag auf Pflegestufe und der persönlichen Begutachtung über eine Pflegestufe Ihres Angehörigen zu entscheiden.</p>","created":"2014-05-21 15:06:30","modified":"2014-06-17 13:13:22"}]}]},{"HelpChapter":{"id":"4","name":"Einstellungen","created":"2014-05-08 14:09:42","modified":"2014-05-20 17:07:21"},"HelpTopic":[{"id":"2","help_chapter_id":"4","name":"Info","created":"2014-05-08 14:58:21","modified":"2014-06-03 12:59:07","HelpChapter":{"id":"4","name":"Einstellungen","created":"2014-05-08 14:09:42","modified":"2014-05-20 17:07:21"},"HelpArticle":[{"id":"18","help_topic_id":"2","name":"Eingeschränkte Alltagskompetenz","content":"<h1>Eingeschränkte Alltagskompetenz </h1>\n\n\n<p>Mit dem 1. Pflegeverstärkungsgesetz (Januar 2015) besteht für alle Pflegebedürftigen die Möglichkeit, zusätzliche Betreuungs- und Entlastungsleistungen in Anspruch zu nehmen. Wird eine eingeschränkte Alltagskompetenz festgestellt, können Leistungen in Höhe von 104 bis 208 Euro im Monat in Anspruch genommen werden. </p>\n\n<p>Die Gutachter beurteilen anhand von 13 festgelegten Kriterien die Schwere der &#8220;Einschränkungen der Alltagskompetenz&#8221;. Werden bei der Begutachtung wenigstens zwei dieser Kriterien erfüllt, davon eines aus einem eingegrenzten Kriterienkatalog, besteht ein Anspruch auf Leistungen der Pflegeversicherung, selbst dann, wenn keine Pflegestufe vorliegt (Pflegestufe 0). </p>\n\n<p>Die Kriterien sind: </p>\n\n<h2>Orientierung</h2>\n\n<p>Orientierung beschreibt das Bescheid wissen über Ort, Zeit, Situation und Person. </p>\n\n<h2>Örtliche Orientierung </h2>\n\n<p>Örtliche Orientierung beinhaltet die Fähigkeit seinen Aufenthaltsort zu kennen und sich im eigenen Bewegungsradius zurecht zu finden. z.B. der Ortsname kann nur mit Mühe genannt werden kann oder die Orientierung in der Wohnung gelingt nicht mehr. </p>\n\n<h2>Zeitliche Orientierung </h2>\n\n<p>Zeitliche Orientierung beinhaltet die Fähigkeit, Tag und Uhrzeit zu kennen und entsprechend den Tagesablauf strukturieren zu können. </p>\n\n<h2>Situative Orientierung </h2>\n\n<p>Situative Orientierung beinhaltet das Verständnis für die derzeitige Lebenslage und die Hintergründe, die zur derzeitigen Situation geführt haben. </p>\n\n<h2>Personelle Orientierung </h2>\n\n<p>Personelle Orientierung beinhaltet das Wissen über die aktuelle persönliche als auch lebensgeschichtliche Situation und die individuelle Beziehung zu den Kontaktpersonen. z.B. ist eine Angabe des eigenen Namens, Geburtstags und Alter nicht möglich. </p>\n\n<h2>Antrieb/Beschäftigung </h2>\n\n<p>Die geistige Fähigkeit, geprägt durch Erlebnisse und Gewohnheiten, seine Zeit sinnvoll einzuteilen, sich entsprechend zu beschäftigen und seine Aktivitäten von sich aus aufzunehmen und an seine körperlichen Fähigkeiten anzupassen. </p>\n\n<h2>Stimmung </h2>\n\n<p>Die Stimmung drückt das Empfinden und die Steuerung von Emotionen wie z. B. Freude, Trauer, Hass aus. </p>\n\n<h2>Gedächtnis </h2>\n\n<p>Die Fähigkeit, Erlebtes und Erlerntes behalten und wiedergeben zu können. Im Langzeitgedächtnis sind z.B. biografische Angaben gespeichert. Das Kurzzeitgedächtnis umfasst die Merkfähigkeit, d. h. die Speicherung neu gelernter Inhalte für einige Minuten. </p>\n\n<h2>Tag-/Nachtrhythmus</h2>\n\n<p>Hierzu gehört die Fähigkeit, einen regelmäßigen und altersentsprechenden Rhythmus sowie die Art und Weise von Wachen, Ruhen und Schlafen zu gestalten und aufrecht zu erhalten, wie z. B. der Umgang mit Schlafstörungen, auch nach nächtlichen Unterbrechungen durch Wasserlassen oder das Einplanen notwendiger Ruhepausen tagsüber. </p>\n\n<h2>Wahrnehmung und Denken </h2>\n\n<p>Hierzu gehört die Fähigkeit, Informationen aus der Umgebung aufnehmen und einordnen zu können, logische Folgerungen zu schließen und begründete Entscheidungen treffen zu können. Dabei spielt das Erkennen von Gefahren und das Einschätzen von Risiken eine wesentliche Rolle. Formale Denkstörungen zeigen sich meistens in der Sprache. Es handelt sich dabei um Veränderungen in der Geschwindigkeit, Kohärenz und Stringenz des Gedankenablaufes. </p>\n\n<h2>Kommunikation und Sprache</h2>\n\n<p>Hierzu gehört die geistige Fähigkeit zum sinnhaften, interpersonellen Austausch unter Berücksichtigung kultureller Gegebenheiten. Wesentlich sind das Verstehen der Bezugsperson (hören, sehen, lesen) und Wünsche und Gedanken äußern zu können (Sprache, Schrift, Gestik, Mimik und Ausdruck von Gefühlen). </p>\n\n<h2>Situatives Anpassen </h2>\n\n<p>Dies beinhaltet die Fähigkeit, sich auf wechselnde Anforderungen/Situationen einzustellen, wie z. B. Besuch/Alleinsein/Wechsel der Bezugsperson, Änderung des üblichen Tagesablaufes, sich in gegebenen Situationen adäquat verhalten zu können, wie z. B. die Fähigkeit, Wünsche zu äußern, bei Gefahr Hilfe einzuholen, aber auch Ablehnungen deutlich zu machen. </p>\n\n<h2>Soziale Bereiche des Lebens wahrnehmen </h2>\n\n<p>Hierzu gehört die Fähigkeit, selbstständig soziale Kontakte aufnehmen und aufrecht erhalten zu können und sein Leben verantwortlich innerhalb des gesellschaftlichen Beziehungsgeflechtes zu gestalten. Das bedeutet u. a., Kontakte zu Familie, Nachbarn und Freunden pflegen zu können oder die Geschäftsfähigkeit bezüglich finanzieller und behördlicher Angelegenheiten zu erhalten.</p>","created":"2014-05-21 11:37:59","modified":"2014-12-30 10:36:41"},{"id":"30","help_topic_id":"2","name":"Einstellungen im Infomenü","content":"<h1>Die Einstellungen im Infomenü</h1>\n\n<p>Unter dem Punkt &#8220;Info&#8221; können persönliche Angaben als auch Einstellungen des Nutzerkontos vorgenommen werden. Außerdem kann von hier aus die Hilfe genutzt werden und es sind Informationen über die App erhältlich.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /></p>","created":"2014-06-01 16:33:50","modified":"2014-06-16 14:58:02"},{"id":"31","help_topic_id":"2","name":"Profil","content":"<h1>Profil</h1>\n\n<p>Im Infomenü werden sowohl persönliche Angben als auch die Angaben zur eingeschränkten Alltagskompetenz verwaltet.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /></p>\n\n<p>Unter &#8220;Profil&#8221; werden persönliche Daten zur pflegebedürftigen Person und zur Tagebuch führenden Person verwaltet. Diese Angaben werden entweder bei Registrierung in der App bereits erfragt und eingegeben oder aber spätestens bevor eine Datei mit Verrichtungen exportiert wird. Die persönlichen Angaben sowie die Angaben zur eingeschränkten Alltagskompetenz sind Voraussetzung für die Beantragung einer Pflegestufe und müssen daher zur Zuordnung der Antrags auf Pflegestufe angegeben werden.<br />\n<img alt=\"Persönliche Angaben und Einstellungen\" src=\"img/Icon_Profil.png\" title=\"Persönliche Angaben und Einstellungen\" /></p>","created":"2014-06-01 16:38:57","modified":"2014-06-16 15:05:34"},{"id":"34","help_topic_id":"2","name":"Nutzerkonto","content":"<h1>Nutzerkonto</h1>\n\n<p>Im Infomenü ist die Verwaltung des Nutzerkontos zu finden. Hier ist ales erstes die E-mail-Adresse, mit der Sie sich registriert haben, platziert. Darunter befinden sich Nutzer &#8211; und Sicherheitseinstellungen.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /></p>\n\n<h2>Nutzerwechsel</h2>\n\n<p>Über den Knopf &#8220;Abmelden&#8221; können Sie den derzeitigen Nutzer der App abmelden und einen neuen Nutzer anmelden oder registrieren. Sie gelangen dazu auf die Login- bzw. Registrierungsseite der App.<br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></p>\n\n<p>Über den Knopf &#8220;Passwort ändern&#8221; können Sie das für den derzeitigen Nutzer verwendete Passwort ändern und erneut abspeichern. <br />\n<img alt=\"Passwort ändern\" src=\"img/Icon_Passwort_aendern.png\" title=\"Passwort ändern\" /></p>\n\n<p>Über den Knopf &#8220;Konto löschen&#8221; können Sie Ihr Nutzerkonto für die App komplett löschen. Bevor dies geschieht werden Sie erneut gefragt ob Sie Ihr Konto wirklich löschen wollen. Wenn Sie dies möchten, können Sie &#8220;Ja&#8221; klicken und müssen sich damit bei erneuter Nutzung der App neu registrieren. Wenn Sie &#8220;nein&#8221; klicken, kehren Sie in der Ansicht zurück auf Ihr Nutzerkonto.<br />\n<img alt=\"Benutzerkonto löschen\" src=\"img/Icon_Konto_loeschen.png\" title=\"Benutzerkonto löschen\" /></p>","created":"2014-06-01 16:59:21","modified":"2014-06-16 15:01:50"},{"id":"35","help_topic_id":"2","name":"Hilfe","content":"<h1>Hilfe</h1>\n\n<p>Über die &#8220;Hilfe&#8221; im Infomenü stehen Ihnen Artikel zur Nutzung und Einstellungen der App als auch zu Informationen zum Pflegetagebuch, der Beantragung einer Pflegestufe etc. zur Verfügung.</p>\n\n<p>Einzelne Hilfeartikel sind ebenso von den jeweiligen Verrichtungen in den Menüs &#8220;Erfassen&#8221; und &#8220;Bearbeiten&#8221; bei Ihrer Dokumentation zugänglich.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Hilfe\" src=\"img/Icon_Hilfe.png\" title=\"Hilfe\" /></p>","created":"2014-06-01 17:02:55","modified":"2014-06-16 15:03:37"},{"id":"36","help_topic_id":"2","name":"Über diese App","content":"<h1>Über diese App</h1>\n\n<p>Im Infomenü im Punkt &#8220;Über diese App&#8221; sind Informationen zur App interaktives Pflegetagebuch zu finden. Hier ist einerseits die enstsprechende Versionsnummer der App, die auf Ihrem Smartphone installiert ist, aufgezeigt. Andererseits finden Sie Informationen zu der Institution, die die Entwicklung dieser App beauftragt hat und zu derjenigen, die sie entwickelt hat und eine E-mail-Adresse, an die Sie sich bei Problemen zur App wenden können.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Informationen über diese App\" src=\"img/Icon_Ueber_diese_App.png\" title=\"Informationen über diese App\" /></p>","created":"2014-06-01 17:06:49","modified":"2014-08-27 08:42:07"}]},{"id":"14","help_chapter_id":"4","name":"Nutzerkonto","created":"2014-06-03 12:58:23","modified":"2014-06-12 21:24:16","HelpChapter":{"id":"4","name":"Einstellungen","created":"2014-05-08 14:09:42","modified":"2014-05-20 17:07:21"},"HelpArticle":[{"id":"1","help_topic_id":"14","name":"Passwort vergessen","content":"<h1>Passwort vergessen</h1>\n\n<p>Haben Sie die App komplett neu auf Ihrem smartphone installiert oder möchten Sie sich auf einem anderen smartphone in die App einloggen und haben Ihr Passwort vergessen, so können Sie bei Start der App in der Login-Maske Ihre E-mail-Adresse, mit der Sie sich registriert haben, eingeben. Danach klicken Sie auf den Link &#8220;Passwort vergessen&#8221; unterhalb des Feldes für das Passwort und fordern damit eine neues Passwort per E-mail an.<br />\n<img alt=\"Passwort vergessen\" src=\"img/Icon_Passwort_vergessen.png\" title=\"Passwort vergessen\" /></p>\n\n<p>Der Satz &#8220;Eine Email mit Ihrem neuen Passwort wurde an Ihre Emailadresse versandt.&#8221; erscheint.</p>\n\n<p>Kurze Zeit später bekommen Sie eine E-mail mit neuem Passwort an die von Ihnen angegebene E-mail-Adresse. Mit dem neuen Passwort können Sie sich wieder in die App einloggen.</p>\n\n<blockquote>\n\t<p>Sie können das neue Passwort im Infomenü im Bereich &#8220;Nutzerkonto&#8221; verändern.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /></p>\n</blockquote>","created":"2014-05-13 16:23:55","modified":"2014-06-17 13:07:43"},{"id":"42","help_topic_id":"14","name":"Anlegen eines Nutzers","content":"<h1>Anlegen eines Nutzers</h1>\n\n<ol>\n\t<li>Wenn Sie die App öffnen können Sie dort direkt einen neuen Nutzer registrieren, indem Sie auf den Knopf &#8220;Registrieren&#8221; klicken und dann einen neuen Nutzer mit Email-Adresse und Passwort anlegen.<br />\n<img alt=\"Nutzer registrieren\" src=\"img/Icon_Registrieren.png\" title=\"Nutzer registrieren\" /></li>\n</ol>\n\n<ol>\n\t<li>Weiterhin können Sie im Infomenü in der Verwaltung unter &#8220;Nutzerkonto&#8221; den derzeitigen Nutzer abmelden, indem Sie auf &#8220;Abmelden&#8221; klicken. Von dort aus gelangen Sie direkt zur Login (Registrierungs) Seite und können dort einen neuen Nutzer anlegen.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></li>\n</ol>","created":"2014-06-12 21:20:42","modified":"2014-06-16 15:09:16"},{"id":"44","help_topic_id":"14","name":"Nutzerwechsel","content":"<h1>Nutzerwechsel</h1>\n\n<p>Im Infomenü unter &#8220;Nutzerkonto&#8221; können Sie per Klick auf &#8220;Abmelden&#8221; den Nutzer wechseln. Sie gelangen von hier zur Login (Registrierungs) Seite und können sich dort per Email-Adresse und Passwort einen anderen Nutzers anmelden oder einen neuen Nutzer registrieren.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzer abmelden\" src=\"img/Icon_Abmelden.png\" title=\"Nutzer abmelden\" /></p>","created":"2014-06-12 21:27:08","modified":"2014-06-16 15:11:12"},{"id":"45","help_topic_id":"14","name":"Passwort ändern","content":"<h1>Passwort ändern</h1>\n\n<p>Im Infomenü in der Ansicht &#8220;Profil&#8221; können Sie per Klick auf &#8220;Passwort ändern&#8221; das bisherige Passwort in ein anderen verändern und speichern.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Profil\" src=\"img/Icon_Profil.png\" title=\"Profil\" /><br />\n<img alt=\"Passwort ändern\" src=\"img/Icon_Passwort_aendern.png\" title=\"Passwort ändern\" /></p>","created":"2014-06-12 21:29:23","modified":"2014-06-16 15:12:40"},{"id":"46","help_topic_id":"14","name":"Konto löschen","content":"<h1>Konto löschen</h1>\n\n<p>Im Infomenü in der Ansicht &#8220;Nutzerkonto&#8221; können Sie per Klick auf &#8220;Konto löschen&#8221; können Sie Ihr Nutzerkonto für die App interaktives Pflegetagebuch löschen. Wenn Sie hier auf &#8220;Ja&#8221; klicken erscheint die Frage: Wollen Sie wirklich Ihre Daten löschen? &#8211; Sie können den Löschvorgang hier abbrechen oder weiterführen. Wenn Sie &#8220;Ja&#8221; klicken, so werden Ihre Email.Adresse und das Passwort gelöscht und Sie müssen sich erneut mit einer Emai-Adresse und Passwort auf der Login (Registrierungs) Seite registrieren.<br />\n<img alt=\"Informationen und Einstellungen\" src=\"img/Icon_Info.png\" title=\"Informationen und Einstellungen\" /><br />\n<img alt=\"Nutzerkonto\" src=\"img/Icon_Nutzerkonto.png\" title=\"Nutzerkonto\" /><br />\n<img alt=\"Nutzerkonto löschen\" src=\"img/Icon_Konto_loeschen.png\" title=\"Nutzerkonto löschen\" /></p>","created":"2014-06-12 21:32:42","modified":"2014-06-16 15:14:20"}]}]}],"_metadata":{"descriptor":"Pflegetagebuch App API","api_version":"1","request_id":"dataGetHelpFull","status":"OK"}};
  }
  
  /**
   * Module exports
   */

  return help;

  /**
   * Module function
   */

  function help() {
    this.defaultAttrs({

    });

    this.showHelp = function(){
    	
    	if (localStorage.getItem('newDataVersion')){
    		$('#special-controls .overlay').show();
    		$('#special-controls .popup-update-data-version').show().addClass('help');
    	} else {
    		this.$node.find('#help-viewer').hide();
    		this.$node.find('.topics-wrapper.swiper-container').hide();
    		this.$node.find('.inner > header .ui-icon-back').css('visibility', 'hidden');
    		this.$node.find('#chapters').show();
    		this.$node.show();
    		
    		var $boxesHelper = this.$node.find('#chapters .box');
    		$boxesHelper.height($boxesHelper.first().width());
    	}
    }
    
    this.handleGetHelpFullSuccess = function(evt, data){
    	
    	localStorage.setItem('helpFull', JSON.stringify(data));
    	
    	this.$chapterTemplate = this.$node.find('.chapter.template').clone();
    	
		var thisComponent = this;
		
    	for (var i = 0; i < data.helpChapters.length; i++){
    		var $chapter = this.$chapterTemplate.clone();
    		$chapter.attr('id', 'chapter-' + data.helpChapters[i].HelpChapter.id);
    		$chapter.find('.title').html(data.helpChapters[i].HelpChapter.name);
    		$chapter.removeClass('template');
    		$chapter.bind('touchstart', function(){
    			
    			var $this = $(this);
    			$this.addClass('active');
    			
    			$this.unbind('touchmove').bind('touchmove', function(){
    				$this.removeClass('active');
    				$this.unbind('touchend');
    			});
    			
    			$this.unbind('touchend').bind('touchend', function(){
    				$this.removeClass('active');
    				thisComponent.handleGoToTopic('default', {
        				target: this.id
        			});
    			});
    			
    			
    		});
    		
    		/*var iconWrappers = $category.find('.icon');
    		
    		for (var j = 0; j < accTypes.accomplishmentCategories[i].AccomplishmentSubcategory.length; j++){
    			var iconHelper = accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].icon_char
    			if (iconHelper){
    				$(iconWrappers[j]).html('&#' + iconHelper + ';').addClass('active');
    			}	
    		}*/
    		this.$node.find('#chapters').append($chapter);
    	}
    	this.$node.find('.chapter.template').remove();
    	
    	// ------------------------------------------------------------------------------------------------
    	
    	this.$topicsWrapperTemplate = this.$node.find('.topics.template').clone();
		
    	for (var i = 0; i < data.helpChapters.length; i++){
    		var $topicsWrapper = this.$topicsWrapperTemplate.clone();
    		$topicsWrapper.attr('id', 'chapter-' + data.helpChapters[i].HelpChapter.id + '-topics');
    		$topicsWrapper.removeClass('template');
    		
    		$topicsWrapper.find('header .title').text(data.helpChapters[i].HelpChapter.name);		
    		this.$node.find('.swiper-wrapper').append($topicsWrapper);
    	}
    	this.$node.find('.topics.template').remove();
    	
    	// ------------------------------------------------------------------------------------------------
    	
    	this.$topicTemplate = this.$node.find('.topic.template').first().clone();
		
    	for (var i = 0; i < data.helpChapters.length; i++){
    		for (var j = 0; j < data.helpChapters[i].HelpTopic.length; j++){
    			var $topic = this.$topicTemplate.clone();
    			$topic.attr('id', 'topic-' + data.helpChapters[i].HelpTopic[j].id);
    			$topic.removeClass('template');
    			$topic.find('header').attr('data-chapter', data.helpChapters[i].HelpTopic.id);
    			$topic.find('header .title').text(data.helpChapters[i].HelpTopic[j].name);
    			
    			if (data.helpChapters[i].HelpTopic[j].HelpArticle.length > 1){
    				$topic.find('.article .title').text(data.helpChapters[i].HelpTopic[j].HelpArticle[0].name);
    				$topic.find('.article').attr('data-article-id', data.helpChapters[i].HelpTopic[j].HelpArticle[0].id).attr('data-Chapter', data.helpChapters[i].HelpChapter.id);
	    			for (var k = 1; k < data.helpChapters[i].HelpTopic[j].HelpArticle.length; k ++){
	    				var articleHelper = $topic.find('.article').first().clone();
	    				articleHelper.attr('data-article-id', data.helpChapters[i].HelpTopic[j].HelpArticle[k].id);
	    				articleHelper.attr('data-category', data.helpChapters[i].HelpTopic.id);
	    				articleHelper.find('.title').text(data.helpChapters[i].HelpTopic[j].HelpArticle[k].name);
	    				$topic.find('.article-wrapper').append(articleHelper);
	    			}
    			} else {
    				if (data.helpChapters[i].HelpTopic[j].HelpArticle.length === 1){
    					$topic.find('.article-wrapper').remove();
        				$topic.addClass('single-type');
        				$topic.attr('data-article-id', data.helpChapters[i].HelpTopic[j].HelpArticle[0].id);
    				}
    				
    			}
    			this.$node.find('#chapter-' + (data.helpChapters[i].HelpChapter.id) + '-topics').append($topic);
    		}
    	}
    	this.$node.find('.topic.template').remove();
    }
    
	this.handleGetHelpFullFailed = function(){
		this.handleGetHelpFullSuccess('fallback', JSON.parse(localStorage.getItem('helpFull')));
	}
    
    this.handleGoToTopic = function(event, data){
    	$('#chapters').hide();
    	this.$node.find('.topics-wrapper').show();
    	
    	var initialSlideHelper = this.$node.find('.topics-wrapper .topics');
    	
    	for (var i = 0; i < initialSlideHelper.length; i++){
    		
    		if (initialSlideHelper[i].id === data.target + '-topics'){
    			initialSlideHelper = i;
    			break;
    		}
    	}
    	
    	var thisComponent = this;
		this.swiper = new Swiper('.topics-wrapper.swiper-container',{
    	    //Your options here:
    	    mode:'horizontal',
    	    loop: true,
    	    initialSlide: data.target.split('-')[1]-1,
    	    onTouchMove: function(){
    	    	thisComponent.swiperMoved = true;
    	    }
    	});
    	
		
    	var thisComponent = this;
    	this.$node.find('.inner > header .ui-icon-back').css('visibility', 'visible');
    	this.$node.find('.inner > header').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.$node.find('.inner > header .ui-icon-back').css('visibility', 'hidden');
    			thisComponent.$node.find('#chapters').show();
    			thisComponent.$node.find('.topics-wrapper').hide();
    			
    			thisComponent.$node.find('.topic .article-wrapper').height(0);
    			
    	    	if (thisComponent.swiper.destroy){
    				thisComponent.swiper.destroy();
    				$('#help .swiper-slide-duplicate').remove();
    				$('#help .swiper-wrapper').attr('style', '');
    				$('#help .topics').attr('style', '');
    			}
    			
    		});
		});
    	
    	this.$node.find('.topic header').unbind('touchstart').bind('touchstart', function(evt){
    		
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			if ($this.parent().hasClass('single-type')){    				
    				thisComponent.handleGoToArticle('default', {
						articleId: $this.parent().attr('data-article-id'),
						topicId: $this.parent().parent().attr('id').split('-')[1],
	    				title: $this.find('.title').text()
					});
				} else {
					var $articleHelper = $this.parent().find('.article-wrapper');
					if ($articleHelper.hasClass('active')){
						$articleHelper.removeClass('active');
						$articleHelper.attr('style', '');
					} else {
						thisComponent.$node.find('.article-wrapper').removeClass('active').attr('style', '');
						$articleHelper.addClass('active');
						$articleHelper.height($this.parent().find('.article-wrapper .article').length * ($('#help .article-wrapper .title').first().height() + 2));
					}
				}
    		});
		});
    	
    	this.$node.find('.article').bind('touchstart', function(evt){
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			
    			thisComponent.handleGoToArticle('default', {
					articleId: $this.attr('data-article-id'),
					topicId:$this.attr('data-chapter'),
    				title: $this.find('.title').text()
				});
    		});
    	});
    	
    }

    this.handleGoToArticle = function(evt, data){
    	this.$node.find('#chapters').hide();
		this.$node.find('.topics-wrapper').hide();
		
		this.$node.find('.topic .article-wrapper').height(0);
		
    	if (this.swiper.destroy){
			this.swiper.destroy();
			$('#help .swiper-slide-duplicate').remove();
			$('#help .swiper-wrapper').attr('style', '');
			$('#help .topics').attr('style', '');
		}
    	
    	this.$node.find('#help-viewer').html(helpArticleList.helpArticles[data.articleId].HelpArticle.content).show().scrollTop(0);
    	
    	var imgTags = document.querySelectorAll('#help-viewer img');
    	
    	$(imgTags).bind('error', function(evt){
    		if (this.src.split(':')[0] !== 'https'){
    			var srcString = this.src.split('/');
    			this.src= 'https://pflege-tagebuch.de/img/apphelp/' + srcString[srcString.length-1];
    		}
    	});
    	
    	for (var i = 0; i < imgTags.length; i++){
    		console.log(imgTags[i].src);
    		var divHelper = document.createElement('div');
    		divHelper.className = 'img-label';
    		divHelper.innerHTML = imgTags[i].title;
    		$(divHelper).insertAfter(imgTags[i]);
    	}
    	
    	
    	
    	var thisComponent = this;
    	this.$node.find('.inner > header .ui-icon-back').css('visibility', 'visible');
    	this.$node.find('.inner > header').unbind('touchstart').bind('touchstart', function(){
    		var $this = $(this);
    		
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			if (data.topicId){
    				thisComponent.handleGoToTopic('backFromHelpViewer', {
    					target: 'chapter-' + data.topicId
    				});
    				thisComponent.$node.find('#help-viewer').html('').hide();
    			} else {
    				thisComponent.$node.find('#chapters').show();
        			thisComponent.$node.find('.topics-wrapper').hide();
        			thisComponent.$node.find('#help-viewer').html('').hide();
        			thisComponent.$node.find('.topic .article-wrapper').height(0);
    			}
    		});
		});  	
    }
	
    this.handleGetArticlesListSuccess = function(evt, data){
    	if (data){
    		localStorage.setItem('helpArticleList', JSON.stringify(data));
    		helpArticleList = data;
    	}
    }
    
	this.handleGetArticlesListFailed = function(evt, data){
		if (localStorage.getItem('helpArticleList')){
			this.handleGetArticlesListSuccess('fallback', JSON.parse(localStorage.getItem('helpArticleList')));
		} else {
			this.handleGetArticlesListSuccess('fallback');
		}
	}
    
    this.after('initialize', function () {
    	
    	this.on('dataHandleGetHelpFullSuccess', this.handleGetHelpFullSuccess);
    	this.on('dataHandleGetHelpFullFailed', this.handleGetHelpFullFailed);
    	
    	this.on('dataHandleGetArticlesListSuccess', this.handleGetArticlesListSuccess);
    	this.on('dataHandleGetArticlesListFailed', this.handleGetArticlesListFailed);
    	
    	var thisComponent = this;
    	$('#extra-flyout .help').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(evt){
    			evt.stopPropagation();
    			$this.removeClass('active');
    			
    			thisComponent.showHelp();
    			$('#extra-flyout').css('right', '-80%');
    			$('#special-controls .overlay-light').hide();
    		});
    	});
    	
    	this.$node.find('.js-btn-close').bind('touchstart', function(){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.$node.hide();
    		});
    	});
    });
  }

}());